import zipfile
import xml.dom.minidom
import xml.sax
from xml.dom.minidom import Document
import string
from xml.sax import saxutils
from xml.dom.ext.reader import Sax2
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump
from common import FakeRequest, FakeUpload
from xml.dom import implementation
from xml.dom import EMPTY_NAMESPACE, XML_NAMESPACE
from xml.dom.ext import PrettyPrint
from Products.ZWiki.ZWikiPage import ZWikiPage
from types import UnicodeType
import re


class User_export:
    def __init__(self):
	self.binarydata = DataTable()
	self.sisegrupid = []
	doctype = implementation.createDocumentType("enterprise", "http://www.htk.tpu.ee/%7Evahur/ims_epv1p1.dtd", "http://www.htk.tpu.ee/%7Evahur/ims_epv1p1.dtd")
	self.user = implementation.createDocument(EMPTY_NAMESPACE, "enterprise", doctype)
	self.userelem = self.user.documentElement
	prop = self.user.createElement('properties')
	self.userelem.appendChild(prop)
	source = self.user.createElement('datasource')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	prop.appendChild(source)
	datetime = self.user.createElement('datetime')
	datetime_data = self.user.createTextNode('kuupaev')
	datetime.appendChild(datetime_data)
	prop.appendChild(datetime)

    def kirjutaKasutaja(self,kasutaja,kursus=''):
	person = self.user.createElement('person')
	self.userelem.appendChild(person)

	sourcedid = self.user.createElement('sourcedid')
	person.appendChild(sourcedid)
	source = self.user.createElement('source')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	sourcedid.appendChild(source)
	id = self.user.createElement('id')
	id_data = self.user.createTextNode(kasutaja.get_uname())
	id.appendChild(id_data)
	sourcedid.appendChild(id)
	
	userid = self.user.createElement('userid')
	try:
		userid.setAttribute('password',kasutaja.getPassword())
	except:
		userid.setAttribute('password','nipitiri')
	userid_name = self.user.createTextNode(kasutaja.get_uname())
	userid.appendChild(userid_name)
	person.appendChild(userid)

	name = self.user.createElement('name')
	person.appendChild(name)
	fn = self.user.createElement('fn')
	fn_data = self.user.createTextNode(kasutaja.get_first_name()+' '+kasutaja.get_last_name())
	fn.appendChild(fn_data)
	name.appendChild(fn)
	n = self.user.createElement('n')
	name.appendChild(n)
	family = self.user.createElement('family')
	family_data = self.user.createTextNode(kasutaja.get_last_name())
	family.appendChild(family_data)
	n.appendChild(family)
	given = self.user.createElement('given')
	given_data = self.user.createTextNode(kasutaja.get_first_name())
	given.appendChild(given_data)
	n.appendChild(given)
	partname = self.user.createElement('partname')
	partname.setAttribute('partnametype','First')
	partname.setAttribute('lang',kasutaja.get_language())
	partname_data = self.user.createTextNode(kasutaja.get_first_name())
	partname.appendChild(partname_data)
	n.appendChild(partname)

	demogr = self.user.createElement('demographics')
	email = self.user.createElement('email')
	email_data = self.user.createTextNode(kasutaja.get_email())
	email.appendChild(email_data)
	person.appendChild(email)

	url = self.user.createElement('url')
	url_data = self.user.createTextNode(kasutaja.get_homepage())
	url.appendChild(url_data)
	person.appendChild(url)
	tel_t = self.user.createElement('tel')
	tel_t.setAttribute('teltype','Voice')
	tel_t_data = self.user.createTextNode(kasutaja.get_phone())
	tel_t.appendChild(tel_t_data)
	person.appendChild(tel_t)
	tel_gsm = self.user.createElement('tel')
	tel_gsm.setAttribute('teltype','Mobile')
	tel_gsm_data = self.user.createTextNode(kasutaja.get_gsm())
	tel_gsm.appendChild(tel_gsm_data)
	person.appendChild(tel_gsm)

	adr = self.user.createElement('adr')
	person.appendChild(adr)
	extadd = self.user.createElement('extadd')
	extadd_data = self.user.createTextNode(kasutaja.get_address2())
	extadd.appendChild(extadd_data)
	adr.appendChild(extadd)
	street = self.user.createElement('street')
	street_data = self.user.createTextNode(kasutaja.get_address1())
	street.appendChild(street_data)
	adr.appendChild(street)
	locality = self.user.createElement('locality')
	locality_data = self.user.createTextNode(kasutaja.get_city())
	locality.appendChild(locality_data)
	adr.appendChild(locality)
	country = self.user.createElement('country')
	country_data = self.user.createTextNode(kasutaja.get_country())
	country.appendChild(country_data)
	adr.appendChild(country)

	if kasutaja.get_photo():
		photo = self.user.createElement('photo')
		photo.setAttribute('imgtype',kasutaja.get_photo_type())
		person.appendChild(photo)
		extref = self.user.createElement('extref')
		photo_name = self.binarydata.storeData(kasutaja.get_photo(),'user')
		extref_data = self.user.createTextNode(photo_name)
		extref.appendChild(extref_data)
		photo.appendChild(extref)

	systemrole = self.user.createElement('systemrole')
	kas_admin =  kasutaja.getRoles()
	if 'Manager' in kas_admin:
		systemrole.setAttribute('systemroletype','SysAdmin')
	else:
		systemrole.setAttribute('systemroletype','User')
	person.appendChild(systemrole)
	try:
		instrole = self.user.createElement('institutionrole')
		instrole.setAttribute('primaryrole','No')
		instrole.setAttribute('institutionroletype','Learner')
		for abc in kursus.get_local_roles():
			if abc[0]==kasutaja.get_uname() and 'Teacher' in abc[1]:
				instrole.setAttribute('institutionroletype','Instructor')
		person.appendChild(instrole)
	except:
		pass

	extension = self.user.createElement('extension')
	person.appendChild(extension)
	org = self.user.createElement('org')
	extension.appendChild(org)
	orgname = self.user.createElement('orgname')
	orgname_data = self.user.createTextNode(kasutaja.get_organization())
	orgname.appendChild(orgname_data)
	org.appendChild(orgname)

	comment = self.user.createElement('comments')
	comment_data = self.user.createTextNode(kasutaja.get_background())
	comment.appendChild(comment_data)
	extension.appendChild(comment)
	desc = self.user.createElement('description')
	extension.appendChild(desc)
	short = self.user.createElement('short')
	short_data = self.user.createTextNode(kasutaja.get_personal_interests())
	short.appendChild(short_data)
	desc.appendChild(short)
	long = self.user.createElement('long')
	long_data = self.user.createTextNode(kasutaja.get_professional_interests())
	long.appendChild(long_data)
	desc.appendChild(long)
	label = self.user.createElement('label')
	label_data = self.user.createTextNode(kasutaja.get_quote())
	label.appendChild(label_data)
	extension.appendChild(label)

	return "valmis"


    def pakiFaili(self,kursusega,failinimi="userexport.zip"):
        "Pakitakse kasutajad faili"
	if kursusega=="/":
		kursusega = ''
        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        PrettyPrint(self.user,stream=dump)
        zip.writestr(zipfile.ZipInfo(kursusega+"users.xml"),dump.getdata())
        for name in self.binarydata.names:
            zip.writestr(
                zipfile.ZipInfo(kursusega+name),
                str(self.binarydata.getData(name)))
        zip.close()

    def kirjutaKursusGrupina(self,kursus):
	# Kirjutab grupi mis omab kursuse funktsiooni. Kik kes selles grupis on
	# student vi teacher
	krupp = self.user.createElement('group')

	krupp_s = self.user.createElement('sourcedid')
	krupp_source = self.user.createElement('source')
	krupp_source_data = self.user.createTextNode('IVA')
	krupp_source.appendChild(krupp_source_data)
	krupp_s.appendChild(krupp_source)
	krupp_id = self.user.createElement('id')
	krupp_id_data = self.user.createTextNode(kursus.get_name())
	krupp_id.appendChild(krupp_id_data)
	krupp_s.appendChild(krupp_id)
	krupp.appendChild(krupp_s)

	krupp_type = self.user.createElement('grouptype')
	type_value = self.user.createElement('typevalue')
	type_value.setAttribute('level','1')
	krupp_type.appendChild(type_value)
	krupp.appendChild(krupp_type)

	description = self.user.createElement('description')
	desc_short = self.user.createElement('short')
	desc_short_data = self.user.createTextNode(kursus.kysiTekst())
	desc_short.appendChild(desc_short_data)
	description.appendChild(desc_short)
	desc_long = self.user.createElement('long')
	desc_long_data = self.user.createTextNode(kursus.get_methods())
	desc_long.appendChild(desc_long_data)
	description.appendChild(desc_long)
	desc_full = self.user.createElement('full')
	desc_full_data = self.user.createTextNode(kursus.get_description())
	desc_full.appendChild(desc_long_data)
	description.appendChild(desc_full)
	krupp.appendChild(description)

	org = self.user.createElement('org')
	orgname = self.user.createElement('orgname')
	orgname_data = self.user.createTextNode(kursus.get_name())
	orgname.appendChild(orgname_data)
	org.appendChild(orgname)
	orgunit = self.user.createElement('orgunit')
	orgunit_data = self.user.createTextNode(kursus.get_organisation())
	orgunit.appendChild(orgunit_data)
	org.appendChild(orgunit)
	krupp.appendChild(org)

	enrollcontrol = self.user.createElement('enrollcontrol')
	enroll_accept = self.user.createElement('enrollaccept')
	enroll_allowed = self.user.createElement('enrollallowed')
	if str(kursus.kysiStaatus()) == str('0') or int(kursus.kysiStaatus())>1:
		enroll_accept_data = self.user.createTextNode('0')
	else:
		enroll_accept_data = self.user.createTextNode('1')
	enroll_allowed_data = self.user.createTextNode('1')
	enroll_accept.appendChild(enroll_accept_data)
	enroll_allowed.appendChild(enroll_allowed_data)
	enrollcontrol.appendChild(enroll_accept)
	enrollcontrol.appendChild(enroll_allowed)
	krupp.appendChild(enrollcontrol)
		
	self.userelem.appendChild(krupp)

    def kirjutaSisegrupid(self,kursus,sisegrupp):
	krupp = self.user.createElement('group')
	sourcedid = self.user.createElement('sourcedid')
	source = self.user.createElement('source')
	source_data = self.user.createTextNode('IVA')
	source.appendChild(source_data)
	sourcedid.appendChild(source)
	id = self.user.createElement('id')
#	id_data = self.user.createTextNode(str(kursus.get_id())+":"+str(sisegrupp.id))
	id_data = self.user.createTextNode(str(sisegrupp.id))
	id.appendChild(id_data)
	sourcedid.appendChild(id)
	krupp.appendChild(sourcedid)

	description = self.user.createElement('description')
	short = self.user.createElement('short')
	short_data = self.user.createTextNode(sisegrupp.title)
	short.appendChild(short_data)
	description.appendChild(short)
	krupp.appendChild(description)

	#relationship
	relationship = self.user.createElement('relationship')
	relationship.setAttribute('relation','2')

        sourcedid = self.user.createElement('sourcedid')
        source = self.user.createElement('source')
        source_data = self.user.createTextNode('IVA')
        source.appendChild(source_data)
        sourcedid.appendChild(source)
        id = self.user.createElement('id')
        id_data = self.user.createTextNode(kursus.get_name())
        id.appendChild(id_data)
        sourcedid.appendChild(id)
	relationship.appendChild(sourcedid)

	label = self.user.createElement('label')
	label_data = self.user.createTextNode('Course sub-group')
	label.appendChild(label_data)
	relationship.appendChild(label)
	krupp.appendChild(relationship)

        self.userelem.appendChild(krupp)

        return

    def kirjutaMembership(self,kogum,tyyp='kursus'):
	# write <membership> tag
	if tyyp == 'kursus':
		sortsu_id = kogum.get_name()
		kasutajad = kogum.get_all_users()
		comment_data = self.user.createTextNode('KURSUS')
	else:
		sortsu_id = kogum.id
		kasutajad = kogum.kasutajad_sisegrupis_objektina(sortsu_id)
		comment_data = self.user.createTextNode('SISEGRUPP')

	membership = self.user.createElement('membership')

	comment = self.user.createElement('comments')
	comment.appendChild(comment_data)
	membership.appendChild(comment)

        sourcedid = self.user.createElement('sourcedid')
        source = self.user.createElement('source')
        source_data = self.user.createTextNode('IVA')
        source.appendChild(source_data)
        sourcedid.appendChild(source)
        id = self.user.createElement('id')
        id_data = self.user.createTextNode(str(sortsu_id))
        id.appendChild(id_data)
        sourcedid.appendChild(id)
	membership.appendChild(sourcedid)

	for juuser in kasutajad:
		member = self.user.createElement('member')
	        sourcedid = self.user.createElement('sourcedid')
	        source = self.user.createElement('source')
	        source_data = self.user.createTextNode('IVA')
	        source.appendChild(source_data)
	        sourcedid.appendChild(source)
	        id = self.user.createElement('id')
	        id_data = self.user.createTextNode(juuser.get_uname())
	        id.appendChild(id_data)
	        sourcedid.appendChild(id)
		member.appendChild(sourcedid)
	
		idtype = self.user.createElement('idtype')
		idtype_data = self.user.createTextNode('1')
		idtype.appendChild(idtype_data)
		member.appendChild(idtype)

		role = self.user.createElement('role')
		role.setAttribute('roletype','Learner')

                for abc in kogum.get_local_roles():
                        if abc[0]==juuser.get_uname() and 'Teacher' in abc[1]:
                                role.setAttribute('roletype','Instructor')

		status = self.user.createElement('status')
		status_data = self.user.createTextNode('1')
		status.appendChild(status_data)
		role.appendChild(status)
		member.appendChild(role)
		membership.appendChild(member)
#	self.userelem.appendChild(membership)
	self.sisegrupid.append(membership)

	return

    def lisaMembership(self):
	for abc in self.sisegrupid:
		self.userelem.appendChild(abc)
	return


class Importer:
    def __init__(self, uname,ivajuur,prefix='', kursus='',binaryd='',testonly=0,userwikionly=0):
	"""Creates impoter"""
        self.idmap = {}
	self.uname = uname
	self.prefix = prefix
	self.iva = ivajuur
	if kursus:
		self.kursus = kursus
	else:
		self.kursus = ''
	if binaryd:
		self.binarydata = binaryd
	else:
	        self.binarydata = DataTable()
        self.timecounters=[0,0,0,0,0,0,0,0,0,0]
	self.processed = []
	self.testonly = testonly
	self.userwikionly = userwikionly


    def importQT(self, elem, course, uname):
	import YlTyybid
	from YlAlus import YlAlus
	from YlTyybid import *
	from YlTest import *
	comment =  self.get_text(elem.getElementsByTagName("qticomment")[0])
        for abc in elem.getElementsByTagName("section"):
		sekt_title =  self.get_attr(abc,'title')
		if not hasattr(course.testid,'nr'):
			course.testid.nr=0
		course.testid.nr = course.testid.nr+1
		qt=YlTest()
		qt.pealkiri = sekt_title
		qt.id = "test"+str(course.testid.nr)
		qt.tyyp = 0
		course.testid._setObject(qt.id, qt)
		for bcd in abc.getElementsByTagName("item"):
			try:
				qt_tyyp =  self.get_attr(bcd,'title')
			except IndexError:
				qt_tyyp = ''
			try:
				qt_id = self.get_attr(bcd,'ident')
			except IndexError:
				qt_id = ''
			try:
				qt_story = self.get_text(bcd.getElementsByTagName("qticomment")[0])
			except IndexError:
				qt_story = ''
			pelem = bcd.getElementsByTagName("presentation")[0]
			try:
				qt_quiz = self.get_text(pelem.getElementsByTagName("mattext")[0])
			except IndexError:
				qt_quiz = ''
			try:
				photo_data = self.binarydata.getData(
					self.get_attr(pelem.getElementsByTagName("matimage")[0],'uri'),self.prefix)
			except IndexError:
				photo_data = None 
			try:
				qt_link = self.get_text(pelem.getElementsByTagName("matemtext")[0])
				qt_linkd = self.get_attr(pelem.getElementsByTagName("matemtext")[0],'uri')
			except IndexError:
				qt_link = ''
				qt_linkd = ''

			try:
				r_grp =  pelem.getElementsByTagName("response_grp")
				r_grp1 = 1
			except IndexError:
				r_grp1 = 0
			try:
				r_lid =  pelem.getElementsByTagName("response_lid")
				r_lid1 = 1
			except IndexError:
				r_lid1 = 0
			try:
				r_xy = pelem.getElementsByTagName("response_xy")
				r_xy1 = 1
			except IndexError:
				r_xy1 = 0
			try:
				r_str = pelem.getElementsByTagName("response_str")
				r_str1 = 1
			except IndexError:
				r_str1 = 0
			try:
				r_num = pelem.getElementsByTagName("response_num")
				r_num1 = 1 
			except IndexError:
				r_num1 = 0
			if qt_tyyp == 'ValikYlesanne':
				vastus = self.get_text(bcd.getElementsByTagName("varequal")[0])
				if vastus == 'T': 
					vastus =1 
				else: 
					vastus =0
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = ValikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
				qt_test.seaKirjeldavTekst('',qt_story)
				qt_test.normPunktid=float(punkte)
				qt_test.viiteURL = qt_linkd
				qt_test.viiteTekst = qt_link
				qt_test.vastus = vastus
				qt_test.pilt =  photo_data
				# pistame testi hoidlasse
				pass
			if qt_tyyp == 'MitmikvalikYlesanne':
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = MitmikvalikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				oiged = []
                                v_text = []
                                v_id = []
                                s_text = []
                                s_id = []

				for abc in bcd.getElementsByTagName("varequal"):
					oiged.append(self.get_text(abc))
				for vastused in bcd.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(vastused,'ident'))
					v_text.append(self.get_text(vastused.getElementsByTagName("mattext")[0]))
				for seletused in bcd.getElementsByTagName("itemfeedback"):
					s_id.append(self.get_attr(seletused, 'ident'))
					s_text.append(self.get_text(seletused.getElementsByTagName("mattext")[0]))
				
                                v_sisse = []
                                s_sisse = []
				o_sisse = []
                                j = 0

				for vmass in v_id:
					i = 0
					for smass in s_id:
						if vmass == smass:
							v_sisse.append(v_text[j])
							s_sisse.append(s_text[i])
						i = i + 1
					try:
						if str(vmass) in oiged:
							o_sisse.append(int(j))
					except:
						pass
					j = j + 1
				qt_test.valikud = v_sisse
				qt_test.selgitused = s_sisse
				qt_test.oigedValikud = o_sisse
				pass
			if qt_tyyp == 'YksikvalikYlesanne':
				vastus = self.get_text(bcd.getElementsByTagName("varequal")[0])
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = YksikvalikYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				v_text = []
				v_id = []
				s_text = []
				s_id = []
				for vastused in pelem.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(vastused,'ident'))
					v_text.append(self.get_text(vastused.getElementsByTagName("mattext")[0]))
				for seletused in bcd.getElementsByTagName("itemfeedback"):
					s_id.append(self.get_attr(seletused, 'ident'))
					s_text.append(self.get_text(seletused.getElementsByTagName("mattext")[0]))
				v_sisse = []
				s_sisse = []
                                s_id.reverse()
                                s_text.reverse()
				j = 0
				for vmass in v_id:
					i = 0
					for smass in s_id:
						if vmass == smass:
							v_sisse.append(v_text[j])
							s_sisse.append(s_text[i])
						i = i + 1
					if vmass == str(vastus):
						qt_test.oigeValik = j
					j = j + 1
				qt_test.valikud = v_sisse
				qt_test.selgitused = s_sisse
				pass
			if qt_tyyp == 'OigeTekstivastusegaYlesanne':
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = OigeTekstivastusegaYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				oiged = []
                                for abc in bcd.getElementsByTagName("varequal"):
                                        oiged.append(self.get_text(abc))
				qt_test.variandid = oiged
				pass
			if qt_tyyp == 'TekstivastusegaYlesanne':
				try:
	                                punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				except:
					punkte = 0
                                qt_test = TekstivastusegaYlesanne(qt_quiz)
                                yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data
				pass
			if qt_tyyp == 'ArvuvahemikuliseVastusegaYlesanne':
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = ArvuvahemikuliseVastusegaYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data
				arv_tyyp = bcd.getElementsByTagName("outcomes")[0]
				q_arv_tyyp = self.get_text(arv_tyyp.getElementsByTagName("qticomment")[0])
				q_alam = self.get_text(bcd.getElementsByTagName("vargte")[0])
				q_oige = self.get_text(bcd.getElementsByTagName("varequal")[0])
				q_ylem = self.get_text(bcd.getElementsByTagName("varlte")[0])
				qt_test.alamPiir = float(q_alam)
				qt_test.ylemPiir = float(q_ylem)
				qt_test.oigeVastus = float(q_oige)
				try:
					qt_test.arvutusTyyp = int(q_arv_tyyp)
				except:
					pass
				pass
			if qt_tyyp == 'VastavusYlesanne':
				import random
				punkte = self.get_text(bcd.getElementsByTagName("setvar")[0])
				qt_test = VastavusYlesanne(qt_quiz)
				yl = qt.lisaYlesanne(qt_test)
                                qt_test.seaKirjeldavTekst('',qt_story)
                                qt_test.normPunktid=float(punkte)
                                qt_test.viiteURL = qt_linkd
                                qt_test.viiteTekst = qt_link
                                qt_test.pilt =  photo_data

				v_id = []
				v_text = []
				for abc in bcd.getElementsByTagName("response_label"):
					v_id.append(self.get_attr(abc,'ident'))
					v_text.append(self.get_text(abc.getElementsByTagName("mattext")[0]))
				s_vastused = []
				s_kysimused = []
				for abc in bcd.getElementsByTagName("varsubset"):
					paar = string.split(self.get_text(abc),",")
					koht_v = v_id.index(paar[0])
					koht_p = v_id.index(paar[1])
					s_kysimused.append(v_text[koht_v])
					s_vastused.append(v_text[koht_p])
				s_jarjestus = []
				for i in range(len(s_kysimused)):
					s_jarjestus.append(i)
				random.shuffle(s_jarjestus)
				qt_test.kysimused = s_kysimused
				qt_test.vastused = s_vastused
				qt_test.jarjestus = s_jarjestus
				pass
	return

    def lisaIsik(self,isik,tyyp,grupinimi=''):
	uid = self.get_text(isik.getElementsByTagName('id')[0])
	roll = self.get_attr(isik.getElementsByTagName('role')[0],'roletype')
	if tyyp == 'kursus':
		self.kursus.add_student(uid)
		if roll == 'Instructor':
			self.kursus.set_roles(uid,('Teacher',))
		else:
			self.kursus.set_roles(uid,('Student',))
	else:
		self.kursus.lisa_sisegruppi(grupinimi,uid)
	return

    def restoreMembership(self,failisisu):
	sisegr = self.kursus.sisegrupid.objectValues()
	sisegrupid = []
	for grupid in sisegr:
		sisegrupid.append(grupid.get_name())
	for group in failisisu.getElementsByTagName('group'):
		id = self.get_text(group.getElementsByTagName('id')[0])
		try:
			typevalue = self.get_attr(group.getElementsByTagName('typevalue')[0],'level')
		except:
			typevalue = ''
		if str(typevalue) == '1':
			try:
				orgname = self.get_text(group.getElementsByTagName('orgname')[0])
			except:
				orgname = 'orgnameorgnameorgname'
	#		if self.kursus:
	#			if str(orgname) == str(self.kursus.get_name()):
	#				pass
    			for ship in failisisu.getElementsByTagName('membership'):
				try:
					komm = self.get_text(ship.getElementsByTagName('comments')[0])
				except:
					komm = ''
				ship_id = self.get_text(ship.getElementsByTagName('id')[0])
				if ship_id == str(self.kursus.get_name()) == id and str(komm) == 'KURSUS':
					for isik in ship.getElementsByTagName('member'):
						self.lisaIsik(isik,'kursus')
		else:
			id = self.get_text(group.getElementsByTagName('id')[0])
			if not id in sisegrupid:
				try:
					sgr = self.kursus.lisa_grupp(id)
					sgr.kysiSyndmusteKataloog()
				except:
					print "sisegrupi loomisel tekkis viga!"
			for ship in failisisu.getElementsByTagName('membership'):
				try:
					komm = self.get_text(ship.getElementsByTagName('comments')[0])
				except:
					komm = ''
				if str(komm) == 'SISEGRUPP':
					for isik in ship.getElementsByTagName('member'):
						ship_id = self.get_text(ship.getElementsByTagName('id')[0])
						if ship_id == id:
							self.lisaIsik(isik,'sisegrupp',id)
	return

    def importUsers(self,element):
	um = getattr(self.iva, 'fle_users')
	tulem = ""
	for person in element.getElementsByTagName('person'):
		roles = []
		userid =  self.get_text(person.getElementsByTagName('userid')[0])
		password = self.get_attr(person.getElementsByTagName('userid')[0],'password')
		try:
			family = self.get_text(person.getElementsByTagName('family')[0])
		except:
			family = ''
		try:
			given = self.get_text(person.getElementsByTagName('given')[0])
		except:
			given = ''
		try:
			email = self.get_text(person.getElementsByTagName('email')[0])
		except:
			email = ''
		try:
			url = self.get_text(person.getElementsByTagName('url')[0])
		except:
			url = ''
		try:
			for telephones in person.getElementsByTagName('tel'):
				if self.get_attr(telephones,'teltype') == 'Voice':
					voice = self.get_text(telephones)
				else:
					mobile = self.get_text(telephones)
		except:
			voice = ''
			mobile = ''
		try:
			addr2 = self.get_text(person.getElementsByTagName('extadd')[0])
		except:
			addr2 = ''
		try:
			street = self.get_text(person.getElementsByTagName('street')[0])
		except:
			street = ''
		try:
			locality = self.get_text(person.getElementsByTagName('locality')[0])
		except:
			locality = ''
		try:
			country = self.get_text(person.getElementsByTagName('country')[0])
		except:
			country = ''
		try:
			photo_tag = person.getElementsByTagName('photo')[0]
			photo_type = self.get_attr(photo_tag,'imgtype')
			photo_location = self.get_text(photo_tag.getElementsByTagName('extref')[0])
			photo = self.binarydata.getData(photo_location)
		except:
			photo = None
		try:
			s_r = person.getElementsByTagName('systemrole')[0]
			systemrole = self.get_attr(s_r,'systemroletype')
			if systemrole == 'SysAdmin':
				roles.append('Manager')
		except:
			systemrole = ''
		try:
			i_r = self.get_text(person.getElementsByTagName('institutionrole')[0])
			inst_role = self.get_attr(i_r,'institutionroletype')
		except:
			instrole = ''
		try:
			eriala = self.get_text(person.getElementsByTagName('orgname')[0])
		except:
			eriala = ''
		try:
			comm = self.get_text(person.getElementsByTagName('comments')[0])
		except:
			comm = ''
		try:
			huvid = self.get_text(person.getElementsByTagName('short')[0])
		except:
			huvid = ''
		try:
			amet_huvid = self.get_text(person.getElementsByTagName('long')[0])
		except:
			amet_huvid = ''
		try:
			label = self.get_text(person.getElementsByTagName('label')[0])
		except:
			label = ''
	#FIX: remove below line
#		userid += '_import'
#		if um.kasKasutajaOlemas(userid):
#			tulem = "kasutaja "+userid+" olemas"
#			print tulem
#		else:
		try:
			um.acl_users._doAddUser(userid,password,['Manager',],())
			kasutaja = um.add_user_fle(userid,('Member',))
			kasutaja.kysiSyndmusteKataloog()
			kasutaja.edit_info(given,family,email,eriala,'keel',photo,'','',street,addr2,
			locality,country,url,voice,mobile,label,comm,huvid,amet_huvid)
		except:
			print "kasutaja "+userid+" lisamisel tekkis viga"
	return

    def test(self,elem, folder, uname, indeks,loop=0):
	for bcd in elem.childNodes:
		#print bcd
		if bcd.nodeType == 1 and bcd.nodeName == 'resource':
			pid = self.get_attr(bcd,"identifier")
			if indeks[self.eemalda(pid)] == self.eemalda(folder.id):
				tyyp = self.get_attr(bcd,'type')
				name = self.get_text(bcd.getElementsByTagName("title")[0])
				if tyyp == 'file':
					data_name = self.get_attr(bcd.getElementsByTagName("file")[0],'href')
					data = self.binarydata.getData(data_name,self.prefix)
					file = folder.add_file(name, 
						FakeUpload(name,data,'application/msword'))
				if tyyp == 'memo':
					sisu = self.get_text(bcd.getElementsByTagName("description")[0])
					memo = folder.add_memo(name,sisu)
				if tyyp == 'URL':
					sisu = self.get_attr(bcd,'href')
					link = folder.add_link(name, sisu)
	#print indeks[self.eemalda(folder.id)]
	if loop==0:
		folder = getattr(folder,folder.id)
		self.importItems(elem,folder,uname,indeks)
	return folder

    def importItems(self, elem, course, uname, indeks,loop=0):
	if loop:
		self.test(elem,course,uname,indeks,loop=1)
	for abc in course.objectValues():
		if abc.meta_type == 'WebtopFolder': 
			folder = getattr(course,abc.id)
			self.test(elem,folder,uname, indeks)
	return "kala"

    def get_text(self,elem):
	res=u''
	for line in elem.childNodes:
        	res += line.nodeValue
	return to_utf8(res)
    def get_attr(self,elem,name):
	return to_utf8(elem.getAttribute(name))

    def kaust(self, elem, kname, parent, uname,fid, pid,indeks):
	folder = parent.add_folder(kname)
	indeks[fid] = self.eemalda(folder.id)
	self.doFolder(elem, folder, uname, indeks)
	return folder
   
    def eemalda(self,pid):
	try:
		number = int(re.sub('[a-zA-Z]','',pid))
	except ValueError:
		number = 0
	return number 

    def doFolder(self,elem,course, uname, indeks):
	""" do folder in bookshelf """
	for bcd in elem.childNodes:
		if bcd.nodeType == 1 and bcd.nodeName == 'item':
			fid = self.eemalda(self.get_attr(bcd,"identifier"))
			pid = self.eemalda(self.get_attr(bcd,"identifierref"))
			kname = self.get_text(bcd.getElementsByTagName("title")[0])
			self.kaust(bcd, kname, course,uname,fid, pid,indeks)
	return indeks 

    def importOrg(self,elem,course):
	for abc in elem.getElementsByTagName("organization"):
		if self.get_text(abc.getElementsByTagName("title")[0]) == "Raamaturiiul":
			nelem = abc
	abc = nelem.getElementsByTagName("item")[0]
	return abc

    def createCourse(self,elem,courses,teacher):
	""" creates an empty course, other functions fill this with data
	    course will be named imported_+exported course name """
	vigu = 0
	try:
		title = elem.getElementsByTagName("imsmd:title")[0]
        	title_c = self.get_text(title.getElementsByTagName("imsmd:langstring")[0])
	except:
		vigu = vigu +1

	try:
		c_organisation = self.get_text(elem.getElementsByTagName("ivamd:organisation")[0])
	except:
		c_organisation = ""
		vigu = vigu+1
	try:
		c_method = self.get_text(elem.getElementsByTagName("ivamd:methods")[0])
	except:
		c_method = ""
		vigu = vigu+1
	try:
		c_quote = self.get_text(elem.getElementsByTagName("ivamd:quote")[0])
	except:
		c_quote = ""
		vigu = vigu+1
	try:
		c_status = int(self.get_text(elem.getElementsByTagName("ivamd:status")[0]))
	except:
		c_status = 0
		vigu = vigu+1
	try:
		c_picture_name = self.get_attr(elem.getElementsByTagName("ivamd:picture")[0],"href")
		c_picture = self.binarydata.getData(c_picture_name,self.prefix)
	except:
		c_picture = None
		vigu = vigu+1
	try:
		desk = elem.getElementsByTagName("imsmd:description")[0]
		desk_c = self.get_text(desk.getElementsByTagName("imsmd:langstring")[0])
#		title_c = "imported_"+title_c
	except:
		desk = ''
		vigu = vigu+1
	if vigu < 3:
			title_c += " *"
			id = courses.add_course_impl(teacher)
			course = courses.get_child(str(id))
			course.update(title_c,desk_c,c_organisation,c_method,0,0,c_quote,c_picture,c_status)
			course.kontrolliRyhmaLaud()
			course.add_folder('CourseFolder')
			course.kysiSyndmusteKataloog()
			return course 
	else:
		print "vigu tekkis liialt palju, jtan kursuse tegemise katki"
	return 0

    def lisaSyndmus(self,resource,tiitel):
	from Kalender import *
	for fail in resource.getElementsByTagName('file'):
		href = self.get_attr(fail,'href')
		print "href  " + href
		syndmused = self.binarydata.getData(str(self.prefix+href))
		synd = syndmused.split('\r\n')
		synd_p = []
		for abc in synd:
		    try:
			if abc[0] == ' ':
				eelmine = synd_p.pop()
				synd_p.append(eelmine + " "+abc)
			else:
				synd_p.append(abc)
		    except:
			pass
		final = []
		for abc in synd_p:
			#print "> "+abc+" <"
			uu = abc.split(':',1)
			final.append(uu)
		#print final
		v_cal = 0
		v_event = 0
		v_loend = 0
		for syndmus in final:
			if syndmus[0] == 'BEGIN' and syndmus[1] == 'VCALENDAR':
				v_cal = 1
			if not v_cal:
				continue
			if syndmus[0] == 'BEGIN' and syndmus[1] == 'VEVENT':
				v_event = 1
			if not v_event:			# no point to collect data
				continue		# if we don't have event

			if syndmus[0] == 'DTSTART' or syndmus[0] == 'DTEND':
				temp = syndmus[1]
                                aeg = []
                                aeg.append(int(temp[0:4]))
                                aeg.append(int(temp[4:6]))
                                aeg.append(int(temp[6:8]))
                                aeg.append(int(temp[9:11]))
                                aeg.append(int(temp[11:13]))
                                aeg.append(int(temp[13:15]))
                                aeg.append(int(0))
                                aeg.append(int(0))
                                aeg.append(int(0))
			if syndmus[0] == 'DTSTART':
				v_loend = v_loend +1
				dtstart = time.mktime(aeg)
			if syndmus[0] == 'DTEND':
				v_loend = v_loend +1
				dtend = time.mktime(aeg) 
			if syndmus[0] == 'N':
				v_loend = v_loend +1
				n = syndmus[1]
			if syndmus[0] == 'DESCRIPTION':
				v_loend = v_loend +1
				desc = syndmus[1]
			if syndmus[0] == 'SUMMARY':
				v_loend = v_loend +1
				summary = syndmus[1]
			if syndmus[0] == 'STATUS':
				v_loend = v_loend +1
				status = int(syndmus[1])
			if syndmus[0] == 'CUTYPE':
				v_loend = v_loend +1
				cutype = syndmus[1]
			if syndmus[0] == 'URL':
				v_loend = v_loend +1
				url = syndmus[1]
			if syndmus[0] == 'X-PROPERTY;VALUE=NAME':
				v_loend = v_loend +1
				name = syndmus[1]
			if syndmus[0] == 'RESOURCES':
				v_loend = v_loend +1
				res = syndmus[1]

                        if syndmus[0] == 'END' and syndmus[1] == 'VCALENDAR':
				break
                        if not v_cal:
                                continue
                        if syndmus[0] == 'END' and syndmus[1] == 'VEVENT':
				if v_loend > 5:
					# try make an event
					if cutype == 'INDIVIDUAL':
						try:
							temp = getattr(self.iva.fle_users, n)
							koht = getattr(temp, 'syndmused')
						except:
							print "kasutaja " + n + " kausta ei leitud snduste tarbeks"
#							temp = getattr(self.iva.fle_users, 'admin')
#							koht = getattr(temp, 'syndmused')
					if cutype == 'GROUP':
						temp = getattr(self.iva.courses, str(self.kursus.get_id()))
						if n == 'kursus':
#							koht = getattr(temp, 'syndmused')
							koht = temp.kysiSyndmusteKataloog()
			#				print "1"
						else:
			#				print "2"
							temp2 = getattr(temp.sisegrupid, n)
							koht = getattr(temp2, 'syndmused')
					if not koht:
						break	# no place to event
			#		print n + " syndmus"
#					synd = KalendriSyndmus(name, summary, desc, dtstart, dtend, url, res, status)
					koht.lisaSyndmusKohe(name, summary, desc, dtstart, dtend, url, res, status)
			#		print dtstart
#					nr = temp.kysiUusNr()
#					synd.id = str(nr)
#					koht._setObject(nr, synd)
                                v_event = 0
				v_loend = 0
                        if not v_event:
                                continue
				
	return

    def ImportUserEvents(self,resource,tiitel):
	for org in resource.getElementsByTagName('organization'):
		id = self.get_attr(org,'identifier')		
		temp = id.split('_')
		juuser = temp[1]
		for item in org.getElementsByTagName('item'):
			idref = self.get_attr(item,'identifierref')
			tiitel = self.get_text(item.getElementsByTagName('title')[0])
			self.otsiTarget(idref,resource,tiitel)
	return

    def handleMetadata(self,element):
	try:
		format = self.get_text(element.getElementsByTagName('imsmd:format')[0])
	except:
		format = 'application/msword'
	return format 

    def handleResource(self,resource,asukoht,resour,tiitel=''):
	tyyp = self.get_attr(resource,'type')
	for element in resource.childNodes:
		# otsi ja leia failid, memod jms
		if element.nodeName == 'dependency':
			idref = self.get_attr(element, 'identifierref')
			self.otsiTarget(idref,resour,'MISC STUFF',asukoht)
		else:
			try:
				href = self.get_attr(element,'href')
				tekst = self.get_text(element.getElementsByTagName('imsmd:title')[0])
			except:
				pass
			if tyyp == 'file':
				# FIXFIXFIX: faili formatt
				try:
					format = self.handleMetadata(element.getElementsByTagName('metadata')[0])
				except:
					format = 'application/msword'
				href = self.get_attr(element,'href')
				data = self.binarydata.getData(str(self.prefix+href))
				# FIX: file type
				fail = asukoht.add_file(tekst,FakeUpload(tekst,data,format),1)
				fail.set_author(self.owner)
			if tyyp == 'memo':
				data = self.binarydata.getData(str(self.prefix+href))
				memo = asukoht.add_memo(tekst,data)
		#		memo.set_author(self.owner)
				memo.manage_delLocalRoles((self.uname,))
				memo.set_author(self.owner)
				memo.manage_setLocalRoles(self.owner, ('Owner',))
			if tyyp == 'URL':
				link = asukoht.add_link(tekst,href)
			#	link.set_author(self.owner)
				link.manage_delLocalRoles((self.uname,))
				link.set_author(self.owner)
				link.manage_setLocalRoles(self.owner, ('Owner',))
			if tyyp == 'wikipage':
				if hasattr(asukoht, tiitel):
#					wikipage = getattr(asukoht, tiitel)
					asukoht._delObject(tiitel)
				data = self.binarydata.getData(str(self.prefix+href))
#				wikipage = ZWikiPage(source_string=data, __name__=tiitel)
				wikipage = ZWikiPage(source_string=data, __name__=tiitel)
				parent = (self.wikiparent,)
				wikipage.parents = parent
				asukoht._setObject(tiitel,wikipage)
#				wikipage += 'lammas tuli klla!!'
	return

    def createFolder(self,asukoht,nimi):
	# loo kaust
#	try:
	if 1 == 1:
		# FIX: omanik on natuke vale siiski
		kaust = asukoht.add_folder(nimi)
		# delete ei anna ka tulemust...
#		kaust._deleteOwnershipAfterAdd()
		kaust.manage_delLocalRoles((self.uname,))
		kaust.set_author(self.owner)
		kaust.manage_setLocalRoles(self.owner, ('Owner',))
#	except:
#		print " <--------------------------------------------> kaust ebannestus: " + asukoht
#		kaust = 'bla9876543211234567890blablaQWKLOPV'
	return kaust

    def otsiItemid(self,item,tiitel,asukoht,resour,start=0):
	# resources tagi ka siia tooma
	tit = self.get_text(item.getElementsByTagName('title')[0])
	if not start:
		uusfolder = self.createFolder(asukoht,tit)
#		asukoht = getattr(asukoht,tit)
	idref = self.get_attr(item,'identifierref')
	try:
		self.otsiTarget(idref,resour,'MISC STUFF',getattr(asukoht,uusfolder.id))
	except:
		self.otsiTarget(idref,resour,'MISC STUFF',asukoht)
        for bcd in item.childNodes:
                if bcd.nodeType == 1 and bcd.nodeName == 'item':
			#otsi itemi tiitel
			#otsi identifierref
			try:
				temp = getattr(asukoht,uusfolder.id)
			except:
				temp = asukoht
			self.otsiItemid(bcd,tiitel,temp,resour)
#	print "<<<<<<<<<<<---------"+str(asukoht.id)+"----------->>>>>>>>>>>>>>>>"
	return

    def otsiWikid(self,item,tiitel,asukoht,resour,start=0,vanem=''):
	tit = self.get_text(item.getElementsByTagName('title')[0])
	self.wikiparent = ''
	idref = self.get_attr(item,'identifierref')
	if not start:
		self.wikiparent = vanem
	self.otsiTarget(idref,resour,tit,asukoht)
	for bcd in item.childNodes:
		if bcd.nodeType == 1 and bcd.nodeName == 'item':
			temp = tit
                        self.otsiWikid(bcd,tiitel,asukoht,resour,vanem=temp)
	return

    def kirjutaRiiulid(self,item,tiitel):
	viga = 0
	temp = getattr(self.iva.courses, self.kursus.get_id())
	asukoht = getattr(temp, 'gf')
	self.owner = self.uname
	wiki = 0
	self.wikiparent = ''
	for org in item.getElementsByTagName('organization'):
		id = self.get_attr(org,'identifier')

		# vaata kas kasutaja yldse on olemas
		# vaata kas kursuse kaust on olemas
		# kui pole loo kaustad
		if re.search('user',id):
			temp = id.split('_')
			if not self.userwikionly:
				juuser = temp[1]
			else:
				juuser = self.uname
			self.owner = juuser
			try:
				self.iva.fle_users.get_user_info(juuser)
				temp = getattr(self.iva.fle_users, juuser)
			except:
				viga = 1
			if re.search('WEBTOP',tiitel) and not viga:
				asukoht = "useri desktopil"
				if not hasattr(getattr(temp, 'webtop'), 'c'+str(self.kursus.id)):
					temp.webtop.lisa_kursuse_kaust_ilma_requestita(juuser,str('c'+str(self.kursus.id)))
			asukoht = getattr(temp.webtop, 'c'+str(self.kursus.id))
#			asukoht = getattr(temp,'webtop')
			if re.search('SAHTLI',tiitel) and not viga:
				asukoht = "useri sahtlis"
				if not hasattr(getattr(temp, 'sahtel'), 'c'+str(self.kursus.id)):
					temp.sahtel.lisa_kursuse_kaust_ilma_requestita(juuser,str('c'+str(self.kursus.id)))
				asukoht = getattr(temp.sahtel, 'c'+str(self.kursus.id))
			if re.search('WIKI',tiitel):
				wiki = 1
		if re.search('WIKI',tiitel):
			if self.userwikionly == 2:
				temp = getattr(self.iva.courses, self.kursus.get_id())
				asukoht = getattr(temp, 'ivawiki')
				wiki = 1
			if not wiki and self.userwikionly==1:
				temp = getattr(self.iva.fle_users, self.uname)
				asukoht = getattr(temp.webtop, 'c'+str(self.kursus.id))
				wiki = 1
			if not wiki and not self.userwikionly:
				temp = getattr(self.iva.courses, self.kursus.get_id())
				asukoht = getattr(temp, 'ivawiki')
				wiki = 1
		if re.search('SISEGRUPP',id) and re.search('SISEGRUPP',tiitel):
			asukoht = "sisegrupis + loo sisegrupp"
			grupinimi = self.get_text(org.getElementsByTagName('title')[0])
			try:
				sgr = self.kursus.lisa_grupp(grupinimi)
				sgr.kysiSyndmusteKataloog()
			except:
				pass
			temp2 = getattr(temp, 'sisegrupid')
			asukoht = getattr(temp2, grupinimi)
		try:
			resources = item.getElementsByTagName('resources')[0]
		except:
			resources = ''
		if re.search('RYHMA',id):
			asukoht = "ryhmalauad"
			sisegrupi_kaustad = org.getElementsByTagName('item')[0]
			temp2 = getattr(temp, 'ryhmalauad')
			korras = 0
			ryhmalaua_idref = self.get_attr(sisegrupi_kaustad,'identifierref')
			self.otsiTarget(ryhmalaua_idref,resources,'TIITEL',temp2)
			for sisegrupid in sisegrupi_kaustad.childNodes:
				if sisegrupid.nodeName == 'item':
					grupinimi = self.get_text(sisegrupid.getElementsByTagName('title')[0])
					m=temp2.objectValues('WebtopFolder')
					for x in m:
						if x.get_name()==grupinimi: 
							try:
								asukoht = getattr(temp2, x.id)
								korras = 1
							except:
								pass
								# FIX: mis siis teeme kui gruppi polegi
#								self.kursus.lisa_grupp(grupinimi)
#								asukoht = getattr(temp2,grupinimi)
					if korras:
						self.otsiItemid(sisegrupid,tiitel,asukoht,resources,1)
					else:
						self.createFolder(temp2,grupinimi)
		st_item = org.getElementsByTagName('item')[0]
		if not re.search('RYHMA',id) and not viga:
			if not wiki and not self.userwikionly and not self.testonly:
				self.otsiItemid(st_item,tiitel,asukoht,resources,1)
			else:
				self.otsiWikid(st_item,tiitel,asukoht,resources,1)
	return

    def leiaLahendus(self,target,tiitel,asukoht='',resour=''):
	try:
		xmlbase = self.get_attr(target,'xml:base')
	except:
		xmlbase = ''
	type = self.get_attr(target,'type')
	href = self.get_attr(target,'href')
	if re.search('file',type) or re.search('memo',type) or re.search('URL',type) or re.search('wiki',type):
		self.handleResource(target,asukoht,resour,tiitel)
	if re.search('Calenda',type):
		self.lisaSyndmus(target,tiitel)
	if re.search('imscp',type):
		if not self.kursus: 
			self.kursus = self.coursemanager
		abc = Importer(self.uname,self.iva,xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('imsqti',type):
		print "'"+xmlbase+"'"
		print self.prefix
		abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('meediapaja',type) or re.search('teadmuspaja',type):
		abc = Importer(self.uname,self.iva,self.prefix+xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly)
		failisisu = abc.loadFile(self.prefix+xmlbase+href)
		abc.processFile(self.kursus,failisisu)
		self.processed.append(target)
	if re.search('iCalendar',tiitel):
		print "impordin kalendrisndmused"
	if re.search('WIKI',tiitel):
		self.kirjutaRiiulid(target,tiitel)
	if re.search('WEBTOP',tiitel):
		self.kirjutaRiiulid(target,tiitel)
	if re.search('SAHTLID',tiitel):
		self.kirjutaRiiulid(target,tiitel)
	if re.search('SISEGRUPP',tiitel):
		self.kirjutaRiiulid(target,tiitel)
	if re.search('RAAMATURIIUL',tiitel):
		self.kirjutaRiiulid(target,tiitel)
	if re.search('SYNDMUSED',tiitel):
		self.ImportUserEvents(target,tiitel)
		print "impordin kasutajate syndmused"
	return

    def otsiTarget(self,identifier,ressursid,tiitel,asukoht=''):
	for target in ressursid.getElementsByTagName("resource"):
		id = self.get_attr(target,'identifier')
#		print id
#		print identifier
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel,asukoht,ressursid)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!! target1"
	for target in self.root.getElementsByTagName("manifest"):
		id = self.get_attr(target,'identifier')
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!! target2"
	for target in self.root.getElementsByTagName("organization"):
		id = self.get_attr(target,'identifier')
		if id == identifier and not self.vaataKasTehtud(target):
			self.leiaLahendus(target,tiitel)
			self.processed.append(target)
			return
		if id == identifier and self.vaataKasTehtud(target):
			print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!!otsiTarget3"
	print "identifieri " + identifier + " pole vimalik leida"
	return

    def otsiTOC(self,element,ressursid):
	for target in element.getElementsByTagName("item"):
		identifier = self.get_attr(target,'identifier')
		identifierref = self.get_attr(target,'identifierref')
		tiitel = self.get_text(target.getElementsByTagName('title')[0])
		if not self.vaataKasTehtud(target):
			self.otsiTarget(identifierref,ressursid,tiitel)
			self.processed.append(target)
		else:
			print "---------------- leidsime sobiva kuid see oli juba tehtud :( jama!!!!otsiTOC"
	return

    def processZip2(self):
	""" ... """
	kaustad = []
	abc = self.root.getElementsByTagName("organizations")[0]
	for i in abc.getElementsByTagName("organization"):
		kaustad.append(self.get_attr(i,'xml:base'))
	return kaustad

    def vaataKasTehtud(self,element):
	for abc in self.processed:
		if element.isSameNode(abc):
			return 1
	return 0

    def otsiKasKasutajaid(self,element):
	try:
		res_xmlbase = self.get_attr(element,'xml:base')
	except:
		res_xmlbase = ''
	for res in element.getElementsByTagName('resource'):
		if re.search('imsent',self.get_attr(res,'type')) and not self.vaataKasTehtud(res):
			try:
				xmlbase = self.get_attr(res,'xml:base')
			except:
				xmlbase = ''
			try:
				href = self.get_attr(res.getElementsByTagName('file')[0],'href')
			except:
				return
			

	                abc = Importer(self.uname,self.iva,xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly)
        	        failisisu = abc.loadFile(self.prefix+xmlbase+href)
                	abc.processFile(self.kursus,failisisu)

#			self.importUsers(res)
			self.processed.append(res)
			if not failisisu:
				failisisu = ''
			return failisisu
	for res in self.root.getElementsByTagName('resource'):
                if re.search('imsent',self.get_attr(res,'type')) and not self.vaataKasTehtud(res):
#			self.importUsers(res)
#			self.processed.append(res)
                        abc = Importer(self.uname,self.iva,xmlbase,self.kursus,self.binarydata,userwikionly=self.userwikionly)
                        failisisu = abc.loadFile(self.prefix+xmlbase+href)
                        abc.processFile(self.kursus,failisisu)
                        self.processed.append(res)
                        return failisisu
	return

    def otsiAlgandmed(self,elem):
	try:
		metadata = elem.getElementsByTagName("metadata")[0]
	except:
		raise 'IVA Error','Missing toplevel-manifest metadata element'
	try:
		resources = elem.getElementsByTagName("resources")[0]
	except:
		raise 'IVA Error','Missing toplevel-manifest resources element'
	try:
		organizations = elem.getElementsByTagName("organizations")[0]
	except:
		raise 'IVA Error','Missing toplevel-manifest organizations element'
	return metadata, organizations, resources

    def processFile(self,coursemanager,element):
	""" process zip and find anything usable. """
	self.coursemanager = coursemanager
	i = 0
	#for organizations in self.root.getElementsByTagName("organizations"):
	#self.kursus = self.createCourse(self.root.getElementsByTagName('metadata')[0],coursemanager,uname)
	st_elem = element.firstChild
	self.root = element.firstChild
	success = self.kontrolliEsimeneElement(st_elem,coursemanager)
	if success:
		return
	metadata,orgnz, resources = self.otsiAlgandmed(st_elem)
	if not self.userwikionly and not self.testonly:
		kas_kursus = self.createCourse(metadata,coursemanager,self.uname)
	if kas_kursus:
		self.kursus = kas_kursus
	else:
		print "sellest failist ei saanud kursust teha\n Proovin kasutada jooksvat kursust"
	failisisu = self.otsiKasKasutajaid(resources)
	if not self.testonly:
		self.otsiTOC(orgnz,resources)
	# kursus ja sisegrupid peaksid olema nd loodud. paigutan kasutajad.
	if failisisu:
		self.restoreMembership(failisisu)
#	self.processed.append(self.organizations)

#	for abc in self.root.childNodes:
#		if not self.vaataKasTehtud(abc):
#			print "blaah "+str(abc.nodeName)
#			for organization in abc.getElementsByTagName("organization"):
#				self.otsiTOC(organization)
#				i=i+1
#				print str(i)+" kala"
#				print organization.nodeName
#				print self.get_attr(organization,'identifier')


    def loadZip(self,file):
        zip = zipfile.ZipFile(file,"r",zipfile.ZIP_DEFLATED)

        for name in zip.namelist():
	#    if not re.search('imsmanifest.xml',name):
                self.binarydata.restoreData(name,zip.read(name))
        zip.close()


    def loadFile(self,nimi):
	xmlstring = self.binarydata.getData(nimi)
	try:
		fish = xml.dom.minidom.parseString(xmlstring)
	except UnicodeError:
		print "XML data is not utf-8 encoded! Detecting encoding..."
		encoding = re.search('encoding="([-a-zA-Z0-9]*)">',xmlstring).group(1)
		print "Transforming from %s to utf-8..." % encoding
		xmlstring = unicode(xmlstring,encoding).encode("utf-8")
		fish = xml.dom.minidom.parseString(xmlstring)
	return fish 

    def kontrolliEsimeneElement(self,element,courses):
	if self.testonly:
		element = element.getElementsByTagName("questestinterop")[0]
	if element.nodeName == 'questestinterop':
		#Jump to qti import
		self.importQT(element,self.kursus,self.uname)
		return "QT"
	if element.nodeName == 'enterprise':
		#FIX: 1st element is DocumentType
		abc = element.nextSibling
		self.importUsers(abc)
		#Jump to user import
		return "EP"
	if element.nodeName == 'Jamming':
		print " import Jamming"
		kala = Exporter(self.iva,prefix=self.prefix)
		kala.binarydata = self.binarydata
		kala.importJamming(element,self.kursus)
		return "MP"
	if element.nodeName == 'KnowledgeBuilding':
		print " import KnowledgeBuilding"
		kala = Exporter(self.iva,prefix=self.prefix)
		kala.binarydata = self.binarydata
		for ctx in element.childNodes:
			kala.importContext(ctx,self.kursus)
		return "TP"
	return 0


class kirjutaYldM:
    def __init__(self):
	self.mainmani = Document()
	self.root_element = self.mainmani.createElement("manifest")
        self.root_element.setAttribute('identifier','IVA')
        self.root_element.setAttribute('version','1')
        self.root_element.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
        self.root_element.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        self.root_element.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
        self.root_element.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
	self.mainmani.appendChild(self.root_element)
	md=self.mainmani.createElement("metadata")
	self.root_element.appendChild(md)
	mds=self.mainmani.createElement('schema')
        md.appendChild(mds)
        text = self.mainmani.createTextNode('IMS Content')
        mds.appendChild(text)
        mdv=self.mainmani.createElement('schemaversion')
        md.appendChild(mdv)
        mdv.appendChild(self.mainmani.createTextNode('1.1'))
        rek = self.mainmani.createElement('imsmd:record')
	md.appendChild(rek)
        gen = self.mainmani.createElement('imsmd:general')
        rek.appendChild(gen)
        tit = self.mainmani.createElement('imsmd:title')
        gen.appendChild(tit)
        lang = self.mainmani.createElement('imsmd:langstring')
        lang.setAttribute('xml:lang','en-US')
        lang.appendChild(self.mainmani.createTextNode('Data exported from IVA. See http://www.htk.tpu.ee/iva'))
        tit.appendChild(lang)

	self.organizations = self.mainmani.createElement("organizations")
	self.root_element.appendChild(self.organizations)
	self.organization = self.mainmani.createElement("organization")
	self.organization.setAttribute('identifier','courses')
	self.organizations.appendChild(self.organization)
	self.ress = self.mainmani.createElement("resources")
	self.root_element.appendChild(self.ress)


    def kirjutaYldmanifest(self, kursusenr=0, kirjeldus='kirjeldus',tyyp='imscp_xmlv1p1p3',base='course/',href='imsmanifest.xml'):
        m = self.mainmani.createElement("item")
	m.setAttribute('identifier','item_'+str(kursusenr))
	m.setAttribute('identifierref','resource_'+str(kursusenr))
#        m.setAttribute('identifier','course'+str(kursusenr))
        self.organization.appendChild(m)
	title = self.mainmani.createElement("title")
	title.appendChild(self.mainmani.createTextNode(kirjeldus))
	m.appendChild(title)
	item = self.mainmani.createElement("resource")
	item.setAttribute('identifier','resource_'+str(kursusenr))
	item.setAttribute('type',tyyp)
	if base != "":
		item.setAttribute('xml:base',base)
	item.setAttribute('href',href)
	item_title = self.mainmani.createElement('file')
	item_title.setAttribute('href',href)
	item.appendChild(item_title)
	self.ress.appendChild(item)
        return m

    def lisaFaili(self, failinimi="ivaarhiiv.zip"):
        "Lisatakse yldmanifest zip'i"
        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.mainmani.writexml(dump)
        zip.writestr(zipfile.ZipInfo("imsmanifest.xml"),dump.getdata())
	zip.close()



class Kirjutus:
    import string
    def __init__(self, ivajuur, kursusenr):
	""" Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt """
	self.generateID()	# just in case
	self.iva = ivajuur
	self.kursusenr = kursusenr
	self.kursus = getattr(ivajuur.courses, str(kursusenr))
	return

    def looKursuseFail(self,metadata=1):
	# kursuse faili loomine
	# must be called before other functions
	self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
# valmistame ette dokumendi 
        self.root=self.dom.createElement("manifest")
	self.dom.appendChild(self.root)
        self.root.setAttribute('identifier','IVA')
        self.root.setAttribute('version','1')
        self.root.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
        self.root.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        self.root.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	self.root.setAttribute('xmlns:ivamd','http://www.htk.tpu.ee/%7Evahur/ivaplus.xsd')
        self.root.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd http://www.htk.tpu.ee/%7Evahur/ivaplus http://www.htk.tpu.ee/%7Evahur/ivaplus.xsd')
	if metadata:
		metadata = self.dom.createElement("metadata")

		schema = self.dom.createElement("schema")
		schema_data = self.dom.createTextNode("IMS Content")
		schema.appendChild(schema_data)
		schema_ver = self.dom.createElement("schemaversion")
		schema_ver_data = self.dom.createTextNode("1.1")
		schema_ver.appendChild(schema_ver_data)
	
		metadata.appendChild(schema)
		metadata.appendChild(schema_ver)

		md_methods = self.dom.createElement('ivamd:methods')
		md_methods_data = self.dom.createTextNode(self.kursus.get_methods())
		md_methods.appendChild(md_methods_data)
		metadata.appendChild(md_methods)
		md_organisation = self.dom.createElement('ivamd:organisation')
		md_organisation_data = self.dom.createTextNode(self.kursus.get_organisation())
		md_organisation.appendChild(md_organisation_data)
		metadata.appendChild(md_organisation)
		md_quote = self.dom.createElement('ivamd:quote')
		md_quote_data = self.dom.createTextNode(self.kursus.kysiTekst())
		md_quote.appendChild(md_quote_data)
		metadata.appendChild(md_quote)
		if self.kursus.kysiLogo():
			md_picture = self.dom.createElement('ivamd:picture')
			name = self.binarydata.storeData(self.kursus.kysiLogo())
			md_picture.setAttribute('href',name)
			metadata.appendChild(md_picture)
		md_status = self.dom.createElement('ivamd:status')
		try:
			md_status_data = self.dom.createTextNode(str(self.kursus.staatus))
		except:
			md_status_data = self.dom.createTextNode(str(0))
		md_status.appendChild(md_status_data)
		metadata.appendChild(md_status)

		record = self.dom.createElement('imsmd:record')
		general = self.dom.createElement('imsmd:general')
		record.appendChild(general)
		title = self.dom.createElement('imsmd:title')
		general.appendChild(title)
		lang = self.dom.createElement('imsmd:langstring')
		lang.setAttribute('xml:lang','en-US')
		lang_data = self.dom.createTextNode(self.kursus.get_name())
		lang.appendChild(lang_data)
		title.appendChild(lang)

		descr = self.dom.createElement('imsmd:description')
		descrlang = self.dom.createElement('imsmd:langstring')
		descrlang.setAttribute('xml:lang','en-US')
		descrlang_data = self.dom.createTextNode(self.kursus.get_description())
		descrlang.appendChild(descrlang_data)
		descr.appendChild(descrlang)
		general.appendChild(descr)
		metadata.appendChild(record)
		self.root.appendChild(metadata)
	
	self.organizations = self.dom.createElement('organizations')
	self.organization = self.dom.createElement('organization')
	self.organization.setAttribute('identifier','IVA_CONTENT'+str(self.idnumber))
	self.organizations.appendChild(self.organization)
	self.resources = self.dom.createElement('resources')
	self.root.appendChild(self.organizations)
	self.root.appendChild(self.resources)
	

    def generateID(self):
	# generates idnumber. used as identifer and identifierref
	# used as 'ITEM'+str(self.idnumber) and 'TARGET'+str(self.idnumber)
	import random
	self.idnumber = str(random.randint(1,9999))+"_"+str(random.randint(1,9999))
	return self.idnumber

    def lisaMetadata(self,vanem,objekt,technical=''):
	metadata = self.dom.createElement('metadata')
	if technical:
		technical = self.dom.createElement('imsmd:technical')
		format = self.dom.createElement('imsmd:format')
		format_data = self.dom.createTextNode(str(objekt.content_type))
		format.appendChild(format_data)
		technical.appendChild(format)
		metadata.appendChild(technical)

	vanem.appendChild(metadata)
	return metadata

    def kirjutaItem(self,vanem,isvisible='',parameters='',tiitel=''):
	# writes an item tag and appends to vanem
	item = self.dom.createElement('item')
	item.setAttribute('identifier','ITEM'+str(self.idnumber))
	item.setAttribute('identifierref','TARGET'+str(self.idnumber))
	if isvisible != '':
		item.setAttribute('isvisible',isvisible)
	if parameters != '':
		item.setAttribute('parameters',parameters)
	if tiitel != '':
		self.kirjutaTitle(item,tiitel)
	vanem.appendChild(item)
	return item

    def kirjutaResource(self,vanem,tyyp='webcontent',fail='', href='',base=''):
	# writes resource tag and appends to vanem
	resource = self.dom.createElement('resource')
	resource.setAttribute('identifier','TARGET'+str(self.idnumber))
	resource.setAttribute('type',tyyp)
	if base != '':
		resource.setAttribute('xml:base',base)
	if href != '':
		resource.setAttribute('href',str(href))
	if fail != '':
		self.kirjutaFile(resource,fail)
	vanem.appendChild(resource)
	return resource

    def kirjutaTitle(self,vanem,tiitel,namespace=''):
	title = self.dom.createElement(namespace+'title')
	title_data = self.dom.createTextNode(tiitel)
	title.appendChild(title_data)
	vanem.appendChild(title)
	return title

    def kirjutaFile(self,vanem,fail):
	fail_elem = self.dom.createElement('file')
	fail_elem.setAttribute('href',fail)
	vanem.appendChild(fail_elem)
	return fail_elem

    def kirjutaDependency(self,vanem,targetid):
	dep = self.dom.createElement('dependency')
	dep.setAttribute('identifierref','TARGET'+str(targetid))
	vanem.appendChild(dep)
	return dep

    def kirjutaManifest(self,base=''):
	# creates sub-manifest, returns 3 elements: metadata, organizations and resources
	manifest = self.dom.createElement('manifest')
	manifest.setAttribute('identifier','TARGET'+str(self.idnumber))
	if base != '':
		manifest.setAttribute('xml:base',base)
	metadata = self.dom.createElement('metadata')
	manifest.appendChild(metadata)
	organizations = self.dom.createElement('organizations')
	manifest.appendChild(organizations)
	resources = self.dom.createElement('resources')
	manifest.appendChild(resources)
	self.root.appendChild(manifest)
	return metadata,organizations,resources

    def otsiWebtopItemid(self,folder,itemid,resource):
	targetid = self.generateID()
	notdone = 1
	resource_done = 0
	item = self.kirjutaItem(itemid)
	try:
		self.kirjutaTitle(item,folder.get_name())
	except:
		pass
	toimetasime = 0
	for file in folder.objectValues('WebtopFile'):
		if notdone:
			res = self.kirjutaResource(resource,tyyp='file')
			dep_res = res
#			self.kirjutaDependency(res)
			resource_done = 1
			notdone = 0
		fnimi = self.binarydata.storeData(file.data,'file')
		fail = self.kirjutaFile(res,fnimi)
		print file.content_type
		metadata = self.lisaMetadata(fail,file, technical=1)
#		self.kirjutaTitle(fail,file.get_name(),'imsmd:')
		self.kirjutaTitle(metadata,file.get_name(),'imsmd:')
		toimetasime = 1
	notdone = 1
	if toimetasime:
		targetid = self.generateID()
		toimetasime = 0
	for link in folder.objectValues('WebtopLink'):
		if notdone:
			res = self.kirjutaResource(resource,tyyp='URL')
			if not resource_done:
				resource_done = 1
				dep_res = res
			else:
				self.kirjutaDependency(dep_res,targetid)
			notdone = 0
		fail = self.kirjutaFile(res,link.get_url())
		self.kirjutaTitle(fail,link.get_name(),'imsmd:')
		toimetasime = 1
	notdone = 1
	if toimetasime:
		targetid = self.generateID()
		toimetasime = 0
	for memo in folder.objectValues('WebtopMemo'):
		if notdone:
			res = self.kirjutaResource(resource,tyyp='memo')
			if not resource_done:
				resource_done = 1
				dep_res = res
			else:
				self.kirjutaDependency(dep_res,targetid)
			notdone = 0
		mnimi = self.binarydata.storeData(memo.get_body(),'memo')
		file = self.kirjutaFile(res,mnimi)	
		self.kirjutaTitle(file,memo.get_name(),'imsmd:')
	for fol in folder.objectValues('WebtopFolder'):
		self.otsiWebtopItemid(fol,item,resource)
	return

    def kirjutaWebtop(self,point,misc='ident',tiitel='SISEGRUPP'):
	# exports webtop style components
	self.generateID()
	self.kirjutaItem(self.organization,tiitel=tiitel)
	e_metadata,e_organizations,e_resources = self.kirjutaManifest()
	organization = self.dom.createElement('organization')
	organization.setAttribute('identifier',misc+str(self.idnumber))
	e_organizations.appendChild(organization)
	self.otsiWebtopItemid(point,organization,e_resources)
	return

    def kirjutaKasutajaWebtop(self,kasutajad):
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='KASUTAJATE WEBTOPID')
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='KASUTAJATE SAHTLID')
	s_metadata,s_organizations,s_resources = self.kirjutaManifest()
	for user in kasutajad:
		uname = user.get_uname()
		try:
			pp = getattr(self.iva.fle_users, uname)
			point = getattr(pp.webtop, 'c'+self.kursusenr)
			webtop_ation = self.dom.createElement('organization')
			webtop_ation.setAttribute('identifier','user_'+str(uname)+'_webtop')
			w_organizations.appendChild(webtop_ation)
			self.otsiWebtopItemid(point,webtop_ation,w_resources)
		except:
			pass
		try:
			point = getattr(pp.sahtel, 'c'+self.kursusenr)
			sahtel_ation = self.dom.createElement('organization')
			sahtel_ation.setAttribute('identifier','user_'+str(uname)+'_sahtel')
			s_organizations.appendChild(sahtel_ation)
			self.otsiWebtopItemid(point,sahtel_ation,s_resources)
		except:
			pass
	return

    def pakiKursusFaili(self,failinimi,path='ABCDE'):
	import string
	if path == 'ABCDE':
		path = self.kursusenr
	if path != '':
		path += '/'
	if zipfile.is_zipfile(failinimi):
		zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
	else:
		zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	dump = Dump()
	self.dom.writexml(dump)
	zip.writestr(zipfile.ZipInfo(path+"imsmanifest.xml"),dump.getdata())
	
	for name in self.binarydata.names:
		zip.writestr(
		  zipfile.ZipInfo(path+name),
		  str(self.binarydata.getData(name)))
	zip.close()


    def otsiWikiLapsed(self,point,resources,organization,start='WikiStart',sygavus=99999):
	#puudub koht muutjate jaoks
	for wiki in self.wikid:
		wiki_vanemad = wiki[1]
		if start in wiki_vanemad:
			self.generateID()
			wikileht = getattr(point, wiki[0])
			item = self.kirjutaItem(organization,tiitel=wikileht.name())
			wname = self.binarydata.storeData(wikileht,'wiki')
			self.kirjutaResource(resources,'wikipage',wname)
			if not self.wikilevel == sygavus:
				self.wikilevel = self.wikilevel+1
				self.otsiWikiLapsed(point, resources, item, wikileht.name(),sygavus)
				self.wikilevel = self.wikilevel-1
	return

    def indekseeriWikid(self,point):
	self.wikid = []
	temp = []
	for wiki in point.objectValues():
		try:
			temp.append(wiki.name())
			temp.append(wiki.parents)
			self.wikid.append(temp)
			temp = []
		except:
			pass
	return

    def kirjutaWiki(self,point,misc='ident',tiitel='ZWIKI',start='WikiStart',palju=''):
	self.generateID()
	self.kirjutaItem(self.organization,tiitel=tiitel)
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
        organization = self.dom.createElement('organization')
        organization.setAttribute('identifier',misc+str(self.idnumber))
        w_organizations.appendChild(organization)
	#kirjutame esieme wiki-lehe 
	self.generateID()
	item = self.kirjutaItem(organization,tiitel=getattr(point,start).name())
	wnimi = self.binarydata.storeData(getattr(point, start),'wiki') 
	self.kirjutaResource(w_resources,'wikipage', wnimi)

	self.indekseeriWikid(point)
	self.wikilevel = 1
	if palju:
		self.otsiWikiLapsed(point,w_resources,item,start,palju)
	else:
		self.otsiWikiLapsed(point,w_resources,item,start)
	return

    def kirjutaKasutajaWiki(self,kasutajad,start='WikiStart'):
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='KASUTAJA WIKI')
	w_metadata,w_organizations,w_resources = self.kirjutaManifest()
        self.generateID()
	for kasutaja in kasutajad:
		uname = kasutaja.get_uname()
		try:
			pp = getattr(self.iva.fle_users, uname)
			point = getattr(pp.webtop, 'c'+self.kursusenr)
			wiki_organization = self.dom.createElement('organization')
			wiki_organization.setAttribute('identifier','user_'+str(uname)+'_wiki')
			w_organizations.appendChild(wiki_organization)
			self.generateID()
		        item = self.kirjutaItem(wiki_organization,tiitel=getattr(point,start).name())
		        wnimi = self.binarydata.storeData(getattr(point, start),'wiki')
		        self.kirjutaResource(w_resources,'wikipage', wnimi)
	
		        self.indekseeriWikid(point)
		        self.otsiWikiLapsed(point,w_resources,item,start)
		except:
			pass
	return

    def vCalTime(self, aeg):
	import time
	vaeg = time.localtime(aeg)
	v_aeg = ""
	v_aeg += str(vaeg[0])
	if len(str(vaeg[1])) == 1:
		v_aeg += "0" +str(vaeg[1])
	else:
		v_aeg += str(vaeg[1])
	if len(str(vaeg[2])) == 1:
		v_aeg += "0" +str(vaeg[2])
	else:
		v_aeg += str(vaeg[2])
	v_aeg += "T"
	if len(str(vaeg[3])) == 1:
		v_aeg += "0"+str(vaeg[3])
	else:
		v_aeg += str(vaeg[3])
	if len(str(vaeg[4])) == 1:
		v_aeg += "0"+str(vaeg[4])
	else:
		v_aeg += str(vaeg[4])
	if len(str(vaeg[5])) == 1:
		v_aeg += "0"+str(vaeg[5])
	else:
		v_aeg += str(vaeg[5])
	return v_aeg

    def format(self,sisend):
	temp = re.sub('\r\n',' ',sisend)
	pikkus = len(temp)
	tulem = ""
	if pikkus>60:
		abc = ""
		for taht in temp:
			abc += taht
			if len(abc)>59:
				tulem += abc
				tulem += "\r\n"
				tulem += " "
				abc = ""
		tulem += abc
		#tulem += "\r\n"
	else:
		tulem = temp
	return tulem

    def kirjutaEvent(self,point,omanik='mina',kat='kursus'):
	tulem = ""
	for syndmus in point.objectValues():
		tulem += "BEGIN:VEVENT\r\n"
		tulem += "DTSTART:"+self.vCalTime(syndmus.algus)+"\r\n"
		tulem += "DTEND:"+self.vCalTime(syndmus.lopp)+"\r\n"
		tulem += "N:"+omanik+"\r\n"
		tulem += "DESCRIPTION:"+self.format(syndmus.pikk)+"\r\n"
		tulem += "SUMMARY:"+self.format(syndmus.lyhi)+"\r\n"
		tulem += "STATUS:"+str(syndmus.olek)+"\r\n"
		tulem += "CUTYPE:"+kat+"\r\n"
		tulem += "URL:"+syndmus.viide+"\r\n"
		tulem += "X-PROPERTY;VALUE=NAME:"+self.format(syndmus.nimi)+"\r\n"
#		tulem += "X-COMPONENT;VALUE=NAME:"+self.format(oma)+"\r\n"
		tulem += "RESOURCES:"+self.format(syndmus.siseviide)+"\r\n"
		tulem += "END:VEVENT\r\n"
	return tulem 

    def has_events(self,point):
	for syndmus in point.objectValues():
		return  1
	return 0 

    def kirjutavCal(self,point,omanik,kat,organiz='', resour=''):
	if organiz == '':
		organiz = self.organization
	if resour == '':
		resour = self.resources
	if self.has_events(point):
		vCal = "BEGIN:VCALENDAR\r\n"
		vCal += "METHOD:PUBLISH\r\n"
		vCal += "VERSION:2.0\r\n"
		vCal += "PRODID:IVA\r\n"
		vCal += self.kirjutaEvent(point,omanik,kat)
		vCal += "END:VCALENDAR\r\n"
		nimi = self.binarydata.storeData(vCal,'vcal','.ics')
	        self.generateID()
	        self.kirjutaItem(organiz,tiitel='iCalendar - '+omanik+' - syndmused')
#	        self.kirjutaItem(self.organization,tiitel='iCalendar - '+omanik+' syndmused')
	        self.kirjutaResource(resour,'iCalendar',nimi)
#	        self.kirjutaResource(self.resources,'iCalendar',nimi)
	return 

    def kirjutaKasutajaSyndmus(self,kasutajad):
	self.generateID()
	self.kirjutaItem(self.organization, tiitel="KASUTAJATE SYNDMUSED")
	s_metadata,s_organizations,s_resources = self.kirjutaManifest()
	for user in kasutajad:
		try:
		    uname = user.get_uname()
		    point = getattr(self.iva.fle_users, uname)
		    if self.has_events(point.syndmused):
			syndmus_organization = self.dom.createElement('organization')
			syndmus_organization.setAttribute('identifier','user_'+str(uname)+'_events')
			s_organizations.appendChild(syndmus_organization)
			self.kirjutavCal(point.syndmused, uname, 'INDIVIDUAL',syndmus_organization,s_resources)
		except:
		    pass
	return

    def prooviKiri(self,point):
	for kiri in point.objectValues():
		print kiri
		print kiri.kysiPealkiri()
		print kiri.kysiSisu()
		print kiri.kysiSaatja()
		print kiri.kysiAeg()
		print kiri.kasLoetud()
	return


    def exportPajad(self,failinimi,path,startonly=0):
	self.generateID()
	TP = Document()
	MP = Document()

	kala = Exporter(self.iva)
	tp_elem = TP.createElement('KnowledgeBuilding')
	for ctx in self.kursus.get_children("CourseContext"):
		tp_elem.appendChild(kala.exportContext(ctx,startonly))

	TP.appendChild(tp_elem)
	mp_elem = MP.createElement('Jamming')
        try:
            #for c in courses.get_children('Course'):
            for js in self.kursus.get_child('jamming').get_children('JamSession'):
		mp_elem.appendChild(kala.exportJamSession(self.kursus, js,startonly))
	except:
		pass
	MP.appendChild(mp_elem)
	self.kirjutaItem(self.organization,tiitel='TEADMUSPAJA')
	self.kirjutaResource(self.resources,'teadmuspaja','teadmuspaja.xml','teadmuspaja.xml')
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='MEEDIAPAJA')
	self.kirjutaResource(self.resources,'meediapaja','meediapaja.xml','meediapaja.xml')

        if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        TP.dump = Dump()
        MP.dump = Dump()
        TP.writexml(TP.dump)
        MP.writexml(MP.dump)
        zip.writestr(zipfile.ZipInfo(path+"teadmuspaja.xml"),TP.dump.getdata())
        zip.writestr(zipfile.ZipInfo(path+"meediapaja.xml"),MP.dump.getdata())
        for name in kala.binarydata.names:
            zip.writestr(
                zipfile.ZipInfo(path+name),
                str(kala.binarydata.getData(name)))
	zip.close()
	return

    def exportQTI(self,failinimi,path):
	# function for going all necessary to export tests
	self.generateID()
	self.kirjutaItem(self.organization,tiitel='QTI')
	self.kirjutaResource(self.resources,'imsqti_xmlv1p1','qti.xml','qti.xml')
	element = self.looTestiFail()
	self.kirjutaTestid(element)
	self.kirjutaTestidZipi(failinimi,path)

    def looTestiFail(self):
	self.generateID()
	self.qti = Document()
	self.qtibin = DataTable()
	self.qtiroot = self.qti.createElement("questestinterop")
	self.qtiroot.setAttribute('xmlns','http://www.imsglobal.org/xsd/ims_qtiasiv1p2')
	self.qtiroot.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	self.qtiroot.setAttribute('xsi:schemaLocation','http://www.imsglobal.org/xsd/ims_qtiasiv1p2 http://www.imsglobal.org/xsd/ims_qtiasiv1p2.xsd')
	self.qti.appendChild(self.qtiroot)
	return self.qtiroot

    def kirjutaTestidZipi(self,failinimi,path=''):
	if zipfile.is_zipfile(failinimi):
                zip = zipfile.ZipFile(failinimi,"a",zipfile.ZIP_DEFLATED)
        else:
                zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
	self.qti.dump = Dump()
	self.qti.writexml(self.qti.dump)
	zip.writestr(zipfile.ZipInfo(path+"qti.xml"),self.qti.dump.getdata())
        for name in self.qtibin.names:
            zip.writestr(
                zipfile.ZipInfo(path+name),
                str(self.qtibin.getData(name)))
        zip.close()

	return

    def testiPilt(self,vanem, varamu):
	if varamu.pilt is not None:
	        mat_pilt = self.qti.createElement('matimage')
	        name = self.qtibin.storeData(varamu.pilt,'qti')
	        mat_pilt.setAttribute('uri',name)
		vanem.appendChild(mat_pilt)
	return vanem

    def testiViide(self,vanem, varamu):
	if varamu.viiteURL != '':
             matem = self.qti.createElement('matemtext')
             matem.setAttribute('uri',varamu.viiteURL)
             matem.appendChild(self.qti.createTextNode(varamu.viiteTekst))
             vanem.appendChild(matem)
	return vanem

    def testiKirjeldavTekst(self,vanem,varamu):
	if varamu.kirjeldavTekst != '':
             komm = self.qti.createElement('qticomment')
             komm.appendChild(self.qti.createTextNode(varamu.kirjeldavTekst))
             vanem.appendChild(komm)
	return vanem

    def testiItem(self,vanem,varamu):
        elem = self.qti.createElement('item')
        elem.setAttribute('ident',varamu.get_id())
	elem.setAttribute('title',varamu.meta_type)
        vanem.appendChild(elem)
	return elem 

    def kirjutaTestid(self,vanem,testinimi=''):
	if testinimi != '':
		ainult_yks_test = 1
	else:
		ainult_yks_test = 0
        qticomment = self.qti.createElement("qticomment")
        qticomment_data = self.qti.createTextNode('Here is a set of questions and tests from IVA')
        qticomment.appendChild(qticomment_data)
        vanem.appendChild(qticomment)
        # export all tests and questions within course
	for hoidla in self.kursus.testid.objectValues():
	 if hoidla.get_id() == testinimi or not ainult_yks_test:
	  sektion = self.qti.createElement('section')
	  sektion.setAttribute('title',hoidla.pealkiri)
	  sektion.setAttribute('ident',hoidla.get_id())
	  #print hoidla.get_id()
	  for yled in hoidla.objectValues():
		#print "->>"+yled.get_id()
		#print yled.get_id()+" - "+ yled.meta_type
		tyyp = yled.meta_type
        	if tyyp=='ValikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
			present = self.qti.createElement('presentation')
			elem.appendChild(present)
			flo = self.qti.createElement('flow')
			present.appendChild(flo)
			mat = self.qti.createElement('material')
			flo.appendChild(mat)
			mattext = self.qti.createElement('mattext')
			mattext.appendChild(self.qti.createTextNode(yled.kysimus))
			mat.appendChild(mattext)
			
			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

			resp_lid = self.qti.createElement('response_lid')
			resp_lid.setAttribute('ident',yled.get_id())
			resp_lid.setAttribute('rcardinality',"Single")
			flo.appendChild(resp_lid)

			render = self.qti.createElement('render_choice')
			resp_lid.appendChild(render)
			flow_l = self.qti.createElement('flow_label')
			render.appendChild(flow_l)
			
			resp_lab = self.qti.createElement('response_label')
			resp_lab.setAttribute('ident','T')
			flow_l.appendChild(resp_lab)
                        mat2 = self.qti.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.qti.createElement('mattext')
                        mattext2.appendChild(self.qti.createTextNode('True'))
                        mat2.appendChild(mattext2)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','F')
                        flow_l.appendChild(resp_lab)
                        mat2 = self.qti.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.qti.createElement('mattext')
                        mattext2.appendChild(self.qti.createTextNode('False'))
                        mat2.appendChild(mattext2)


			resproc = self.qti.createElement('resprocessing')
			elem.appendChild(resproc)
			out = self.qti.createElement('outcomes')
			resproc.appendChild(out)
			muut = self.qti.createElement('decvar')
			muut.setAttribute('vartype','Integer')
			muut.setAttribute('maxvalue',str(yled.normPunktid))
			out.appendChild(muut)

			kond = self.qti.createElement('respcondition')
			kond.setAttribute('title','Correct')
			resproc.appendChild(kond)
			kond_var = self.qti.createElement('conditionvar')
			kond.appendChild(kond_var)
			varequal = self.qti.createElement('varequal')
			varequal.setAttribute('respident',yled.get_id())
			if yled.vastus:
				varequal.appendChild(self.qti.createTextNode('T'))
			else:
				varequal.appendChild(self.qti.createTextNode('F'))
 			kond_var.appendChild(varequal)

			setvar = self.qti.createElement('setvar')
			setvar.setAttribute('action','Add')
			setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			pass
		if tyyp=='OigeTekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_fib')
			render.setAttribute('fibtype','String')
			render.setAttribute('encoding','UTF_8')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)
                        
			kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        for abc in yled.variandid:
                                varequal = self.qti.createElement('varequal')
                                varequal.setAttribute('respident',yled.get_id())
                                varequal.appendChild(self.qti.createTextNode(str(abc)))
                                kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			
			pass
        	if tyyp=='YksikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
			i=0
			for abc in yled.valikud:
	                        resp_lab = self.qti.createElement('response_label')
	                        resp_lab.setAttribute('ident',str(i))
	                        render.appendChild(resp_lab)
				flow_mat = self.qti.createElement('flow_mat')
				resp_lab.appendChild(flow_mat)
	                        mat2 = self.qti.createElement('material')
	                        flow_mat.appendChild(mat2)
	                        mattext2 = self.qti.createElement('mattext')
	                        mattext2.appendChild(self.qti.createTextNode(abc))
	                        mat2.appendChild(mattext2)
				i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        varequal = self.qti.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
			varequal.appendChild(self.qti.createTextNode(str(yled.oigeValik)))
			kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			i=0
			for abc in yled.selgitused:
				itemfeed = self.qti.createElement('itemfeedback')
				itemfeed.setAttribute('ident',str(i))
				elem.appendChild(itemfeed)
				flow_m = self.qti.createElement('flow_mat')
				itemfeed.appendChild(flow_m)
				mat = self.qti.createElement('material')
				flow_m.appendChild(mat)
				mattext = self.qti.createElement('mattext')
				mattext.appendChild(self.qti.createTextNode(abc))
				mat.appendChild(mattext)
				i=i+1
			pass
        	if tyyp=='TekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Ordered")
                        flo.appendChild(resp_lid)
			
                        render = self.qti.createElement('render_fib')
                        render.setAttribute('fibtype','String')
                        render.setAttribute('enconding','UTF_8')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)
			pass
        	if tyyp=='MitmikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_lid)
			
                        render = self.qti.createElement('render_choice')
                        render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
                        i=0
                        for abc in yled.valikud:
                                resp_lab = self.qti.createElement('response_label')
                                resp_lab.setAttribute('ident',str(i))
                                render.appendChild(resp_lab)
                                flow_mat = self.qti.createElement('flow_mat')
                                resp_lab.appendChild(flow_mat)
                                mat2 = self.qti.createElement('material')
                                flow_mat.appendChild(mat2)
                                mattext2 = self.qti.createElement('mattext')
                                mattext2.appendChild(self.qti.createTextNode(abc))
                                mat2.appendChild(mattext2)
                                i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			for abc in yled.oigedValikud:
	                        varequal = self.qti.createElement('varequal')
	                        varequal.setAttribute('respident',yled.get_id())
	                        varequal.appendChild(self.qti.createTextNode(str(abc)))
	                        kond_var.appendChild(varequal)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
                        i=0
                        for abc in yled.selgitused:
                                itemfeed = self.qti.createElement('itemfeedback')
                                itemfeed.setAttribute('ident',str(i))
                                elem.appendChild(itemfeed)
                                flow_m = self.qti.createElement('flow_mat')
                                itemfeed.appendChild(flow_m)
                                mat = self.qti.createElement('material')
                                flow_m.appendChild(mat)
                                mattext = self.qti.createElement('mattext')
                                mattext.appendChild(self.qti.createTextNode(abc))
                                mat.appendChild(mattext)
                                i=i+1

			pass
        	if tyyp=='ArvuvahemikuliseVastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.qti.createElement('response_num')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
			resp_lid.setAttribute('numtype','Decimal')
                        flo.appendChild(resp_lid)

                        render = self.qti.createElement('render_fib')
			render.setAttribute('fibtype','Decimal')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.qti.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
			komm = self.qti.createElement('qticomment')
			komm.appendChild(self.qti.createTextNode(str(yled.arvutusTyyp)))
			out.appendChild(komm)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			varless = self.qti.createElement('vargte')
			varless.setAttribute('respident',yled.get_id())
			varless.appendChild(self.qti.createTextNode(str(yled.alamPiir)))
			kond_var.appendChild(varless)
                        varequal = self.qti.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
                        varequal.appendChild(self.qti.createTextNode(str(yled.oigeVastus)))
                        kond_var.appendChild(varequal)
			varover = self.qti.createElement('varlte')
			varover.setAttribute('respident',yled.get_id())
			varover.appendChild(self.qti.createTextNode(str(yled.ylemPiir)))
			kond_var.appendChild(varover)

                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)

			pass
        	if tyyp=='ProtsentYlesanne':
			pass
        	if tyyp=='VastavusYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.qti.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.qti.createElement('flow')
                        present.appendChild(flo)
                        mat = self.qti.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.qti.createElement('mattext')
                        mattext.appendChild(self.qti.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

			resp_grp = self.qti.createElement('response_grp')
                        resp_grp.setAttribute('ident',yled.get_id())
                        resp_grp.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_grp)
			render = self.qti.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
			resp_grp.appendChild(render)
			i=0
			krupp = ''
			for abc in yled.vastused:
				resp_lab = self.qti.createElement('response_label')
				ident = 'p'+str(i)
				if krupp != '':
					krupp = krupp+','
				krupp = krupp + ident
				resp_lab.setAttribute('ident',ident)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
				rmat = self.qti.createElement('material')
				resp_lab.appendChild(rmat)
				rmattext = self.qti.createElement('mattext')
				rmattext.setAttribute('texttype','text/plain')
				rmattext.appendChild(self.qti.createTextNode(abc))
				rmat.appendChild(rmattext)
				i=i+1
			i=0
			for abc in yled.kysimused:
				resp_lab = self.qti.createElement('response_label')
				resp_lab.setAttribute('ident','v'+str(i))
				resp_lab.setAttribute('match_max','1')
				resp_lab.setAttribute('match_group',krupp)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
                                rmat = self.qti.createElement('material')
                                resp_lab.appendChild(rmat)
                                rmattext = self.qti.createElement('mattext')
                                rmattext.setAttribute('texttype','text/plain')
                                rmattext.appendChild(self.qti.createTextNode(abc))
                                rmat.appendChild(rmattext)
				i=i+1

                        resproc = self.qti.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.qti.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.qti.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.qti.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.qti.createElement('conditionvar')
                        kond.appendChild(kond_var)
			jah = self.qti.createElement('and')
			kond_var.appendChild(jah)
			i=0
			for abc in yled.vastused:
				varsub = self.qti.createElement('varsubset')
				varsub.setAttribute('respident',yled.get_id())
				varsub.setAttribute('setmatch','Exact')
				varsub.appendChild(self.qti.createTextNode('v'+str(i)+','+'p'+str(i)))
				jah.appendChild(varsub)
				i=i+1
                        setvar = self.qti.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.qti.createTextNode(str(yled.normPunktid)))
                        kond.appendChild(setvar)
			
			pass
	  vanem.appendChild(sektion)
	return

