import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
import time
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft

class Kiri(
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Saadetud kiri postkastis"
     def __init__(self, pealkiri, sisu, saatja, saaja, remote_id):
       "Kirja loomine"
       self.pealkiri=pealkiri
       self.sisu=sisu
       self.saatja=saatja
       self.loomisaeg=time.time()
       self.loetud=0
       self.saaja = saaja 
       self.remote_id = remote_id
       
     def kysiPealkiri(self):
       "Pealkirja ksimine"
       return self.pealkiri
       
     def kysiSisu(self):
       "Sisu ksimine"
       return self.sisu

     def kysiSaatja(self):
       return self.saatja
       
     def kysiSaatja_nimega(self):
       "Saatja ksimine"
       try:
           saatja = getattr(self.fle_root().fle_users, self.saatja)
           if saatja.get_first_name()!="" and saatja.get_last_name()!="":
              vastus = saatja.get_first_name()
              vastus += "&nbsp;"
              vastus += saatja.get_last_name()
           else:
              vastus = saatja.get_uname() 
           return vastus
       except:
           return self.saatja
       
     def kysiAeg(self):
       "Aja ksimine"
       # FIX:
       # return self.aeg
       return self.loomisaeg
       
     def kysiAegTekstina(self, REQUEST):
       "Saatmisaeg"
       return self.aegTekstina(REQUEST, self.loomisaeg)

     def aegTekstina(self, REQUEST, aeg):
       "tekstiesitus"
       self.get_lang(('common',), REQUEST)
       if aeg==-1: return "*"
       return time.strftime(REQUEST['L_timestamp_format'], time.localtime(aeg))

     def kasLoetud(self):
       "Kas loetud"
       return self.loetud
       
     def index_html(self, REQUEST):
       "Vljastus"
       self.loetud=1
       tulemus=self.hdr(self, REQUEST)
       if hasattr(self, 'omakopi'):
           tulemus = tulemus + "<br /><br />"
           try:
               tulemus += REQUEST['L_who_has_read']
               saaja = self.saaja.split(',')
               for abc in saaja:
                   attrib = abc.lstrip()+"_hasread"
                   if hasattr(self,attrib):
                      tulemus += " "+abc
                   else:
                      tulemus += "<b>"+ abc+"</b>"
               tulemus += "<br />"
           except:
               pass
       else:
           k = self.fle_root().fle_users
           kasutaja = getattr(k, self.saatja).kysiKirjadeKataloog()
#           tulemus += "<br /><br />"+self.remote_id+"<br /><br />"
           # mis siis kui kasutaja 7 korda kirja avab? :)
           try:
               saatja_kopi = getattr(kasutaja, self.remote_id)
               setattr(saatja_kopi, str(REQUEST.AUTHENTICATED_USER)+"_hasread" ,1)
           except:
               pass
               # kui kasutajal tema kastis enam seda kirja pole 
       tulemus=tulemus+"</p>\n"
       tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       tulemus=tulemus+"  <tr>\n"
       tulemus=tulemus+"    <td class=\"t1\" width=\"120\">"+REQUEST['L_ic_sender']+":</td>\n"
       if kasutaja.get_first_name()!='' and kasutaja.get_last_name()!='':
          try:
              s_saatja = kasutaja.get_first_name()+" "+kasutaja.get_last_name()
          except:
              s_saatja = self.saatja
       else:
          s_saatja = self.saatja
       tulemus=tulemus+"    <td class=\"t1\">"+s_saatja+"</td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td class=\"t1\" width=\"120\">"+REQUEST['L_ic_to']+"</td>\n"
       tulemus=tulemus+"    <td class=\"t1\">"+self.saaja+"</td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td class=\"t1\" width=\"120\">"+REQUEST['L_ic_sentdate']+":</td>\n"
       tulemus=tulemus+"    <td class=\"t1\">"+self.kysiAegTekstina(REQUEST)+"</td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td class=\"t1\" width=\"120\">"+REQUEST['L_ic_title']+":</td>\n"
       tulemus=tulemus+"    <td class=\"t1\">"+self.kysiPealkiri()+"</td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td colspan=\"2\" class=\"t1\">\n<p>"+self.sisu+"</p>\n    </td>\n"
       tulemus=tulemus+"  </tr>\n</table>\n"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
       
       
class Kirjakast(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     kirjaNr=0
     uusiKirju=0

     def kirjadeLoetelu(self, REQUEST,outbox=0):
      "Loetelu lehena"
      self.get_lang(('ivacommon',), REQUEST)
      k=getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).kirjad
      self.uusiKirju=0
      tulemus=self.hdr(self, REQUEST)
      tulemus=tulemus+"</p>\n"
      tulemus=tulemus+"<form action=\"kirjakastiMuutus\">\n"
      tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"#EEEEEE\">\n"
      tulemus=tulemus+"  <tr>\n"
      tulemus=tulemus+"    <td width=\"30\" align=\"center\">\n"
      tulemus=tulemus+"    <img src=\"images/mailbox\" alt=\"\" height=\"20\" width=\"20\" />\n    </td>\n"
      tulemus=tulemus+"    <td>"
      if outbox:
          tulemus=tulemus+"    <a href=\""+k.absolute_url()+"/kirjadeLoetelu\" class=\"link2\">"+REQUEST['L_ic_mailbox']+"</a>"
      else:
          tulemus=tulemus+REQUEST['L_ic_mailbox']
      tulemus=tulemus+"    </td>\n"
      tulemus=tulemus+"    <td width=\"30\" align=\"center\">\n"
      tulemus=tulemus+"    <img src=\"images/transparent_gif\" alt=\"\" height=\"20\" width=\"20\" />\n    </td>\n"
      tulemus=tulemus+"    <td><a href=\""+k.absolute_url()+"/kirjaKoostamiseVorm\" class=\"link2\">"+REQUEST['L_ic_newmail']+"</a></td>\n"
      tulemus=tulemus+"    <td width=\"30\" align=\"center\">\n"
      tulemus=tulemus+"    <img src=\"images/outbox\" alt=\"\" height=\"20\" width=\"20\" />\n    </td>\n"
      tulemus=tulemus+"    <td>"
      if outbox:
          tulemus=tulemus+REQUEST['L_ic_outbox']
      else:
          tulemus=tulemus+"    <a href=\""+k.absolute_url()+"/kirjadeLoetelu?outbox=1\" class=\"link2\">"+REQUEST['L_ic_outbox']+"</a>"
      tulemus=tulemus+"    </td>\n"
      tulemus=tulemus+"  </tr>\n</table>\n\n"
      kirjad=self.objectValues()
      if len(kirjad)>0:
       tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
       tulemus=tulemus+"  <tr>\n"
       tulemus=tulemus+"    <td><img src=\"images/transparent_gif\" height=\"8\" width=\"10\" alt=\"\" /></td>\n"
       tulemus=tulemus+"  </tr>\n</table>\n"
       tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       tulemus=tulemus+"  <tr>\n"
       tulemus=tulemus+"    <td width=\"30\">&nbsp;</td>\n"
       tulemus=tulemus+"    <td>"+REQUEST['L_ic_title']+"</td>\n"
       tulemus=tulemus+"    <td>"+REQUEST['L_ic_sender']+"</td>\n"
       tulemus=tulemus+"    <td>"+REQUEST['L_ic_sentdate']+"</td>\n"
       tulemus=tulemus+"  </tr>\n"
       for kiri in kirjad:
         if outbox:
             if not hasattr(kiri,'omakopi'):
                continue
         else:
             if hasattr(kiri,'omakopi'):
                continue
         tulemus=tulemus+"  <tr>\n"
         tulemus=tulemus+"    <td width=\"30\" class=\"t1\"><input type=\"checkbox\" name=\"kiri\" value=\""+kiri.id+"\" /></td>\n"
         if not kiri.kasLoetud():
           tulemus=tulemus+"    <td class=\"t1\"><strong>"
         else:
           tulemus=tulemus+"    <td class=\"t1\">"
         tpealkiri=kiri.kysiPealkiri()
         if not tpealkiri.lower().startswith("re"):
           tpealkiri="Re: "+tpealkiri
         tulemus=tulemus+"<a href='"+kiri.absolute_url()+"'>"+kiri.kysiPealkiri()+"</a>"
         if not kiri.kasLoetud():
           tulemus=tulemus+"</strong></td>\n"
           tulemus=tulemus+"    <td class=\"t1\"><strong>"
         else:
           tulemus=tulemus+"</td>\n"
           tulemus=tulemus+"    <td class=\"t1\">"
         tulemus=tulemus+"<a href=\"kirjaKoostamiseVorm?kellele="+kiri.kysiSaatja()+"&amp;pealkiri="+tpealkiri+"\">"+kiri.kysiSaatja_nimega()+"</a>"
         if not kiri.kasLoetud():
           tulemus=tulemus+"</strong></td>\n"
           tulemus=tulemus+"    <td class=\"t1\"><strong>"
         else:
           tulemus=tulemus+"</td>\n"
           tulemus=tulemus+"    <td class=\"t1\">"
         tulemus=tulemus+kiri.kysiAegTekstina(REQUEST)
         if not kiri.kasLoetud():
           tulemus=tulemus+"</strong></td>\n  </tr>\n"
         else:
           tulemus=tulemus+"</td>\n  </tr>\n"
       tulemus=tulemus+"</table>"     
       tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
       tulemus=tulemus+"  <tr>\n"
       tulemus=tulemus+"    <td><img src=\"images/transparent_gif\" height=\"8\" width=\"10\" alt=\"\" /></td>\n"
       tulemus=tulemus+"  </tr>\n</table>\n"
       tulemus=tulemus+"<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       tulemus=tulemus+"  <tr>\n"
       tulemus=tulemus+"    <td><input type=\"submit\" name=\"kustuta\" value=\""+REQUEST['L_ic_delete']+"\" /></td>\n"
       tulemus=tulemus+"  </tr>\n</table>\n"
      else:
        tulemus=tulemus+"<p>"+REQUEST['L_ic_nomail']+"</p>"
      tulemus=tulemus+"</form>\n"
      tulemus=tulemus+self.fle_html_footer(self, REQUEST)
      return tulemus
      
     def kirjakastiMuutus(self, REQUEST, kiri=()):
      "Esiotsa vaid kustutamine"
      if type(kiri)==types.StringType:
        kiri=(kiri,)
      for x in kiri:
        self._delObject(x)
      REQUEST.RESPONSE.redirect('kirjadeLoetelu')
       
     def lisaKiri(self, REQUEST, pealkiri, sisu, saatja, saaja, remote_id):
       "Kirja lisamine kasti"
       import re
       self.uusiKirju=1
       k=Kiri(pealkiri, re.sub('\n', '<br />', sisu), saatja, saaja, remote_id)
       self.kirjaNr=self.kirjaNr+1
       kirjanimi="kiri"+str(self.kirjaNr)
       k.id=kirjanimi
       self._setObject(kirjanimi, k)
       return k.id
       
     def kasUusiKirju(self, REQUEST):
       "jah/ei"
       return self.uusiKirju
       
     def kirjaKoostamiseVorm(self, REQUEST, kellele=(), pealkiri="", sisu=''):
       "Koht kokkupanekuks"
       if type(kellele)==types.StringType:
         kellele=(kellele,)
       tulemus=self.hdr(self, REQUEST)
       tulemus=tulemus+"    </p>\n\n"
       tulemus=tulemus+"<h2>"+REQUEST['L_ic_newmail']+"</h2>\n\n"
       tulemus=tulemus+"<form action=\"kirjaSaatmiseLeht\">\n"
       tulemus=tulemus+"<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%\">\n  <tr>\n"
       tulemus += "<tr><td>"+REQUEST['L_ic_select_whom']+"</td><td><select name='s_kellele'>"
       knr = getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).get_jooksev_kursus()
       k_kasutajad = getattr(self.fle_root().courses, str(knr)).get_all_users()
       for k_k in k_kasutajad:
           tulemus += "<option value=\""+k_k.get_uname()+"\">"
           if k_k.get_first_name()!='' and k_k.get_last_name()!='':
              tulemus += k_k.get_first_name() + " " + k_k.get_last_name()
           else:
              tulemus += k_k.get_uname()
           tulemus += "</option>"
       tulemus += "</select><input type=\"submit\" value='"+REQUEST['L_ic_add_name']+"' name=\"lisa\">"
       tulemus += "</td></tr>"
       tulemus=tulemus+"    <td>"+REQUEST['L_ic_to']+"</td>\n"
       tulemus=tulemus+"    <td><input type=\"text\" name=\"kellele\" value=\""+", ".join(kellele)+"\" class=\"width400\" /></td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td>"+REQUEST['L_ic_subject']+"</td>\n"
       tulemus=tulemus+"    <td><input type=\"text\" name=\"pealkiri\" value=\""+pealkiri+"\" class=\"width400\" /></td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td valign=\"top\">"+REQUEST['L_ic_text']+"</td>\n"
       tulemus=tulemus+"    <td><textarea name=\"sisu\" cols=\"40\"  rows=\"6\" class=\"width400\">"+sisu+"</textarea></td>\n"
       tulemus=tulemus+"  </tr>\n  <tr>\n"
       tulemus=tulemus+"    <td>&nbsp;</td>\n"
       tulemus=tulemus+"    <td><input type=\"submit\" name=\"saada\" value=\""+REQUEST['L_ic_send']+"\" /></td>\n"
       tulemus=tulemus+"  </tr>\n</table>\n</form>\n"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
       
    
     def kirjaSaatmiseLeht(self, REQUEST, kellele, pealkiri, sisu, lisa='', s_kellele=''):
       "Saatmine, kellele on inimeste komadega eraldatud loetelu"   
       if lisa:
          if kellele:
             kellele += ", "
          kellele += s_kellele
          REQUEST.RESPONSE.redirect('kirjaKoostamiseVorm?kellele='+kellele+'&pealkiri='+pealkiri+'&sisu='+sisu)
          return
       tulemus=self.hdr(self, REQUEST)
       saaja = kellele
       omakopi_id = self.omakoopia(REQUEST, kellele,saaja,pealkiri,sisu)
       kellele=kellele.split(',')
       for i in range(len(kellele)):
         kellele[i]=kellele[i].strip()
       tulemus=tulemus+"</p>\n<p>"
       for kasutaja in kellele:
         tulemus=tulemus+kasutaja
         kass = self.saadaKiri(REQUEST, kasutaja, saaja, pealkiri, sisu, omakopi_id)
         if kass[0] != 0:
            tulemus += " - sisekiri ok"
         else:
            tulemus += " - sisekiri not ok"
         if kass[1] == 0:
            tulemus = tulemus + " - Email not ok"
         if kass[1] != 3 and kass[1] !=0:
            tulemus += " - Email ok"
         tulemus += "</p>\n"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
       
     def saadaKiri(self, REQUEST, kellele, saaja, pealkiri, sisu, remote_id):
       "Kellele on ks inimene"
       k=self.fle_root().fle_users
       if not hasattr(k, kellele): return 0,0
       kasutaja = k.get_user_info(kellele)
       saatja = k.get_user_info(str(REQUEST.AUTHENTICATED_USER))
       try:
           if saatja.get_first_name()!='' and saatja.get_last_name()!='':
		lisa_saatja = saatja.get_first_name()+" "+saatja.get_last_name()
           else:
		lisa_saatja = saatja.get_uname()
           if kasutaja.email_kirjad == 1 and kasutaja.get_email():
              raport = self.saadaEmail(kasutaja.get_email().strip(),pealkiri,sisu+"\n\n\n"+\
              lisa_saatja,saatja.get_email().strip())
       except:
           pass
       kirja_id = getattr(k, kellele).kysiKirjadeKataloog().lisaKiri(REQUEST, pealkiri, sisu, str(REQUEST.AUTHENTICATED_USER), saaja, remote_id)
       try:
            if raport == 999:
               pass
       except:
         raport = 3
       return kirja_id,raport

     def omakoopia(self, REQUEST, kellele,saaja, pealkiri,sisu):
#       k=self.fle_root().fle_users
#       outbox = getattr(k, str(REQUEST.AUTHENTICATED_USER)).kysiKirjadeKataloog()
#       sisu = "Kiri saadetud: "+kellele+"<br><br>"+sisu
       kirja_id = self.lisaKiri(REQUEST, pealkiri, sisu, str(REQUEST.AUTHENTICATED_USER), saaja, '9999')
       uuskiri = getattr(self,kirja_id)
       uuskiri.omakopi = 1
       return kirja_id
      
