import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
import time
import re
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml
class Kodutoo(
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Kodut andmete hoidla"
     def __init__(self, REQUEST, tyyp, kirjeldus="", 
         normPunkte=0,kalendriID=None):
       "Algvrtustus"
       self.tyyp=int(tyyp)
       self.kirjeldus=kirjeldus
       self.loppaeg=None #Esituspiiri pole mratud
       self.normPunkte=normPunkte
       self.kalendriID=None #kalendrisyndmuse id
       
     def muutmisVorm(self, REQUEST):
       "Kodut andmete muutmine. Kitutakse vastavalt tbile"      
       self.get_lang(('ivatasks',),REQUEST)
       t=self.hdr(self, REQUEST)
       tyybid=self.aq_parent.kodutoodeTyypideLoetelu(REQUEST)
       t=t+"<h3>"+REQUEST['L_ia_editing_task']+"</h3>"
       t=t+"<form action='muutmisLeht'>"
       t=t+"<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"       
       t=t+"<tr><td class='t1'>"+REQUEST['L_ia_type']+"</td><td class='t1'>"+tyybid[self.tyyp]+"</td></tr>\n"
       t=t+"<tr><td class='t1'>"+REQUEST['L_ia_title']+"</td><td class='t1'><input type='text' name='pealkiri' value='"+self.kysiPealkiri(REQUEST)+"' /></td></tr>\n"
       t=t+"<tr><td class='t1'>"+REQUEST['L_ia_descr']+"</td><td class='t1'><textarea name='kirjeldus'>"+self.kirjeldus+"</textarea></td></tr>\n"
       if self.tyyp==0: #test         
         kursus=getattr(self.fle_root().courses, self.jooksva_kursuse_nr(self, REQUEST))
         t+"<tr><td class='t1'>"+REQUEST['L_ia_quiz']+":</td><td>"
         t=t+REQUEST['L_ia_select_quiz']+": <select name='testiID'>"
         t=t+"<option value='-1'>"+REQUEST['L_ia_select_quiz']+"</option>"
         testiID="-1"
         if hasattr(self, 'testiID'):
           testiID=self.testiID
         for x in kursus.testid.objectValues():
          if x.id==testiID:
           t=t+"<option value='%s' selected='SELECTED'>%s</option>\n" % (x.getId(), x.annaPealkiri())
          else:
           t=t+"<option value='%s'>%s</option>\n" % (x.getId(), x.annaPealkiri())
         t=t+"</select></td></tr>"
       if self.tyyp==1 or self.tyyp==2: #Isiklik vi grupp
          import YlTest
          from YlTest import LahendusLuba
          abi=LahendusLuba() #vaid ajamen tarbeks
          t+="<tr><td class='t1'>"+REQUEST['L_ia_deadline']+"</td><td class='t1'><input type='checkbox' name='kasLoppaeg' "
          if self.loppaeg:
            t+=" checked='CHECKED' "
          t+="/>"
          if self.loppaeg:
            t+=abi.ajaMuutmisElemendid('loppaeg', self.loppaeg)
          else:
            t+=abi.ajaMuutmisElemendid('loppaeg', -1)
          t+="</td></tr>"
       if self.tyyp==2: #grupp
          t+="<tr><td class='t1'>"+REQUEST['L_ia_groups']+"</td><td class='t1'><select name='grupid' multiple size='5'>" 
          if not hasattr(self, 'grupid'):
            self.grupid=[]
          kursusegrupid=self.aq_parent.sisegrupid.objectValues()
          for kg in kursusegrupid:
            t+="<option value='"+kg.id+"'"
            if kg.id in self.grupid:
              t+=" selected='SELECTED' "
            t+=">"+kg.id+"</option>\n"
          t+="</select></td></tr>"
            
          
       t=t+"<tr><td class='t1'>"+REQUEST['L_ia_total']+"</td><td class='t1'><input type='text' name='normPunkte' value='"+str(self.normPunkte)+"'/></td></tr>"
       t=t+"</table>"
       t=t+"<table  width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
       t=t+"  <tr>\n"
       t=t+"  <td><input type='submit' value='"+REQUEST['L_ia_submit']+"'></td>"
       t=t+"  </tr>\n"
       t=t+"</table>\n</form>"
       t=t+self.fle_html_footer(self, REQUEST)
       return t
       
     def muutmisLeht(self, REQUEST):
       "Muutuste salvestus"
       self.get_lang(('common','ivatasks',),REQUEST)
       eelmine_loppaeg = self.loppaeg
       self.normPunkte=float(re.sub(',', '.', REQUEST.normPunkte))
       self.kirjeldus=REQUEST.kirjeldus
       self.pealkiri=REQUEST.pealkiri
       if self.tyyp==0:
         self.testiID=REQUEST.testiID
       if self.tyyp==2:
         self.grupid=[]
         if hasattr(REQUEST, 'grupid'):
           if type(REQUEST.grupid) is types.StringType:
             self.grupid.append(REQUEST.grupid)
           else:
             for x in REQUEST.grupid:
               self.grupid.append(x)
         for x in self.grupid:
           grupikaust=self.aq_parent.leiaGrupiKaust(x)
           if not hasattr(grupikaust, self.id):
             grupikaust.lisa_kaust(self.id)
             getattr(grupikaust, self.id).seaEsitluskaust(1)
           getattr(grupikaust, self.id).set_name(self.pealkiri)
       if hasattr(REQUEST, 'kasLoppaeg'):
         import YlTest
         from YlTest import LahendusLuba
         abi=LahendusLuba() #vaid ajamen tarbeks
         self.loppaeg=abi.ajaPyydmisLeht(REQUEST, 'loppaeg')
       else:
         self.loppaeg=None
       self.absolute_url()
       syndmused = self.find_course().syndmused
       s_nimi = REQUEST['L_ia_task']
       s_lyhi = self.kodutoodeTyypideLoetelu(REQUEST)[self.tyyp]
       if self.tyyp != 0 and self.tyyp != 3:
          s_status = 1
       else:
          s_status = 0
       if self.kalendriID != None:
          try:
              too_syndmus = getattr(syndmused, self.kalendriID)
              s_pikk = too_syndmus.pikk
              s_end = too_syndmus.lopp
              s_res = too_syndmus.siseviide
              if s_end != eelmine_loppaeg and eelmine_loppaeg != None:
                 s_pikk += "<br />"+REQUEST['L_ia_deadline_updated']
                 if self.loppaeg !=None:
                   s_pikk += time.strftime(REQUEST['L_timestamp_format'], time.localtime(self.loppaeg))
                 else:
                   s_pikk += REQUEST['L_ia_no_deadline']
                 s_end = self.loppaeg
              syndmused._delObject(too_syndmus.id)
          except:
              self.kalendriID = None
       if self.kalendriID == None:
          s_end = time.time()
          if hasattr(REQUEST, 'kasLoppaeg'):
             s_end = abi.ajaPyydmisLeht(REQUEST, 'loppaeg')
          s_pikk = REQUEST['L_ia_task_added']+"<br />"+self.kirjeldus+""
          s_pikk += "<br />"+REQUEST['L_ia_points']+str(self.normPunkte)
          if self.tyyp != 0 and self.tyyp != 3:
             s_pikk += "<br />"+REQUEST['L_ia_deadline']
             s_pikk += time.strftime(REQUEST['L_timestamp_format'], time.localtime(s_end))
       too_syndmus = syndmused.lisaSyndmusKohe(s_nimi,s_lyhi,s_pikk,time.time(),s_end,'','',s_status)
       self.kalendriID = too_syndmus.id

       REQUEST.RESPONSE.redirect('../kodutoodeLoetelu')
         
         
     def kysiPealkiri(self, REQUEST):
       "Antakse kui on"
       if hasattr(self, 'pealkiri'):
         return self.pealkiri
       return "pealkirjata"
                
       
class KodutoodeKataloog(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     tooNr=0
     hindeTahised=["A", "B", "C", "D", "E", "F"]
     hindePiirid=[90, 80, 70, 60, 50]
     
     def kodutoodeTyypideLoetelu(self, REQUEST):
       "Tbid koos nimedega"
       self.get_lang(('ivatasks',),REQUEST)
       t=[REQUEST['L_ia_quiz'], REQUEST['L_ia_product'], REQUEST['L_ia_grpwork'], REQUEST['L_ia_presentn']]
       return t

     def kodutooLisamiseVorm(self, REQUEST):
       "Sisestamine"
       self.get_lang(('ivatasks',),REQUEST)
       t=self.hdr(self, REQUEST)
       t=t+"<h3>"+REQUEST['L_ia_adding_task']+"</h3>"
       t=t+"<form action='kodutooLisamiseLeht'>"
       t=t+"<table border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
       t=t+"<tr><td class='t1'>"+REQUEST['L_ia_type']+"</td><td class='t1'><select name='tyyp'>"
       tyybid=self.kodutoodeTyypideLoetelu(REQUEST)
       for i in range(len(tyybid)):
         t=t+"<option value='%d'>%s</option>\n" % (i, tyybid[i])      
       t=t+"</select></td></tr>\n"     
       t=t+"</table><input type='submit' value='"+REQUEST['L_ia_add']+"' />"
       t=t+"</form>"+self.fle_html_footer(self, REQUEST)
       return t
       
     def lisaKodutoo(self, REQUEST, tyyp):
       "Luuakse vastava tbiga kodut ja vljastatakse selle eksemplar"
       self.tooNr=self.tooNr+1
       id='too'+str(self.tooNr)
       too=Kodutoo(REQUEST, tyyp)
       too.id=id
       self._setObject(too.id, too)
       return too
       
     def kodutooLisamiseLeht(self, REQUEST):
       "Andmete salvestus"
       too=self.lisaKodutoo(REQUEST, REQUEST.tyyp)
#       self.tooNr=self.tooNr+1
#       id='too'+str(self.tooNr)
#       too=Kodutoo(REQUEST, REQUEST.tyyp)
#       too.id=id
#       self._setObject(too.id, too)
#       return too.id
       REQUEST.RESPONSE.redirect(self.absolute_url()+'/'+too.id+'/muutmisVorm')
       
     def kodutoodeLoetelu(self, REQUEST):
       "Nii nagu nimi tleb"
       self.get_lang(('ivatasks',),REQUEST)
       t=self.hdr(self, REQUEST)+"<br />"
       t+="</p><table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"#EEEEEE\">\n"
       t+="  <tr>\n"
       t+="    <td width=\"30\" align=\"center\"><img src=\"images/transparent_gif\"\n"
       t+="    alt=\"\" height=\"20\" width=\"20\" border=\"0\" /></td>\n"
       t+="    <td><a href=\"kodutooLisamiseVorm\" class=\"link2\">"+REQUEST['L_ia_addtask']+"</a></td>\n"
       t+="    <td><a href='"+self.aq_parent.absolute_url()+"/kasutajateHinneteTabel'>"+REQUEST['L_ia_grading']+"</a></td>\n"
       t+="  </tr>\n</table>\n\n"
       t+="<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
       t+="<tr>\n<td><img src=\"images/transparent_gif\" height=\"8\" width=\"10\" alt=\"\" /></td>\n"
       t+="</tr>\n</table>\n\n"

       t+="<form action='kodutoodeTootlus'>"
       t+="<table width='100%' border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       t+="  <tr>\n"
       t+="<th>&nbsp;</th><th>"+REQUEST['L_ia_title']+"</th><th>"+REQUEST['L_ia_type']+"</th><th>"+REQUEST['L_ia_points']+"</th></tr>\n"
       m=self.objectValues()
       normPunktiSumma=0
       tyybid=self.kodutoodeTyypideLoetelu(REQUEST)
       for x in m:
         t+="<tr>"
         t+="<td class=\"t1\"><input type='checkbox' name='tooID' value='%s' /></td>" % x.id
         t+="<td class=\"t1\"><a href='"+x.absolute_url()+"/muutmisVorm'>"+x.kysiPealkiri(REQUEST)+"</a></td>"
         t+="<td class=\"t1\">"+tyybid[x.tyyp]+"</td>"
         t+="<td class=\"t1\">"+str(x.normPunkte)+"</td>"
         t+="</tr>\n"
         normPunktiSumma+=x.normPunkte
       t+="</table><br />"
       t+=REQUEST['L_ia_total']+str(normPunktiSumma)+"<br />"

       t+="<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
       t+="  <tr>\n"
       t+="    <td><input type='submit' name='kustuta' value='"+REQUEST['L_ia_delete']+"'></td>\n"
       t+="  </tr>\n</table>\n"

       t+="<p><table border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n<tr>\n"
       t+="<th>"+REQUEST['L_ia_grade_labels']+"</th><th>"+REQUEST['L_ia_grade_percent']+"</th><th>"+REQUEST['L_ia_points']+"</th>"
       t+="</tr>\n"
       koef=self.normpunktideSumma(REQUEST)/100.0
       for i in range(len(self.hindePiirid)+5):
         if i<len(self.hindePiirid):
           t+="<tr><td class='t1'><input type='text' size='5' name='hindeTahis' value='"+self.hindeTahised[i]+"'></td><td class='t1'><input type='text' size='5' name='hindePiir' value='"+str(self.hindePiirid[i])+"' /> </td><td class='t1'>"+str(koef*self.hindePiirid[i])
         else:
          if i<len(self.hindeTahised):
           t+="<tr><td class='t1'><input type='text' size='5' name='hindeTahis' value='"+self.hindeTahised[i]+"'></td><td class='t1'><input type='text' size='5' name='hindePiir'  /> <td class='t1'>&nbsp;</td>"
          else:
           t+="<tr><td class='t1'><input type='text' size='5' name='hindeTahis'></td><td class='t1'><input type='text' size='5' name='hindePiir' /><td class='t1'>&nbsp;</td>"
         t+="</td></tr>"
          
       t+="</table></p>"
       t+="<input type='submit' name='salvesta' value='"+REQUEST['L_ia_submit']+"' />"
       t+="</form>"
       t+self.fle_html_footer(self, REQUEST)
       return t       

     def kodutoodeTootlus(self, REQUEST, kustuta='', salvesta='', tooID=()):
       "Toiming vastavalt nupule"
       if kustuta:
         if type(tooID)==types.StringType:
           tooID=(tooID,)
         for x in tooID:
           self._delObject(x)
       if salvesta:
         self.hindeTahised=[]
         self.hindePiirid=[]
         kokku=len(REQUEST.hindePiir)
         veel=1
         i=0
         while veel and i<kokku:
           try:
#             print i
             self.hindeTahised.append(REQUEST.hindeTahis[i])
             self.hindePiirid.append(float(re.sub(',', '.', REQUEST.hindePiir[i])))
#             if (i>0) and (self.hindePiirid[i]<=self.hindePiirid[i-1]):
#               veel=0
           except:
             veel=0
           i=i+1
                    
       REQUEST.RESPONSE.redirect('kodutoodeLoetelu')
       
     def normpunktideSumma(self, REQUEST):
       "Kataloogis olevate tde normpunktide summa"
       summa=0
       for x in self.objectValues():
         summa+=x.normPunkte
       return summa
       

     def punktideleVastavHinne(self, REQUEST, punkte):
       "Arvutatakse this punktide jrgi"
       self.get_lang(('ivatasks',),REQUEST)
       if not hasattr(self, 'hindePiirid'): return REQUEST['L_ia_noscale']
       if len(self.hindePiirid)==0: return REQUEST['L_ia_nogrades']
       if self.normpunktideSumma(REQUEST)<=0:
         return ""
       protsent=float(punkte)*100/self.normpunktideSumma(REQUEST)
       i=0
       while i<len(self.hindePiirid):
         if protsent >= self.hindePiirid[i]:
           return self.hindeTahised[i]
         i+=1
       if i<len(self.hindeTahised):
         return self.hindeTahised[i]
       return REQUEST['L_ia_failed']
         

class KodutooHinnang(
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Kodut kommenteeritud andmete hoidla"
     
     def __init__(self, opetajaPunkte, kommentaar):
       "Loomine"
       self.opetajaPunkte=opetajaPunkte
       self.kommentaar=kommentaar
       
     def kysiOpetajaPunkte(self, REQUEST):
       "Vljastus"
       return self.opetajaPunkte
       
     def kysiKommentaar(self, REQUEST):
       "Vljastus"
       return self.kommentaar
       
     
