import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml
#import TestiYlesanne
#from TestiYlesanne import TestiYlesanne

class YlesandeKirjeldus(
     Persistent,
     OFS.SimpleItem.Item,
     Traversable,
     AccessControl.Role.RoleManager
     ):
     "Testi lesande metadata"
     meta_type="YlesandeKirjeldus"
     marksonad=[]
     selgitus=""
     def kasLeidubMarksona(self, sona):
        "1, kui vastav mrksna olemas"
        return sona in self.marksonad
        
     def lisaMarksona(self, sona):
        "Kui mrksna puudub, siis lisatakse"
        if not self.kasLeidubMarksona(sona):
           self.marksonad.append(sona)
           
     def leivaPuru(self, viimane=0):
        "Teekond les"
        return self.aq_parent.leivaPuru()+" &gt; kirjeldus"
           
     def muutmisVorm(self, REQUEST):
        "Vorm kirjelduse muutmiseks"
        tulemus=leheAlgus(self, REQUEST)+"<form action='muutmisLeht'><table><tr><td>Selgitus:</td>"+\
          ("<td><input type='text' name='selgitus' value='%s' /></td></tr>" % self.selgitus)
        for x in self.marksonad:
          tulemus=tulemus+"\n<tr><td>Marksona</td><td>"+\
             ("<input type='text' name='marksona' value='%s'/></td></tr>" % x)
        tulemus=tulemus+"\n<tr><td>Marksona</td><td>"+\
          ("<input type='text' name='marksona' value=''/></td></tr>")+\
          "<tr><td colspan='2' align='center'><input type='submit' value='Salvesta' /></td></tr></table></form>"
        return tulemus+leheLopp(self, REQUEST)
        
     def muutmisLeht(self, REQUEST, selgitus, marksona):
        "Muutuste salvestus"
        self.selgitus=selgitus
        if type(marksona) is None:
           marksona=()
        if type(marksona) is types.StringType:
           marksona=(marksona,)
        self.marksonad=[]
        for x in marksona:
           if x.strip():
             self.lisaMarksona(x)
        REQUEST.RESPONSE.redirect('muutmisVorm')
           
     def index_html(self):
        "Veebi nha olev osa"
        return self.selgitus+" "+str(self.marksonad)
           
        
     
class YlesanneKoosKirjeldusega(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Hoiab lesande oma kirjeldusega koos"
     def __init__(self, ylesanne, kirjeldus=YlesandeKirjeldus()):
        self._setObject('ylesanne', ylesanne)
        self._setObject('kirjeldus', kirjeldus)
        
     def lisaMarksona(self, sona):
        "Lisab kirjelduse alla sealt puuduva mrksna"
        self.kirjeldus.lisaMarksona(sona)
        
     def marksonadHTML(self):
        "Mrksnad jadana"
        return asendaHTML(str(self.kirjeldus.marksonad))
        
     def selgitusHTML(self):
        "Selgitus"
        return asendaHTML(self.kirjeldus.selgitus)
        
     def leivaPuru(self, viimane=0):
       "Teekond les"
       nimi=self.id
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'">nimi+"</a>"
       return self.aq_parent().leivaPuru()+ " &gt; Kirjeldusega lesanne " + tekst        
        
     def index_html(self):
        "Peegel veebis"
        return leheAlgus(self, REQUEST)+self.ylesanne.esitlusHTML() +\
           self.marksonadHTML()+self.selgitusHTML()+leheLopp(self, REQUEST)
        
        
     
     
class TestiYlesanneteHoidla(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft):
     "Hoidla petaja tarvis"
     #elemendid=[]
     nr=0
     
     def elemendidHoidlas(self):
        "Hoidlas olevad lesanded koos kirjeldustega"
        return self.objectValues()

     def kasYlesannePuudub(self, ylesanne):
        "1 kui vastavate vljadega lesanne puudub"
        return ylesanne not in self.ylesandedHoidlas()
     
     def lisaYlesanneKoosKirjeldusega(self, element):
        "lesanne lisatakse puudumise korral"
        if self.kasYlesannePuudub(element.ylesanne):
           self.nr=self.nr+1
           element.id='el'+str(self.nr)
           self._setObject(element.id, element)
           #elemendid.append(element)
        
     def lisaYlesanne(self, ylesanne):
        "Vaid lesande lisamine, kirjeldus thi"
        self.lisaYlesanneKoosKirjeldusega(YlesanneKoosKirjeldusega(ylesanne))
     
     
     def ylesandedHoidlas(self):
        "Hoidlast vaid lesanded, mitte kirjeldused."
        return [x.ylesanne for x in self.elemendidHoidlas()]
        
     
     def marksonadHoidlas(self):
        "Mrksnad kikide lesannete peale kokku"
        marksonad=[]
        for x in self.elemendidHoidlas():
          if x.kirjeldus:
            for k in x.kirjeldus.marksonad:
              if k not in marksonad:
                marksonad.append(k)
        return marksonad
        
     def marksonaViideteLoetelu(self, REQUEST):
        "Viited leiduvatele mrksnadele"
        m=self.marksonadHoidlas()
        #m.sort()
        if m is None:
          return "Thi mrksnastik"
        tulemus=leheAlgus(self, REQUEST)+"<h3>Marksonad</h3>"
        for x in m:
          tulemus=tulemus+"\n"+\
            "<a href='ylesandedTabelina?marksona="+x+"'>"+x+"</a><br />"
        return tulemus+leheLopp(self, REQUEST)

     def kasLeidubMarksona(self, sona):
        "Kas vastav mrksna hoidlas olemas"
        return sona in self.marksonadHoidlas()
        
     def marksonaleVastavadElemendid(self):
        "Vaid soovitud mrksnaga elemendid"
        elemendid=[]
        for x in self.ylesandedHoidlas():
          if sona in x.kirjedus.marksonad:
             elemendid.append(x)
        return elemendid


     def lisaYlesandedTestist(self, test):
        "Lisatakse vaid kordumatud lesanded"
        for x in test.ylesanded():
           self.lisaYlesanne(x)
           
     def ylesandedTabelina(self, REQUEST, marksona=None):
        "lesanded ja nende kirjeldused tutvustava tabelina"
        if marksona is None:
          m=self.elemendidHoidlas()
        else:
          m=self.marksonaleVastavadElemendid(marksona)
        tulemus=leheAlgus(self, REQUEST)+"<table>"
        for x in m:
          tulemus=tulemus+"\n<tr><td>"+x.ylesanne.esitlusHTML()+"<td>"+\
            "<td>"+x.ylesanne.vaatamineHTML()+"</td>"+\
            "<td>"+x.marksonadHTML()+"</td>"+\
            "<td>"+x.selgitusHTML()+"</td>"+\
            "<td>"+x.ylesanne.meta_type+"</td></tr>"
        tulemus=tulemus+"</table>\n<br />"+self.marksonaViideteLoetelu()
        return tulemus+leheLopp(self, REQUEST)


     def ylesandedMuutmisTabelina(self, REQUEST):
        "lesanded koos viidetega kustutamiseks ja muutmiseks"
        tulemus=leheAlgus(self, REQUEST)+\
        "<form action='kustuta_leht'><table>"
        for x in self.elemendidHoidlas():
          tulemus=tulemus+"\n<tr><td>"+x.ylesanne.esitusHTML()+"<td>"+\
            "<td>"+x.ylesanne.vaatamineHTML()+"</td>"+\
            "<td>"+x.marksonadHTML()+"</td>"+\
            "<td>"+x.selgitusHTML()+"</td>"+\
            "<input type='checkbox' name='kustuta' value='"+x.id+"' />"+"</td>"+\
            "<td><a href='"+x.id+"/ylesanne/muutmisVorm'>lesanne</a><a href='"+x.id+"/kirjeldus/muutmisVorm'>Kirjeldus</a></td>"+\
            "</tr>"
        tulemus=tulemus+"</table><input type='submit' value='Kustuta' /></form>"+\
           "\n<br /><a href='ylesanneteTyypideLoetelu'>Lisa lesanne</a>"
        return tulemus+leheLopp(self, REQUEST)
        
     def kustuta_leht(self, REQUEST, kustuta=None):
        "lesannete kustutamise leht"
        if kustuta is None:
           kustuta=()
        if type(kustuta) is types.StringType:
           kustuta=(kustuta,)
        for x in kustuta:
           self._delObject(x)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
        
     def ylesanneteTyypideLoetelu(self, REQUEST):
        "Vljakutse"
        return leheAlgus(self, REQUEST)+TestiYlesanne().ylesanneteTyypideLoetelu()+leheLopp(self, REQUEST)
        
     def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande lisamine" 
        yl=TestiYlesanne().lisaUusYlesanne(tyyp)
        self.lisaYlesanne(yl)
        #REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        REQUEST.RESPONSE.redirect(yl.absolute_url()+"/muudaVorm?liikumisURL="+self.absolute_url())
        
     def leivaPuru(self, viimane=0):
        "Teekond les"
        nimi="lesannete hoidla"
        if viimane:
          tekst=nimi
        else:
          tekst="<a href='"+self.absolute_url()+"'">nimi+"</a>"
        return " &gt; "+tekst
                          
     def index_html(self, REQUEST):
        "Peegel veebis"
        return self.ylesandedTabelina(REQUEST)

