import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
import time
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml
#import TestiYlesanne
import YlVahendus
from YlVahendus import YlVahendus
#from TestiYlesanne import TestiYlesanne
     
        
                   
class YlTest(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
    "lesannetest koosnev test"
    meta_type='YlTest'
    pealkiri=""
    nr=0
    avatudTaitmiseks=0
    juhuslikJarjekord=0
    
    security=ClassSecurityInfo()
    security.declareObjectPublic()
    
    
    def __init__(self):
       "Alustus"
       self.koigiLuba=LahendusLuba()
       self.koigiLuba.id='koigiLuba'
       self.grupiLoad=LahendusLoad()
       self.grupiLoad.id='grupiLoad'
       self.isikuLoad=LahendusLoad()
       self.isikuLoad.id='isikuLoad'
       self.vahendus=YlVahendus()
       self.vahendus.id='vahendus'
      
    def lisaYlesanne(self, yl):
       "uus lesanne testis"
       if yl is None: return
       self.nr=self.nr+1
       yl.id="yl"+str(self.nr)
       tulem = self._setObject(yl.id, yl)
       return tulem 
       
    def lisaYlesanded(self, ylmassiiv):
       "Lisatakse lesannete massiiv"
       for x in ylmassiiv:
         self.lisaYlesanne(x)
         
    def ylesandedTekstina(self):
       "Vljastab lesanded HotPotatos ekspordina"
       tulemus=""
       yl=self.ylesanded()
       for i in range(len(yl)):
         tulemus=tulemus+yl[i].kirjutaYlesanneTekstiks(self.pealkiri, i+1)
       return tulemus
       
    def kysimused(self):
       "Ksimuste loetelu"
       k=[]
       for x in self.ylesanded():
         k.append(x.kysimus)
       return k
       
    def ylesanded(self):
       "lesannete loetelu"
       return self.objectValues()
     
    def annaPealkiri(self):
       "Testi nimi"
       try:
         if len(self.pealkiri)>0:
           return self.pealkiri    
         return self.getId()
       except:
         return self.getId()
         
    def pealkiriHTML(self, REQUEST):
       "Pealkiri HTMLina"
       return asendaHTML(self.annaPealkiri())

    def pealkirjaEsitlus(self, REQUEST):
       "Nimi mens"
       if self.pealkiriHTML(REQUEST)!="":
         return self.pealkiriHTML(REQUEST)
       else:
         return self.getId()
         
    def seaPealkiri(self, pealkiri):
       "Pealkirja salvestus"
       self.pealkiri=pealkiri
       
    def annaKirjeldus(self):
       "Testi kirjeldus"
       if hasattr(self, 'kirjeldus'):
         return self.kirjeldus
       return ""
    
    def seaKirjeldus(self, kirjeldus):
       "Kirjelduse salvestus"
       self.kirjeldus=kirjeldus
       
    def kirjeldusHTML(self, REQUEST):
       "Kirjeldus HTMLina"
       return asendaHTML(self.annaKirjeldus())
       
       
    def pealkirjaMuutmisVormHTML(self, REQUEST, liikumisURL):
       "Leht pealkirja muutuse sisestuseks"
       tulemus=leheAlgus(self, REQUEST)
       tulemus=tulemus+self.pealkirjaMuutmisVorm(REQUEST, liikumisURL)
       tulemus=tulemus+leheLopp(self, REQUEST)
       return tulemus
       
    def pealkirjaMuutmisVorm(self, REQUEST, liikumisURL=""):
       "Vorm pealkirja, kirjelduse ja tbi muutmiseks"
       self.get_lang(('ivatests',), REQUEST)
       t= "<h2>"+REQUEST['L_it_editing_settings']+"</h2><form action='pealkirjaMuutmisLeht'>"
       t+="<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
       t+="<tr><td class='t1' width='25%'>"+REQUEST['L_it_quiz_title']+"</td><td class='t1'><input type='text' name='pealkiri' value='"
       t+=self.annaPealkiri()+"' /></td></tr>\n"
       t+="<tr><td class='t1'>"+REQUEST['L_it_quiz_descr']+"</td><td class='t1'><textarea name='kirjeldus'>"
       t+=self.kirjeldusHTML(REQUEST)+"</textarea></td></tr>\n"
       t+="<tr><td class='t1'>"+REQUEST['L_it_quiz_type']+"</td><td class='t1'><select name='tyyp'>"
       m=self.kysiTyypideNimed(REQUEST)
       for i in range(len(m)):
        if i==self.kysiTyyp(REQUEST):
         t+="<option value='"+str(i)+"' selected='SELECTED'>"+m[i]+"</option>\n"        
        else:
         t+="<option value='"+str(i)+"'>"+m[i]+"</option>\n"
       t+="</select></td></tr>"
       t+="<tr><td class='t1'>"+REQUEST['L_it_test_randomize']+"</td><td class='t1'><input type='checkbox' name='juhujarjestus' "
       if self.kasKysimusteJuhuslikJarjekord():
         t+=" checked='CHECKED' "
       t+=" /></td></tr>"
       t+="<tr><td class='t1'>"+REQUEST['L_it_ca_visible']+"</td><td class='t1'><select name='nahtavus'>"
       m=self.vastusteNahtavusedTekstina(REQUEST)
       for i in range(len(m)):
         t+="<option value='"+str(i)+"'"
         if i==self.kysiVastusteNahtavus():
           t+=" selected='SELECTED' "
         t+=">"+m[i]+"</option>\n"
       t+="</td></select>"

       t+="<tr><td class='t1' colspan=\"2\"><br /><h3>"+REQUEST['L_it_description_of_permissions']+":</h3></td></tr>"
       t+="<tr>"
       t+="<td class='t1' colspan=\"2\"><input type=\"radio\" value=\"suletud\" name=\"testipass\" "
       if len(self.grupiLoad.objectValues())==0 and self.koigiLuba.algusAeg==-1 and len(self.isikuLoad.objectValues())==0:
          t+="checked=\"checked\">&nbsp;"
       else:
          t+=">&nbsp;"
       t+=REQUEST['L_it_notpublic']+"</td></tr>"
	# j2rgmine
       t+="<tr>"
       t+="<td class='t1' colspan=\"2\"><input type=\"radio\" value=\"ajapiirang\" name=\"testipass\" "
       if self.koigiLuba.algusAeg!=-1:
          t+="checked=\"checked\">&nbsp;"
       else:
          t+=">&nbsp;"
       t+=REQUEST['L_it_for_all']+" "+REQUEST['L_it_timelimit']+"&nbsp;"
       if self.koigiLuba.algusAeg!=-1:
          t+="<a href=\"koigiLuba?liikumisURL="+self.fle_root().absolute_url()+'/testihaldus/'+"\">"+REQUEST['L_it_restrictions']+"</a>"
       t+="</td></tr>"
	#J2rgmine
       t+="<tr>"
       t+="<td class='t1' colspan=\"2\"><input type=\"radio\" value=\"sisegr\" name=\"testipass\" "

       if len(self.grupiLoad.objectValues())!=0:
          t+="checked=\"checked\">&nbsp;"
       else:
          t+=">&nbsp;"
       t+=REQUEST['L_it_for_subgroups']+"&nbsp;"
       if len(self.grupiLoad.objectValues())!=0:
          t+="<a href=\"grupiLubadeLisamisVorm\">"+REQUEST['L_it_restrictions']+"</a>" 
       t+="</td></tr>"
       #J2rgmine
       t+="<tr>"
       t+="<td class='t1' colspan=\"2\"><input type=\"radio\" value=\"isikuline\" name=\"testipass\" "

       if len(self.isikuLoad.objectValues())!=0:
          t+="checked=\"checked\">&nbsp;"
       else:
          t+=">&nbsp;"
       t+=REQUEST['L_it_for_persons']+"&nbsp;"
       if len(self.isikuLoad.objectValues())!=0:
          t+="<a href=\"isikuLubadeLisamisVorm\">"+REQUEST['L_it_restrictions']+"</a>"
       t+="</td></tr>"
       t+="</table>"

       t+="<table width='100%' border='0' cellpadding='0' cellspacing='0' bgcolor='#EEEEEE'>\n <tr>\n   <td>"
       t+="   <input type='submit' value='"+REQUEST['L_it_save_title']+"' />"+\
         "<input type='hidden' name='liikumisURL' value='"+liikumisURL+"'>\n"
       t+="   </td>\n </tr>\n</form>"
       return t
         
    def pealkirjaMuutmisLeht(self, REQUEST, pealkiri, kirjeldus, tyyp, nahtavus, liikumisURL="", juhujarjestus='', testipass=''):
       "Pealkirja salvestus"
       if testipass:
          self.seaPass(testipass, REQUEST)
       self.seaPealkiri(pealkiri)
       self.seaKirjeldus(kirjeldus)
       self.seaTyyp(REQUEST, int(tyyp))
       self.seaKysimusteJuhuslikJarjekord(juhujarjestus)
       self.seaVastusteNahtavus(nahtavus)
       if liikumisURL=='':
         liikumisURL='ylesandedMuutmisTabelina';
       REQUEST.RESPONSE.redirect('pealkirjaMuutmisVormHTML?liikumisURL='+liikumisURL)
#       REQUEST.RESPONSE.redirect(liikumisURL)
     
    def seaPass(self,testipass, REQUEST):
	# closing test
	if testipass!='koigile':
		self.avatudTaitmiseks=0
	if testipass!='ajapiirang':
		self.koigiLuba.algusAeg=-1
	if testipass!='sisegr':
		for x in self.grupiLoad.nimedeLoetelu():
			self.grupiLoad._delObject(x)
	if testipass!='isikuline':
		for x in self.isikuLoad.nimedeLoetelu():
			self.isikuLoad._delObject(x)
	# seting permissions
	if testipass=='koigile':
		self.avatudTaitmiseks=1
		pass
	if testipass=='ajapiirang':
		self.prooviRegistreeridaTestKodutooks(REQUEST)
		import time
		if self.koigiLuba.algusAeg==-1:
			self.koigiLuba.algusAeg=time.time()
			self.koigiLuba.loppAeg=time.time()+3000000
		print testipass
		pass
	if testipass=='sisegr':
		if len(self.grupiLoad.objectValues())==0:
			dummy = LahendusLuba()
			dummy.id = 'DuMmY67891'
			self.grupiLoad._setObject(dummy.id, dummy)
		print testipass
		pass
	if testipass=='isikuline':
		if len(self.isikuLoad.objectValues())==0:
			dummy = LahendusLuba()
			dummy.id = 'DuMmY67891'
			self.isikuLoad._setObject(dummy.id, dummy)
		print testipass
		pass
	return
     
    def kysiVastusteNahtavus(self):
      "Teatatakse kood, millal ppur vib testi lahendusi nha"
      if hasattr(self, 'vastusteNahtavus'):
        return self.vastusteNahtavus
      return 0
      
    def seaVastusteNahtavus(self, kood):
      "Salvestus"
      self.vastusteNahtavus=int(kood)
      
    def vastusteNahtavusedTekstina(self, REQUEST):
      "Massiiv nimetustega"
      m=[REQUEST['L_it_ca_onclosing'], REQUEST['L_it_ca_always'], REQUEST['L_it_ca_never']]
      return m
      
    def jooksevNahtavusTekstina(self, REQUEST):
      "Praegune seisund"
      m=self.vastusteNahtavusedTekstina(REQUEST)
      return m[self.kysiVastusteNahtavus()]
      
    def kasLubatudLahendusiVaadata(self, REQUEST):
      "Kas konkreetsel kasutajal on igus oma lahenduste tulemusi nha"
      kood=self.kysiVastusteNahtavus()
      if kood==2: return 0
      if kood==1: return 1
      if kood==0: 
        return not self.kasLubatudLahendada(REQUEST)
        
    def kasKirjasKodutoona(self, REQUEST):
      "Kas test asub juba kodutde loetelus"
      m=self.aq_parent.kodutood.objectValues()
      leidub=0
      for x in m:
        if x.tyyp==0:
          if hasattr(x, 'testiID'):
            if x.testiID==self.id:
              leidub=1
      return leidub
             
    def prooviRegistreeridaTestKodutooks(self, REQUEST):
      "Registreeritakse juhul, kui tbiks on test ning vastav test pole veel kodutoo"
      if self.kasKirjasKodutoona(REQUEST): return 0
      if self.kysiTyyp(REQUEST)!=0: return 0
      too=self.aq_parent.kodutood.lisaKodutoo(REQUEST, 0)
      too.pealkiri=self.annaPealkiri()
      too.testiID=self.id
      return 1
       
       
    def ylesanneteArv(self):
       "lesannete arv"
       return len(self.ylesanded())
       
    def tutvustus(self):
       "Testi tutvutus"
       return "Lahendamiseks meldud test"
       
    def kasKysimusteJuhuslikJarjekord(self):
       "Kas lahendamisel jrjestatakse ksimused juhuslikult"
       if hasattr(self, 'juhuslikJarjekord'):
         return self.juhuslikJarjekord
       return 0
       
    def seaKysimusteJuhuslikJarjekord(self, jarjekord):
       "Muutuja seadmine"
       if jarjekord:
         self.juhuslikJarjekord=1
       else:
         self.juhuslikJarjekord=0
       return str(self.juhuslikJarjekord)
       
    def muudaKysimusteJuhuslikJarjekord(self):
      "Jrjekorra muutmine"
      if self.kasKysimusteJuhuslikJarjekord():
        self.seaKysimusteJuhuslikJarjekord(0)
      else:
        self.seaKysimusteJuhuslikJarjekord(1)
      return str(self.kasKysimusteJuhuslikJarjekord())
        

    def kasLubatudLahendada(self, REQUEST):
      "Arvutus lubade kaudu"
      try:
       if self.kasAvatudTaitmiseks()==1: return 1
       n=self.lahendusKordadeArv(REQUEST)
       if self.koigiLuba.kasLubatudLahendada(REQUEST, n):return 1
       if hasattr(self.isikuLoad, str(REQUEST.AUTHENTICATED_USER)):
         if getattr(self.isikuLoad, str(REQUEST.AUTHENTICATED_USER)).kasLubatudLahendada(REQUEST, n):
           return 1
       for x in self.find_course().sisegrupid.objectValues():
         m=x.get_local_roles()
         leitud=0
         for t in m:
          if t[0]==str(REQUEST.AUTHENTICATED_USER):
            leitud=1
         if leitud:
           try:
            if hasattr(self.grupiLoad, x.id):
             if getattr(self.grupiLoad, x.id).kasLubatudLahendada(REQUEST, n):
                return 1
           except:
             pass
       return 0
      except:
       return 1
        
    def kasLubatudLahendadaTekst(self, REQUEST):
      "Abifunktsioon"
      return str(self.kasLubatudLahendada(REQUEST))
       
#    def lubadeViited(self, REQUEST):
#       "Viited lubadele"
#       self.get_lang(('ivatests',), REQUEST)
#       tulemus=leheAlgus(self, REQUEST)+"<h3>"+REQUEST['L_it_description_of_permissions']+"</h3><form action='lubadeKustutusLeht'><ul>"
#       tulemus=tulemus+"<li>"
#       if self.avatudTaitmiseks==1:
#         tulemus=tulemus+"<input type='checkbox' name='chkavatudtaitmiseks' /> "
#       else:
#         tulemus=tulemus+"<a href='lubaKoigileTaita'>"+REQUEST["L_it_open_test"]+"</a>"
#       tulemus=tulemus+REQUEST["L_it_opened_for_all"]+": "
#       if self.avatudTaitmiseks==1:
#         tulemus=tulemus+" + "
#       else:
#         tulemus=tulemus+" - "
#       tulemus=tulemus+"</li>"
#       tulemus=tulemus+"<li>"
#       if self.koigiLuba.algusAeg!=-1:
#         tulemus=tulemus+"<input type='checkbox' name='chkkoigiluba' />"
#       tulemus=tulemus+"<a href='koigiLuba'>"+REQUEST['L_it_all_permission']+"</a>"+\
#         self.koigiLuba.loaAndmedTekstina(REQUEST)+"</li>"+\
#         "<li>"+REQUEST['L_it_inner_groups_permission']
#       if self.kasLeidubLoataGruppe():
#         tulemus=tulemus+", <a href='grupiLubadeLisamisVorm'>"+REQUEST["L_it_add_group_permission"]+"</a>"
#       tulemus=tulemus+"</li><ul>"
#       for x in self.grupiLoad.objectValues():
#         tulemus=tulemus+"\n<li><input type='checkbox' name='grupp"+x.id+"' /><a href='"+x.absolute_url()+"'>"+x.id+"</a>"+x.loaAndmedTekstina(REQUEST)+"</li>"
#       tulemus=tulemus+"</ul><li>"+REQUEST['L_it_user_permission']
#       if self.kasLeidubLoataIsikuid():
#         tulemus=tulemus+", <a href='isikuLubadeLisamisVorm'>"+REQUEST["L_it_add_personal_permission"]+"</a>"	
#       tulemus=tulemus+"</li><ul>"
#       for x in self.isikuLoad.objectValues():
#         tulemus=tulemus+"\n<li><input type='checkbox' name='isik"+x.id+"' /><a href='"+x.absolute_url()+"'>"+x.id+"</a>"+x.loaAndmedTekstina(REQUEST)+"</li>"
#       tulemus=tulemus+"</ul><input type='submit' value='"+REQUEST["L_it_delete_permission"]+"' /></form>"+leheLopp(self, REQUEST)
#       return tulemus
       
    def lubadeKustutusLeht(self, REQUEST):
      "Lubade eemaldamine"
      isikud = 0
      grupid = 0
      if hasattr(REQUEST, 'chkavatudtaitmiseks'):
         self.avatudTaitmiseks=0
      if hasattr(REQUEST, 'chkkoigiluba'):
         self.koigiLuba.algusAeg=-1
      for x in self.isikuLoad.nimedeLoetelu():
        if hasattr(REQUEST, 'isik'+x):
          self.isikuLoad._delObject(x)
          isikud = 1
      for x in self.grupiLoad.nimedeLoetelu():
        if hasattr(REQUEST, 'grupp'+x):
          self.grupiLoad._delObject(x)
          grupid = 1
      if isikud:
         REQUEST.RESPONSE.redirect('isikuLubadeLisamisVorm')
      if grupid:
         REQUEST.RESPONSE.redirect('grupiLubadeLisamisVorm')
      
    def lubaKoigileTaita(self, REQUEST):
       "igus pidevalt tita"
       self.seaAvatudTaitmiseks(1, REQUEST)
       self.prooviRegistreeridaTestKodutooks(REQUEST)
       REQUEST.RESPONSE.redirect('lubadeViited')
        
       
    def kasLeidubLoataIsikuid(self):
       "jah/ei"
       return len(self.find_course().get_all_users_id())>len(self.isikuLoad.nimedeLoetelu())

    def isikuLubadeLisamisVorm(self, REQUEST):
	""" Valida, kellel lubada """
	self.get_lang(('ivatests',),REQUEST)
	tulemus=leheAlgus(self, REQUEST)
	on_tulemust = 0
	isikud=self.find_course().get_all_users_id()
	loagaIsikud=self.isikuLoad.nimedeLoetelu()
	tulemus += "<form action=\"lubadeKustutusLeht\">"
	for luba in self.isikuLoad.objectValues():
		if luba.id == 'DuMmY67891':
			continue
		tulemus += "<br /> <input type=\"checkbox\" name=\"isik"+luba.id+"\" /><a href=\""+luba.absolute_url()+"?liikumisURL="+self.absolute_url()+"/isikuLubadeLisamisVorm\">"+luba.id+"</a>"+luba.loaAndmedTekstina(REQUEST)
		on_tulemust = 1
	if on_tulemust:
		tulemus += "<br /><input type=\"submit\" value=\""+REQUEST["L_it_delete_permission"]+"\" />"
	tulemus += "</form>"	
	tulemus += "<form action=\"isikuLubadeLisamisLeht\">"
	siit_tulemust = 0
	for luba in isikud:
		if luba in loagaIsikud:
			continue
		tulemus += "<br />\n<input type='checkbox' name='nimed' value='"+luba+"'/>"+luba
		print "kala"
		on_tulemust = 1
		siit_tulemust = 1
	if siit_tulemust:
		tulemus += "<br /><input type='submit' value='"+REQUEST['L_it_add_user_permission']+"' />"
	tulemus += "</form>"
	tulemus += "<br /><a href=\""+self.fle_root().absolute_url()+"/testihaldus/\">Testi haldus</a>"
	tulemus += leheLopp(self,REQUEST)
	if on_tulemust:
		return tulemus
	else:
		pass
              
#    def isikuLubadeLisamisVorm(self, REQUEST):
#       "Valida, kellel lubada"
#       self.get_lang(('ivatests',),REQUEST)
#       tulemus=leheAlgus(self, REQUEST)+"<form action='isikuLubadeLisamisLeht'>"
#       isikud=self.find_course().get_all_users_id()
#       loagaIsikud=self.isikuLoad.nimedeLoetelu()
#       kogus=0
#       for x in isikud:
#          if x not in loagaIsikud:
#            kogus=kogus+1
#            tulemus=tulemus+"<br />\n<input type='checkbox' name='nimed' value='"+x+"'/>"+x               
#       if kogus>0:
#         tulemus=tulemus+"<br /><input type='submit' value='"+REQUEST['L_it_add_user_permission']+"' />"
#       else:
#         tulemus=tulemus+REQUEST["L_it_no_users_without_permission"]
#       return tulemus+"</form>"+leheLopp(self, REQUEST)
       
    def isikuLubadeLisamisLeht(self, REQUEST, nimed=None):
       "Nimede salvestus"
       if nimed is not None:
         if type(nimed) is types.StringType:
           nimed=(nimed,)
         for x in nimed:
           luba=LahendusLuba()
           luba.id=x
           self.isikuLoad._setObject(luba.id, luba)       
       REQUEST.RESPONSE.redirect('isikuLubadeLisamisVorm')
       
    def kasLeidubLoataGruppe(self):
       "jah/ei"
       return len(self.find_course().sisegrupid.objectValues())>len(self.grupiLoad.nimedeLoetelu())
       
    def grupiLubadeLisamisVorm(self, REQUEST):
	""" valida, kellel lubada """
	self.get_lang(('ivatests',), REQUEST)
	tulemus=leheAlgus(self, REQUEST)
	on_tulemust = 0
	grupid = self.find_course().sisegrupid.objectValues()
	loagaGrupid = self.grupiLoad.nimedeLoetelu()
	tulemus += "<form action=\"lubadeKustutusLeht\">"
	for luba in self.grupiLoad.objectValues():
		if luba.id=='DuMmY67891':
			continue
		tulemus += "\n<br /><input type=\"checkbox\" name=\"grupp"+luba.id+"\" /><a href=\""+luba.absolute_url()+"?liikumisURL="+self.absolute_url()+"/grupiLubadeLisamisVorm\">"+luba.id+"</a>"+luba.loaAndmedTekstina(REQUEST)+"</li>"
		on_tulemust = 1
	if on_tulemust:
		tulemus += "<br /><input type=\"submit\" value=\""+REQUEST["L_it_delete_permission"]+"\" />"
	tulemus += "</form>"
	tulemus += "<form action=\"grupiLubadeLisamisLeht\">"
	siit_tulemust = 0
	for luba in grupid:
		if luba.id in loagaGrupid:
			continue
		tulemus += "<br />\n<input type='checkbox' name='nimed' value='"+str(luba.id)+"'/>"+str(luba.id)
		on_tulemust = 1
		siit_tulemust = 1
	if siit_tulemust: 
		tulemus += "<br /><input type=\"submit\" value=\""+REQUEST['L_it_add_group_permission']+"\" />"
	tulemus += "</form>"
	tulemus += "<br /><a href=\""+self.fle_root().absolute_url()+"/testihaldus/\">Testi haldus</a>"
	tulemus += leheLopp(self,REQUEST)
	if on_tulemust:
		return tulemus
	else:
		pass

#    def grupiLubadeLisamisVorm(self, REQUEST):
#       "Valida, kellel lubada"
#       self.get_lang(('ivatests',), REQUEST)
#       tulemus=leheAlgus(self, REQUEST)
#       if self.kasLeidubLoataGruppe():
#        tulemus=tulemus+"<form action='grupiLubadeLisamisLeht'>"
#        grupid=self.find_course().sisegrupid.objectValues()
#        loagaGrupid=self.grupiLoad.nimedeLoetelu()
#        for x in grupid:
#          if x.id not in loagaGrupid:
#            tulemus=tulemus+"<br />\n<input type='checkbox' name='nimed' value='"+str(x.id)+"'/>"+str(x.id)               
#        tulemus=tulemus+"<br /><input type='submit' value='"+REQUEST['L_it_add_group_permission']+"' />"
#        tulemus= tulemus+"</form>"
#       else:
#        tulemus=tulemus+REQUEST["L_it_no_groups_without_permission"]
#       tulemus=tulemus+leheLopp(self, REQUEST)
#       return tulemus
       
    def grupiLubadeLisamisLeht(self, REQUEST, nimed=None):
       "Lahendusloa lisamine grupile"
       if nimed is not None:
         if type(nimed) is types.StringType:
           nimed=(nimed,)
         for x in nimed:
           luba=LahendusLuba()
           luba.id=x
           self.grupiLoad._setObject(luba.id, luba)       
       REQUEST.RESPONSE.redirect('grupiLubadeLisamisVorm')
       
       
    def kustutaLahendusload(self):
       "Kustutatakse lahendusload"
       self.grupiLoad.kustutaKoikLoad()
       self.isikuLoad.kustutaKoikLoad()
       self.koigiLuba.algusAeg=-1
       self.koigiLuba.loppAeg=-1
       self.koigiLuba.kordadeArv=-1
       
    def kasLeidubLubasid(self):
      "Lubade olemasolu otsing"
      if len(self.grupiLoad.objectValues())>0: return 1
      if len(self.isikuLoad.objectValues())>0: return 1
      if self.koigiLuba.algusAeg!=-1: return 1
      return 0
      
      
    def taitmisAvatusSymbol(self, REQUEST):
      "Smbol vastavalt ligipsuseisundile"
      self.get_lang(('ivatests',), REQUEST)
      if self.kasAvatudTaitmiseks()==1:
        #return "<dtml-var L_it_qt_public>"
        return REQUEST['L_it_qt_public'] 
      if self.kasAvatudTaitmiseks()==2:
        #return "<dtml-var L_it_qt_closed>"
        return REQUEST['l_it_qt_closed']
      return REQUEST['L_it_qt_between']

    def kasAvatudTaitmiseks(self):
       "Teatab, kas opilastele on test nahtav"
       try:   
         if self.avatudTaitmiseks:
           return 1
         if self.kasLeidubLubasid(): return 2
         return 0
       except:
         return 0

    def seaAvatudTaitmiseks(self, seisund, REQUEST):
       "Saab oelda, kas avatud"
       if int(seisund)==1:
         self.avatudTaitmiseks=1
       else: 
         self.avatudTaitmiseks=0
         self.kustutaLahendusload()
       #return str(self.avatudTaitmiseks)
       REQUEST.RESPONSE.redirect('index_html')
       
    def muudaAvatudTaitmiseks(self, REQUEST):
       "Vahetab seisundi"
       if self.avatudTaitmiseks==1:
         self.seaAvatudTaitmiseks(0, REQUEST)
       else:
         self.seaAvatudTaitmiseks(1, REQUEST)
       
    def ylesanneteTyypideLoetelu(self, REQUEST):
        "Vljakutse"
        return leheAlgus(self, REQUEST)+self.vahendus.ylesanneteTyypideLoetelu(REQUEST)+leheLopp(self, REQUEST)
        
    def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande lisamine" 
        yl=self.vahendus.lisaUusYlesanne(REQUEST, tyyp)
        self.lisaYlesanne(yl)
        REQUEST.RESPONSE.redirect(self.absolute_url()+"/"+yl.id+"/muutmisVorm?liikumisURL="+self.absolute_url())

    def ylesandedTabelina(self, REQUEST):
        "lesanded tabelina"
        m=self.ylesanded()
        tulemus=leheAlgus(self, REQUEST)+self.pealkirjaEsitlus(REQUEST)+"<table>"
        for x in m:
          tulemus=tulemus+"\n<tr><td>"+x.esitlusHTML(REQUEST)+"<td>"+\
            "<td>"+x.vaatamineHTML(REQUEST)+"</td>"+\
            "<td>"+x.marksonadHTML(REQUEST)+"</td>"+\
            "<td>"+x.ylesanne.ylesandeNimetus(REQUEST)+"</td></tr>"
        tulemus=tulemus+"</table>"
        return tulemus+leheLopp(self, REQUEST)


    def ylesandedMuutmisTabelina(self, REQUEST):
        "lesanded koos viidetega kustutamiseks ja muutmiseks"
        self.get_lang(('ivatests',), REQUEST)
        tulemus=leheAlgus(self, REQUEST)+self.vahendus.ylesanneteTyybidValikuna(REQUEST) 
        if len(self.ylesanded())>0:        
         tulemus=tulemus+"<form action='kustuta_leht'>"
         tulemus=tulemus+"<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
         tulemus=tulemus+"<tr><th>"+REQUEST['L_it_deletion']+"</th><th>"+REQUEST['L_it_question']
         tulemus=tulemus+"</th><th>"+REQUEST['L_it_answer']+"</th><th>"+REQUEST['L_it_type']+"</th><th>"
         tulemus=tulemus+REQUEST['L_it_points']+"</th><th>"+REQUEST['L_it_change']+"</th></tr>"
         for x in self.ylesanded():
          try:
           tulemus=tulemus+"\n<tr>"+\
            "<td class='t1'><input type='checkbox' name='kustuta' value='"+x.id+"' />"+"</td>"+\
            "<td class='t1'>"+x.esitlusHTML(REQUEST)+"</td>"+\
            "<td class='t1'>"+x.vaatamineHTML(REQUEST)+"</td>"+\
            "<td class='t1'>"+x.ylesandeNimetus(REQUEST)+"</td>"+\
            "<td class='t1'>"+x.normPunktidHTML(REQUEST)+"</td>"+\
            "<td class='t1'><a href='"+x.id+"/muutmisVorm?liikumisURL="+self.absolute_url()+"'>"+REQUEST['L_it_change']+"</a></td>"+\
            "</tr>"
          except:
           print "Invalid question"
         tulemus=tulemus+"</table>\n<table width='100%' border='0' cellpadding='2' cellspacing='0' bgcolor='#EEEEEE'>\n"
         tulemus=tulemus+"  <tr><td>\n"
         tulemus=tulemus+"  <input type='submit' value='"+REQUEST['L_it_deletion']+"' /></form>\n"
         tulemus=tulemus+"  </td></tr>\n</table>"
        return tulemus+leheLopp(self, REQUEST)
        


    def kustuta_leht(self, REQUEST, kustuta=None):
        "lesannete kustutamise leht"
        if kustuta is None:
           kustuta=()
        if type(kustuta) is types.StringType:
           kustuta=(kustuta,)
        for x in kustuta:
           self._delObject(x)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
    def ylTyyp(self, REQUEST, ylid):
       "Ksitud ID-ga lesande tp"
       if hasattr(self, ylid):
         return self.ylid.ylesandeNimetus(REQUEST)
       return None

       
    def taidaVorm(self, REQUEST):
      "Titmisvorm"
      self.get_lang(('ivatests',), REQUEST)
      tulemus=leheAlgus(self, REQUEST)+"<h3>"
      if self.tyyp==1:
	      tulemus=tulemus+self.pealkirjaEsitlus(REQUEST)
      else:
	      tulemus=tulemus+REQUEST['L_it_solving_test'] % self.pealkirjaEsitlus(REQUEST)
      tulemus=tulemus+"</h3>"
      
      k=self.salvestusAsukoht(REQUEST, self.id)
      if not hasattr(k, 'algusaeg') and self.tyyp!=1:
        tulemus+="<p></p>"+REQUEST['L_it_warning_quiz']
        k.algusaeg=time.time()
      else:
        if self.tyyp!=1:
          tulemus+=REQUEST['L_it_quiz_started']+time.strftime(REQUEST['L_timestamp_format'], time.localtime(k.algusaeg))


      tulemus=tulemus+"<form action='loeAndmedLehelt' method='post'>\n<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
      kirjutusyl=[]
      for x in self.ylesanded():
        kirjutusyl.append(x)
      if self.kasKysimusteJuhuslikJarjekord():
        import random
        random.shuffle(kirjutusyl)
      for x in kirjutusyl:  
            tulemus=tulemus+"\n<tr><td class='t1' valign='top'>"+x.esitlusHTML(REQUEST)+"</td>"+\
            "<td class='t1' valign='top'>"+x.taitmineHTML(REQUEST, x.id) + "</td></tr>"
      tulemus=tulemus+"</table>\n"
      tulemus=tulemus+"<table width='100%' border='0' cellpadding='2' cellspacing='0' bgcolor='#EEEEEE'>\n <tr>\n   <td>"
      tulemus=tulemus+"<input type='submit' name='salvestusnupp' value='"+REQUEST['L_it_save_solved_test']+"'>\n"
      tulemus=tulemus+"   </td>\n </tr>\n</table></form>"
      return tulemus+leheLopp(self, REQUEST)
      
    def testiSelgitusLeht(self, REQUEST):
      "Leht, kus antakse teada, et esimesel lahendamisel registreeritakse kasutaja aeg"
      self.get_lang(('ivatests',),REQUEST)
      t=leheAlgus(self, REQUEST)
      k=self.salvestusAsukoht(REQUEST, self.id)
      if not hasattr(k, 'algusaeg'):
        t+="<p></p>"+REQUEST['L_it_warning_quiz']
      else:
        t+=REQUEST['L_it_quiz_started']+": "+time.strftime(REQUEST['L_timestamp_format'], time.localtime(k.algusaeg))
      t+="<form action='taidaVorm'><input type='submit' value='"+REQUEST['L_it_begin_quiz']+"'></form>"
      t+=self.fle_html_footer(self, REQUEST)
      return t
      
    def alustus(self, REQUEST):
      "Juhatus lahendusele vastavalt testi tbile"
      tyyp=self.kysiTyyp(REQUEST)
      if tyyp==0:
        return self.testiSelgitusLeht(REQUEST)
      if tyyp==1:
        return self.taidaVorm(REQUEST)
      if tyyp==2:
        return self.harjutusVorm(REQUEST)
      return "Unknown type"
       
    def index_html(self, REQUEST):
       "Peegel veebi"
       if self.kas_opetaja(self, REQUEST):
         #return self.ylesandedMuutmisTabelina(REQUEST)
         REQUEST.RESPONSE.redirect(self.absolute_url()+"/ylesandedMuutmisTabelina")
       else:
         return self.taidaVorm(REQUEST)


    def loeAndmedLehelt(self, REQUEST):
        "Veebilt tulevad andmed talde"
        self.get_lang(('ivatests',), REQUEST)
        tulemus=""
        if not hasattr(REQUEST, 'salvestusnupp'):
          return leheAlgus(self, REQUEST)+\
            REQUEST['L_it_click_to_save']+\
            leheLopp(self, REQUEST)
        t=TestiVastused()
        t.testinimi=self.id
        for x in self.ylesanded():
          vastus=None
          if hasattr(REQUEST, x.id):
            vastus=getattr(REQUEST, x.id)
          tulemus=tulemus+"!"+x.id+" "+str(vastus)
          t._setObject(x.id, x.salvestaPakutu(vastus))
        self.paigutaTestiVastus(REQUEST, t)
        return leheAlgus(self, REQUEST)+"<br /><b>"+REQUEST['L_it_answers_saved']+"</b>"+leheLopp(self, REQUEST)
        
    def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
       "Koht testi tulemuste salvestamiseks"
       kasutajajuur=getattr(self.fle_root().fle_users,\
                   str(REQUEST.AUTHENTICATED_USER))
       try:
        kasutaja=getattr(kasutajajuur.webtop,\
          'c'+kasutajajuur.get_jooksev_kursus())
       except:
        kasutaja=kasutajajuur.webtop
       if not hasattr(kasutaja, 'testivastused'):
          kasutaja.manage_addProduct['OFSP'].manage_addFolder('testivastused')
          kasutaja.testivastused.id='testivastused'
       if not hasattr(kasutaja.testivastused.aq_self, testinimi):
          kasutaja.testivastused.manage_addProduct['OFSP'].manage_addFolder(testinimi)
          testikataloog=getattr(kasutaja.testivastused, testinimi)
          testikataloog.id=testinimi
          testikataloog.variandinr=0
       testikataloog=getattr(kasutaja.testivastused, testinimi)
       #return self.get_url_to_object(testikataloog)
       return testikataloog

    def paigutaTestiVastus(self, REQUEST, vastus):
       "Paigutab variandi uue id alla"
       self.get_lang(('ivatests',), REQUEST)
       k=self.salvestusAsukoht(REQUEST, vastus.testinimi)
       k.variandinr=k.variandinr+1
       vastus.id="variant"+str(k.variandinr)
       k._setObject(vastus.id, vastus)
       self.lisaSyndmus(REQUEST, 'testeLahendatud')
       return str(k.variandinr)
       
    def lahendusKordadeArv(self, REQUEST):
       "Mitu varianti on kasutaja vastavat testi lahendanud"
       k=self.salvestusAsukoht(REQUEST, self.id)
       return len(k.objectValues())

    def kasutajateTulemused(self, REQUEST, kommentaarid=0):
       "Testi tulemused"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+"</p>\n<h2>"+(REQUEST['L_it_test_answers'] % self.id)+"</h2>\n"
       kommentaarid=int(kommentaarid)
       if kommentaarid==0:
         tulemus=tulemus+"<p><a href='"+REQUEST.URL0+"?kommentaarid=1'>"+REQUEST['L_it_show_comments']+"</a></p>\n"
       else:
         tulemus=tulemus+"<p><a href='"+REQUEST.URL0+"?kommentaarid=0'>"+REQUEST['L_it_hide_comments']+"</a></p>\n"       
       try:
         kasutajad=self.get_all_users()
       except:
         return tulemus+REQUEST['L_it_problem_in_finding_user']
       tulemus=tulemus+"\n<table border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       for x in kasutajad:
        tulemus=tulemus+"<tr>\n<td class=\"t1\" valign=\"top\">"+str(x.id)+"</td>\n<td class=\"t1\">\n"
        try:
         k=getattr(x.webtop, 'c'+str(self.find_course().get_id()))
           #tulemus=tulemus+"j"+k.absolute_url()
         if hasattr(k, 'testivastused'):
             #tulemus=tulemus+"k"
             if hasattr(k.testivastused, self.id):      
               t=getattr(k.testivastused, self.id)
               for y in t.objectValues():
#                 print type(y)
                 tulemus=tulemus+"<a href='"+y.absolute_url()+"'>"+str(y.id)+"</a> "
                 if kommentaarid:
                   tulemus=tulemus+str(y.lyhiKokkuvoteOpetajale(REQUEST))
                 else:
                   tulemus=tulemus+str(y.punktiArvutusHTML(REQUEST))
                 tulemus=tulemus+"<br />\n"
               tulemus=tulemus+"\n</td>\n"
        except Exception, probleem:
          tulemus=tulemus+"</td>"
       tulemus+="</tr>\n</table><br />\n"
       tulemus+="<a href='lahendusteStatistika'>"+REQUEST['L_it_quiz_stats']+"</a>"
       tulemus+=leheLopp(self, REQUEST)
       return tulemus




    def harjutusVorm(self, REQUEST, ylid=None):
      "Vorm harjutuslesande nitamiseks"
      t = ""
      if ylid is None:
        ylesanded=self.ylesanded()
        if len(ylesanded)==0:
          t+="Empty/Tyhi"
          t+=self.fle_html_footer(self, REQUEST)
          return t
        ylid=ylesanded[0].id
      y=getattr(self, ylid)
      t=self.hdr(self, REQUEST)+self.leivaPuru(REQUEST)+"<p></p><h2>"+REQUEST['L_it_type_selftest']+": "+self.pealkiri+"</h2><p></p>" + t
      t+="<form action='harjutusLeht'><table  border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
      t+="<tr><td class='t1' valign='top'>"
      t+="<input type='hidden' name='ylid' value='"+ylid+"' />"
      t+=y.esitlusHTML(REQUEST)+"</td><td class='t1'>"
      t+=y.taitmineHTML(REQUEST, 'vastus')
      t+="   </td> \n</tr>\n</table>\n<p></p><input type='submit' value='"+REQUEST['L_it_selftest_submit']+"' /></form>"
      t+=self.fle_html_footer(self, REQUEST)
      return t


    def harjutusLeht(self, REQUEST, ylid, vastus=None):
      "Harjutuslesannete vastuse nitus"
      self.get_lang(('ivatests',),REQUEST)
      t=self.hdr(self, REQUEST)+self.leivaPuru(REQUEST)+"<p></p><h2>"+REQUEST['L_it_feedback']+"</h2>"
      y=getattr(self, ylid)
      ylesanded=self.ylesanded()
      t+="<table border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n<tr><td>"
      t+=REQUEST['L_it_question']+": </td><td class='t1'>"+y.esitlusHTML(REQUEST)+"</td>\n<tr>\n<td>"
      t+=REQUEST['L_it_you_answered']+"</td><td class='t1'>"+y.pakutudHTML(REQUEST, vastus)+"</td>\n<tr>\n<td>"
      t+=REQUEST['L_it_right_answer']+"</td><td class='t1'>"+y.tegelikHTML(REQUEST)
      t+="   </td>\n </tr>\n</table>"
      nr=0
      koht=-1
      while nr<len(ylesanded): #Leitakse, millise lesandega on massiivist tegemist
        if y==ylesanded[nr]:
          koht=nr
        nr+=1
      if koht!=-1:
        if koht==len(ylesanded)-1:
          t+="<p></p><h2>"+REQUEST['L_it_selftest_end']+"</h2>"
        else:
          id=ylesanded[koht+1].id
          t+="<p></p><a href='harjutusVorm?ylid="+id+"'>"+REQUEST['L_it_selftest_next']+"</a>"
      t+=self.fle_html_footer(self, REQUEST)
      return t      
      
    def seaTyyp(self, REQUEST, tyyp):
      "Testi tbi sttimine"
      self.tyyp=tyyp
      
    def kysiTyyp(self, REQUEST):
      "Vljastatakse testi tp"
      if not hasattr(self, 'tyyp'):
        return 0
      return self.tyyp
      
    def kysiTyypideNimed(self, REQUEST):
      "Tpide tlgitud nimed"
      self.get_lang(('ivatests',),REQUEST)
      m=[REQUEST['L_it_type_quiz'], REQUEST['L_it_type_survey'], REQUEST['L_it_type_selftest']]
      return m
      
    def kysiTyypTekstina(self, REQUEST):
      "Jooksva testi tp"
      return self.kysiTyypideNimed(REQUEST)[self.kysiTyyp(REQUEST)]

    def lahendusteArvud(self, REQUEST):
      "Lahendamise statistika: kohal 0: lahendajate arv, kohal 2 lahenduste arv"
      try:
       kasutajad=self.get_all_users()
       taitjaid=0
       lahendusi=0
       for x in kasutajad:
         if hasattr(x.webtop, 'c'+str(self.find_course().get_id())):
          k=getattr(x.webtop, 'c'+str(self.find_course().get_id()))
          if hasattr(k, 'testivastused'):
            if hasattr(k.testivastused, self.id):
               t=getattr(k.testivastused, self.id)
               if len(t.objectValues())>0:
                 taitjaid=taitjaid+1
                 lahendusi=lahendusi+len(t.objectValues())
       return (taitjaid, " ",  lahendusi)                           
      except:
       return ('x', ' ', 'x')
       
    def lahendusteStatistika(self, REQUEST):
      "Statistika testilahenduste kohta"
      self.get_lang(('ivatests',),REQUEST)
      t=self.hdr(self, REQUEST)+self.leivaPuru(REQUEST)
      t+="<p></p><h2>"+REQUEST['L_it_quiz_stats']+"</h2><p></p>"
      t+="<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
      kataloogid=self.lahendusteKataloogid(REQUEST)
      m=self.ylesanded()
      for x in m:
        t+="<tr><td class='t1' valign='top'>"
        t+="<h3>"+x.annaKirjeldavTekst(REQUEST)+"<br />"+x.kysimusHTML(REQUEST)+"</h3>"
        #t+="</td><td class='t1'> "
        t+="<p></p>"+self.lahendusedStatistikaVastavaltTyybile(REQUEST, kataloogid, x)
        t+="</td></tr>"
      t+="</table>"  
      t+=REQUEST['L_it_submissions']+str(len(kataloogid))
      t+=self.fle_html_footer(self, REQUEST)
      return t
           
    def lahendusteKataloogid(self, REQUEST):
      "ppurite lahenduste kataloogid statistika tarbeks"
      kataloogid=[]
      kasutajad=self.get_all_users()
      for x in kasutajad:
         if hasattr(x.webtop, 'c'+str(self.find_course().get_id())):
          k=getattr(x.webtop, 'c'+str(self.find_course().get_id()))
          if hasattr(k, 'testivastused'):
            if hasattr(k.testivastused, self.id):
               t=getattr(k.testivastused, self.id)
               if hasattr(t, 'variant1'):
                 kataloogid.append(t.variant1)
      return kataloogid
      
    def lahendusteYlesanded(self, REQUEST, kataloogid, ylesanne):
      "Ette antakse ppurite vastava testivariandi lahenduskataloogide massiiv.. Vljastatakse kataloogi seest etteantud nimega lesannete massiiv"
      tulemus=[]
      for k in kataloogid:
        if hasattr(k, ylesanne.id):
          tulemus.append(getattr(k, ylesanne.id))
      return tulemus
      
    def lahendusedStatistikaVastavaltTyybile(self, REQUEST, kataloogid, ylesanne):
      ""
      self.get_lang(('ivatests',),REQUEST)
      ylesanded=self.lahendusteYlesanded(REQUEST, kataloogid, ylesanne)
      if ylesanne.meta_type=="YksikvalikYlesanne":
        return self.lahendusedStatistikaMitmikvalik(REQUEST, ylesanded, ylesanne)
      if ylesanne.meta_type=="MitmikvalikYlesanne":
        return self.lahendusedStatistikaOigedVariandid(REQUEST, ylesanded, ylesanne)
      if ylesanne.meta_type=="ValikYlesanne":
        return self.lahendusedStatistikaJahEi(REQUEST, ylesanded, ylesanne)
      if ylesanne.meta_type=="OigeTekstivastusegaYlesanne":
        return self.lahendusedStatistikaLyhivastus(REQUEST, ylesanded, ylesanne)
      if ylesanne.meta_type=="ArvuvahemikuliseVastusegaYlesanne" or ylesanne.meta_type=="ProtsentYlesanne":
        return self.lahendusedStatistikaArvuvahemik(REQUEST, ylesanded, ylesanne)
      if ylesanne.meta_type=="TekstivastusegaYlesanne":
        return self.lahendusedStatistikaTekstivastus(REQUEST, ylesanded, ylesanne)
      return REQUEST['L_it_no_stats']
      
    def lahendusedStatistikaMitmikvalik(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      v=[]
      vigu=0
      pihtas=0
      for i in range(len(ylesanne.valikud)):
        v.append(0)
      for x in ylesanded:
        try:
          v[int(x.pakutudAndmed)]+=1
          if x.kasPihtas():pihtas+=1
        except:
          vigu+=1
      t="<table border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
      t+="<tr><th>"+REQUEST['L_it_stat_choice']+"</th><th>"+REQUEST['L_it_stat_count']+"</th></tr>\n"
      for i in range(len(ylesanne.valikud)):
        t+="<tr><td class='t1'>"+ylesanne.valikud[i]+"</td><td class='t1'>"+str(v[i])+"</td></tr>\n"
      t+="</table>"
      t+=REQUEST['L_it_stat_err']+": "+str(vigu)+"<br />"
      if ylesanne.oigeValik!=-1: #Kui leidub ige vastus
        t+=REQUEST['L_it_stat_hits']+": "+str(pihtas)
      return t
    
       
    def lahendusedStatistikaOigedVariandid(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      v=[]
      p=[]
      vigu=0
      for i in range(len(ylesanne.valikud)):
        v.append(0)
        p.append(0)

      for x in ylesanded:
#        try:
         vastused=None
         if x.pakutudAndmed is None:
            vastused=()
         if type(x.pakutudAndmed) == types.StringType:
            vastused=(int(x.pakutudAndmed))
         if vastused is None:
#         if type(x.pakutudAndmed) == types.TupleType or type(x.pakutudAndmed)==types.DictType:
            vastused=map(int, x.pakutudAndmed)
         for vastus in vastused:
          v[int(vastus)]+=1
         
         for i in range(len(ylesanne.valikud)):
          if i in ylesanne.oigedValikud and i in vastused:
            p[i]+=1
          if (i not in ylesanne.oigedValikud) and (i not in vastused):
            p[i]+=1 
#        except:
#          vigu+=1
      t="<table  border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n <tr>"
      t+="<th>"+REQUEST['L_it_stat_choice']+"</th><th>"+REQUEST['L_it_stat_count']+"</th>"
      t+="<th>"+REQUEST['L_it_stat_hits']+"</th></tr>\n"
      for i in range(len(ylesanne.valikud)):
        t+="<tr><td class='t1'>"+ylesanne.valikud[i]+"</td><td class='t1'>"+str(v[i])+"</td>"
        if len(ylesanne.oigedValikud)>0:
          t+="<td class='t1'>"+str(p[i])+"</td>"
        t+="</tr>\n"
      t+="</table>"
      t+=REQUEST['L_it_stat_err']+": "+str(vigu)
      return t

    def lahendusedStatistikaJahEi(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      kokku=0
      pihtas=0
      for x in ylesanded:
        if x.pakutudAndmed=="on":
          kokku+=1
        if x.kasPihtas():
          pihtas+=1
      return REQUEST['L_it_stat_count']+": "+str(kokku)+", "+REQUEST['L_it_stat_hits']+": "+str(pihtas)
    
       
    def lahendusedStatistikaLyhivastus(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      kokku=0
      pihtas=0
      for x in ylesanded:
        if len(x.pakutudAndmed)>0:
          kokku+=1
        if x.kasPihtas():
          pihtas+=1
      return REQUEST['L_it_stat_count']+": "+str(kokku)+", "+REQUEST['L_it_stat_hits']+": "+str(pihtas)
    
       
    def lahendusedStatistikaArvuvahemik(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      punkteSaanud=0
      punktiSumma=0
      for x in ylesanded:
        if x.automaatPunkte()>0:
          punkteSaanud+=1
        punktiSumma+=x.automaatPunkte()
      return REQUEST['L_it_stat_scored']+str(punkteSaanud)+REQUEST['L_it_stat_total']+str(punktiSumma)+"/"+str(len(ylesanded)*ylesanne.normPunktid)
    
       
    def lahendusedStatistikaTekstivastus(self, REQUEST, ylesanded, ylesanne):
      "Vljundiks HTML-tabel: valik/pakutud kordade arv. sisendiks kigi lahendajate vastavad lesanded"
      self.get_lang(('ivatests',),REQUEST)
      vastanud=0
      t=REQUEST['L_it_submissions']+"<br />"
      for x in ylesanded:
        if len(x.pakutudAndmed.strip())>0:
          vastanud+=1
        t+="<p>"+x.pakutudHTML(REQUEST)+"</p>"
      return t+REQUEST['L_it_stat_notempty']+str(vastanud)    
       



    def leivaPuru(self, REQUEST, viimane=0):
       "Teekond les"
       self.get_lang(('ivatests',),REQUEST)
       nimi=self.id
       if not hasattr(self,'tyyp'):
          self.tyyp=0
       nimi=self.kysiTyypideNimed(REQUEST)[self.tyyp]
       if viimane:
         tekst=nimi
       else:
         tekst=nimi
       if self.kas_opetaja(self, REQUEST):
         return " &gt; <a href='"+self.fle_root().testihaldus.absolute_url()+"'>"+REQUEST["L_it_hdr_tests"]+"</a> &gt; " + tekst
       return " &gt; "+tekst
       
Globals.InitializeClass(YlTest)

class LahendusLoad(Persistent, OFS.Folder.Folder, Traversable):
   "Lahenduslubade kogum"
   def leivaPuru(self, REQUEST, viimane=0):
     "Teekond les"
     nimi=self.id+" "
     if viimane:
         tekst=nimi
     else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
     return self.aq_parent.leivaPuru(REQUEST)+" &gt; <a href='"+self.aq_parent.absolute_url()+"/lubadeViited'>lubade haldus</a> &gt; "+tekst
       
   def kustutusLeht(self, REQUEST, kustuta=None):
     "iguslubade kustutamine"
     if kustuta is not None:
       if type(kustuta)==types.StringType:
         kustuta=(kustuta,)
       for x in kustuta:
         self._delObject(x)
     REQUEST.RESPONSE.redirect('index_html')
     
   def kustutaKoikLoad(self):
     "Plats puhtaks"
     for x in self.nimedeLoetelu():
       self._delObject(x)
     
   def nimedeLoetelu(self):
     "Elementide nimed tekstina"
     nimed=[]
     for x in self.objectValues():
       nimed.append(x.id)
     return nimed
       
   def index_html(self, REQUEST):
     "Lubade loetelu"
     self.get_lang(('ivatests',), REQUEST)
     tulemus=leheAlgus(self, REQUEST)
     if len(self.objectValues())>0:
      tulemus=tulemus+"<form action='kustutusLeht'><ul>"
      for x in self.objectValues():
       tulemus=tulemus+"\n<li><input type='checkbox' name='kustuta' value='"+x.id+"'><a href='"+x.absolute_url()+"'>"+x.id+"</a></li>"
      tulemus=tulemus+"</ul><input type='submit' value='"+REQUEST['L_it_delete_permission']+"' /></form>"
     else:
      tulemus=tulemus+"Lubasid pole jagatud"
     tulemus=tulemus+leheLopp(self, REQUEST)
     return tulemus

class LahendusLuba(Persistent, OFS.SimpleItem.Item, Traversable):
   "igused testi lahendamiseks"
   kordadeArv=-1  #arvu ei piirata
   algusAeg=-1    #Pole avatud lahendamiseks
   loppAeg=-1     #Kestust ei piirata
   import time
   def kasLahendusAeg(self):
     "jah/ei praeguse hetke kohta"
     if self.algusAeg==-1: return 0
     if self.algusAeg>time.time():return 0
     if self.loppAeg==-1:return 1
     if self.loppAeg>time.time():return 1
     else: return 0
     
   def kasLubatudLahendada(self, REQUEST, tehtudKordadeArv):
     "Jah/ei"
     if self.kasLahendusAeg()==0:return 0
     if self.kordadeArv==-1: return 1
     return int(tehtudKordadeArv)<self.kordadeArv
     
   def looValik(self, elemendinimi, algus, ots, valitu=-1, minkohtadearv=2, samm=1):
      "Valikmen HTML"
      tulemus="<select name='"+elemendinimi+"'>"
      x=algus
      while x<=ots:
        tulemus=tulemus+"\n <option value='"+str(x)+"'"
        if valitu==x:
          tulemus=tulemus+" selected "
        tekst=str(x)
        while len(tekst)<minkohtadearv:
          tekst="0"+tekst
        tulemus=tulemus+">"+tekst+"</option>"
        x=x+samm
      tulemus=tulemus+"\n</select>"
      return tulemus

   def aegTekstina(self, REQUEST, aeg):
      "tekstiesitus"
      self.get_lang(('common',), REQUEST)
      if aeg==-1: return "*"
      return time.strftime(REQUEST['L_timestamp_format'], time.localtime(aeg))
   
   def loaAndmedTekstina(self, REQUEST):
      "Loa kirjeldus ekraanil. Ajavahemik, kordade arv."
      self.get_lang(('ivatests',), REQUEST)
      tulemus=""
      if self.algusAeg==-1:
        tulemus=tulemus+"  "+REQUEST['L_it_timelimit']
        return tulemus
      tulemus=tulemus+self.aegTekstina(REQUEST, self.algusAeg)+"-"
      if self.loppAeg==-1:
        tulemus="igavesti"
      else:
        tulemus=tulemus+self.aegTekstina(REQUEST, self.loppAeg)
      if self.kordadeArv==-1:
        tulemus=tulemus+" piiramata arv"
      else:
        tulemus=tulemus+" "+str(self.kordadeArv)
      tulemus=tulemus+" x" 
      return tulemus
      

   def ajaMuutmisElemendid(self, elemendinimi, aeg=-1):
     "Valikute kogum"
     if aeg==-1:aeg=time.time()
     m=time.localtime(aeg)
     tulemus=self.looValik(elemendinimi+"Aasta", m[0]-5, m[0]+10, m[0])
     tulemus=tulemus+"-"+\
             self.looValik(elemendinimi+"Kuu", 1, 12, m[1])
     tulemus=tulemus+"-"+\
             self.looValik(elemendinimi+"Paev", 1, 31, m[2])
     tulemus=tulemus+" &nbsp; "+\
             self.looValik(elemendinimi+"Tund", 0, 23, m[3])
     tulemus=tulemus+":"+\
             self.looValik(elemendinimi+"Minut", 0, 59, m[4], samm=5)
     return tulemus
     
   def ajaPyydmisLeht(self, REQUEST, elemendinimi):
     "Saabuvad parameetrid ajaks"
     m=(int(getattr(REQUEST, elemendinimi+"Aasta")),
        int(getattr(REQUEST, elemendinimi+"Kuu")),
        int(getattr(REQUEST, elemendinimi+"Paev")),
        int(getattr(REQUEST, elemendinimi+"Tund")),
        int(getattr(REQUEST, elemendinimi+"Minut")),0,0,0,-1)
     return time.mktime(m)
          
     
   def muutmisVorm(self, REQUEST, liikumisURL=''):
     "Vljund veebilehele"
     self.get_lang(('ivatests',), REQUEST)
     tulemus=leheAlgus(self, REQUEST)+\
       "<form action='muutmisLeht'><input type='hidden' name='liikumisURL' value='"+liikumisURL+"' />"
     korratekst=REQUEST['L_it_unlimited']
     if self.kordadeArv!=-1:
       korratekst=str(self.kordadeArv)
     tulemus=tulemus+"<h3>"+REQUEST['L_it_start_time']+"</h3>"+\
       self.ajaMuutmisElemendid("algusAeg", self.algusAeg)+\
       "<h3>"+REQUEST['L_it_end_time']+"</h3>"+\
       self.ajaMuutmisElemendid("loppAeg", self.loppAeg)+\
       "<h3>"+REQUEST['L_it_repeat']+"</h3>"+\
       "<input type='text' name='kordadearv' value='1'/>"+\
       "<br /><input type='submit' value='"+REQUEST['L_it_save']+"' />"
     tulemus=tulemus+"</form>"+leheLopp(self, REQUEST)
     return tulemus
     
   def muutmisLeht(self, REQUEST, liikumisURL=''):
     "Tulemuste talletus"
     self.algusAeg=self.ajaPyydmisLeht(REQUEST, "algusAeg")
     self.loppAeg=self.ajaPyydmisLeht(REQUEST, "loppAeg")
     try:
       self.kordadeArv=int(REQUEST['kordadearv'])
     except:
       self.kordadeArv=-1
     if liikumisURL!='':
       REQUEST.RESPONSE.redirect(liikumisURL)
     else:
       REQUEST.RESPONSE.redirect('muutmisVorm')
     
   def index_html(self, REQUEST,liikumisURL=''):
     "Avaleht"
     return self.muutmisVorm(REQUEST,liikumisURL)

   def leivaPuru(self, REQUEST, viimane=0):
     "Teekond les"
     nimi=self.id+" lahendusaeg"
     if viimane:
         tekst=nimi
     else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
     return self.aq_parent.leivaPuru(REQUEST)+" &gt; "+tekst
       
     
     
     
   
class TestiVastused(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):           
     "Testi vastusvariant"
     testinimi=""
     koguKommentaar=""
     
     def ylesanded(self):
       "lesannete kogum"
       return self.objectValues()
     
     
     def vastusteTabel(self, REQUEST):
       "lesannete vastused tabelina"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)
       tulemus=tulemus+"<p></p><h2>"+REQUEST['L_it_quiz_responses']+"</h2>"
       tulemus=tulemus+"<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>\n"
       tulemus=tulemus+"<tr><th>"+REQUEST['L_it_an_question']+"</th><th>"+REQUEST['L_it_an_user_answer']
       tulemus=tulemus+"</th><th>"+REQUEST['L_it_an_teacher_answer']+"</th><th>"+REQUEST['L_it_an_points']
       tulemus=tulemus+"</th><th>"+REQUEST['L_it_an_comment']+"</th></tr>"
       for x in self.ylesanded():
        try:
          p="x"
          if x.kasPunktiArvutus():
            p=str(x.punkte())+"/"+str(x.normPunktid)
          tulemus=tulemus+"\n<tr><td class='t1'>"+x.esitlusHTML(REQUEST)+"</td><td class='t1'>"+\
          x.pakutudHTML(REQUEST)+"</td><td class='t1'>"+x.tegelikHTML(REQUEST)+"</td><td class='t1'>"+p+"</td><td class='t1'>"+x.opetajaKommentaarHTML(REQUEST)+"</td></tr>"
        except:
          tulemus=tulemus+"<tr><td class='t1' colspan='4'>"+REQUEST['L_it_stat_err']+"</td></tr>"  
       tulemus=tulemus+"</table><br />"+REQUEST['L_it_totalpoints']+self.punktiArvutusHTML(REQUEST)
       tulemus=tulemus+"<br />"+REQUEST['L_it_an_comment']+": "+self.koguKommentaarHTML(REQUEST)+"<br />"
       if self.kas_opetaja(self, REQUEST):
         tulemus=tulemus+"<a href='vastusteKommenteeritavTabel'>"+REQUEST['L_it_an_answer_commenting_table']+"</a>"
       return tulemus+leheLopp(self, REQUEST)

     def vastusteKommenteeritavTabel(self, REQUEST):
       "lesannete vastused tabelina"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+\
       "<form action='kommentaarideSalvestusLeht'><table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#EEEEEE'>"+\
         "<tr><th>"+REQUEST['L_it_anc_question']+"</th><th>"+REQUEST['L_it_anc_user_answer']+"</th>"+\
         "<th>"+REQUEST['L_it_anc_teacher_answer']+"</th>"+\
         "<th>"+REQUEST['L_it_anc_automatic_points']+"</th><th>"+REQUEST['L_it_anc_nominal_points']+\
         "</th><th>"+REQUEST['L_it_anc_teacher_points']+"</th><th>"+REQUEST['L_it_anc_teachers_comment']+\
         "</th><th>"+REQUEST['L_it_anc_point_reading']+"</th></tr>"
       for x in self.ylesanded():
          opunktid=""
          if x.annaOpetajaPunktid() is not None:
            opunktid=x.annaOpetajaPunktid()
          else:
            if x.kasPunktiArvutus():
              opunktid=x.automaatPunkte()
          tulemus=tulemus+"\n<tr><td class='t1'>"+x.esitlusHTML(REQUEST)+"</td><td class='t1'>"+\
          x.pakutudHTML(REQUEST)+"</td><td class='t1'>"+x.tegelikHTML(REQUEST)+"</td>"
          tulemus=tulemus+"<td class='t1'>"+str(x.automaatPunkte())+"</td>"+\
          "<td class='t1'>"+str(x.normPunktid)+"</td>"+\
          "<td class='t1'><input type='text' name='opetajapunktid"+x.id+"' "+\
          " value='"+str(opunktid)+"' size='5' /></td>"
          tulemus=tulemus+\
          "<td class='t1'><input type='text' name='opetajakommentaar"+x.id+"' "+\
          " value='"+str(x.annaOpetajaKommentaar())+"' /></td>"+\
          "<td class='t1'>"+str(x.kasPunktiArvutus())+"</td>"+\
          "</tr>"
       tulemus=tulemus+"</table><br />"+\
        self.punktiArvutusHTML(REQUEST)+"<br />"+REQUEST['L_it_anc_comment_to_whole_answer']+":<br />"+\
        "<textarea name='koguKommentaar'>"+self.annaKoguKommentaar()+"</textarea>"
       tulemus+="<table  width='100%' border='0' cellpadding='2' cellspacing='0' bgcolor='#EEEEEE'>\n"
       tulemus+=" <tr>\n   <td>\n   <input type='submit' value='"+REQUEST['L_it_anc_save']+"' >\n"
       tulemus+="   </td>\n </tr>\n</table>\n</form>"
       return tulemus+leheLopp(self, REQUEST)


     def kommentaarideSalvestusLeht(self, REQUEST):
       "petaja kommentaaride salvestus"
       import re
       for x in self.ylesanded():
         if hasattr(REQUEST, 'opetajapunktid'+x.id) and len(getattr(REQUEST,'opetajapunktid'+x.id))>0:
           try:
             x.seaOpetajaPunktid(float(re.sub(",", ".", getattr(REQUEST,'opetajapunktid'+x.id))))
             x.seaPunktiArvutus(1)
           except:
             x.seaPunktiArvutus(0)
         else:
           x.seaOpetajaPunktid(None)
           x.seaPunktiArvutus(0)
         if hasattr(REQUEST, 'opetajakommentaar'+x.id):
           x.seaOpetajaKommentaar(getattr(REQUEST, 'opetajakommentaar'+x.id))           
           
       self.seaKoguKommentaar(REQUEST.koguKommentaar)
       REQUEST.RESPONSE.redirect('vastusteKommenteeritavTabel')
       
     def seaKoguKommentaar(self, koguKommentaar):
       "Salvestatakse petaja kommentaar kogu lahendusvariandile"
       self.koguKommentaar=koguKommentaar
       
     def annaKoguKommentaar(self):
       "Kommentaari vljastus"
       return self.koguKommentaar
       
     def koguKommentaarHTML(self, REQUEST):
       "Kogu kommentaar HTML-ina"
       return asendaHTML(self.annaKoguKommentaar())
       
     def lyhiKokkuvoteOpetajale(self, REQUEST):
       "Kokkuvote"
       tulemus=self.punktiArvutusHTML(REQUEST)
       for x in self.ylesanded():
         if len(x.annaOpetajaKommentaar())>0:
           tulemus=tulemus+"<br />\n"+x.opetajaKommentaarHTML(REQUEST)
       if len(self.koguKommentaarHTML(REQUEST))>0:
         tulemus=tulemus+"<br /><br />"+self.koguKommentaarHTML(REQUEST)
       return tulemus

     def pihtasSumma(self):
       "Tabamusega ylesannete summa"
       summa=0
       for x in self.ylesanded():
         if x.kasPihtas():
           summa=summa+1
       return summa
       
     def punktiSumma(self):
        "lesannete punktisumma"
        summa=0
        for x in self.ylesanded():
         try:
          if x.kasPunktiArvutus():
             summa=summa+x.punkte()
         except Exception, probleem:
          print str(probleem) + " punkte " + x.absolute_url()
        return summa
        
     def normPunktiSumma(self):
        "100%"
        summa=0
        for x in self.ylesanded():
          if x.kasPunktiArvutus():
            summa=summa+x.annaNormPunktid()
        return summa
        
     def punktiProtsent(self, REQUEST):
        "%"
        self.get_lang(('ivatests',), REQUEST)
        if self.normPunktiSumma()==0:
          return "Protsendiarvutus puudub"
        return str(round(self.punktiSumma()*100/self.normPunktiSumma(), 2))+" %"

     def punktiArvutusHTML(self, REQUEST):
        "Tulemuste vljastus"
        self.get_lang(('ivatests',), REQUEST)        
        return str(round(self.punktiSumma(),2))+" / "+str(round(self.normPunktiSumma(), 2))+\
           ", "+self.punktiProtsent(REQUEST)
       
     def punktiArvutusLyhiHTML(self, REQUEST):
        "Tulemuste vljastus"
        self.get_lang(('ivatests',), REQUEST)        
        return str(round(self.punktiSumma(), 2))+" / "+str(self.normPunktiSumma())
       
     def leivaPuru(self, REQUEST, viimane=0):
       "Teekond les"
       self.get_lang(('ivatests',),REQUEST)
       nimi=self.testinimi
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
         
       if self.fle_root().kas_opetaja(self, REQUEST):
         testipuru="<a href='"+self.get_url_to_object(self.fle_root())+"testihaldus'>"+REQUEST['L_it_tests']+"</a>"
       else:
         testipuru=REQUEST['L_it_tests']
       return " &gt; "+testipuru+" &gt; "+tekst+" &gt; "+REQUEST['L_it_answers']+" "
       
     def index_html(self, REQUEST):
       "Peegel veebi"
       return self.vastusteTabel(REQUEST)
       
Globals.InitializeClass(TestiVastused)
Globals.default__class_init__(TestiVastused)   

def asendaHTML(sona):
   try:
    sona=sona.replace("&", "&amp;")
    sona=sona.replace(">", "&gt;")          
    sona=sona.replace("<", "&lt;")             
    return sona;
   except:
    return "error: "+sona
           
def leheAlgus(obj, REQUEST):
   return obj.fle_root().hdr(obj, REQUEST)+obj.leivaPuru(REQUEST)+"<br />"
   
def leheLopp(obj, REQUEST):
   return obj.fle_html_footer(obj, REQUEST)

