# $Id: vocabulary_et_ee.py,v 1.4 2003/12/28 14:44:24 MartL Exp $
#
# Copyright 2003 by IVA Team and contributors
#
# This file is part of IVA.
#
# IVA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IVA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""Contains the Estonian translations for all IVA printable strings."""

# How to do a new translation:
#
# 1. Copy this file into a new file, appending the language code after it, so
# you get something like "vocabulary_es.py" for Spanish and so on.
#
# 2. Edit the new file, translating the second portion of each line. The
# first portion is the keyword, which you shouldn't touch. The second is the
# translation that should be translated to the target language. The third
# is the supplementary instruction, that should help you do the translations.
#
# 3. Please note that the file is in Python code and needs to follow certain
# syntax rules:
#  - Strings can either be quoted by singles quotes (') or double quotes (").
#    If you need to use either of these quotation marks in your translation,
#    make sure that you use the other quotation mark to surround the string.
#    If you need to use both quotation marks in the same translation string,
#    you can surround the string with triple quotes (''' or """), which
#    allows you to use either of the quotation marks inside the string.
#  - Line breaks are not allowed inside strings, so make sure you don't
#    use an editor that wraps lines. You can have line breaks between
#    strings, though.
#
# 4. If you need to use special characters (outside of the 127 character
# ASCII range), you have several choices:
#
# A. Write in your native encoding (whatever suits you best). This requires
#    that you change the "charset_encoding" keyword in the "common" module to
#    the encoding type you will use. This document is written in iso8859-1,
#    although as english does not contain special characters, it could be
#    in utf-8 as well without any differences.
#    Most European languages are easiest to write in iso8859-1.
#
# B. Write in utf-8 encoded unicode. If your editor can save files in utf-8,
#    use that feature. If not, you can add the special characters manually
#    with the \x escape sequences. Make sure you remove the keyword
#    "charset_encoding" from the "common" module, or change its value to
#    "utf-8" so that the strings are interpreted correctly.
#    'key': ('\xe3\x82\xaa','This is the katakana letter O,encoded in utf-8.'),
#
# C. Write in unicode. Each unicode string starts with u followed by the
#    quotes. Each unicode character starts with \u followed by the code in
#    hexadecimal notation. The value of the "charset_encoding" keyword
#    is irrelevant if you use unicode all the way.
#    'key': (u'\u30aa','This is the katakana letter O, encoded in unicode.'),
#
# 5. Check your translation. If you have Python installed and you've
#    downloaded IVA sources, you can execute "python TranslationLint.py"
#    which will check through all the translation files and will produce
#    an error if there is a syntax error.
#    If you have installed IVA, you can test the translation yourself
#    by going to Zope Management and selecting the Tools tab in your IVA
#    instance, and clicking on "reload_translations". After this you
#    should be able to select your translation from user preferences
#    and see the translated strings.
#

common = {
    'language_name': ('Estonian', 'Name of this language'),
    'charset_encoding': ('ISO-8859-13','Encoding used in this translation (if missing, utf-8 is assumed'),
    'WebTop': ('Veebilaud','Main tab for webtop'),
    'Knowledge_Building': ('TeadmusPaja','Main tab for knowledge building'),
    'Course_Management': ('Kursuste haldamine','Main tab for course management'),
    'User_Management': ('Kasutajad','Main tab for user management'),
    'Jamming': ('Ttoad', 'Main tab for jamming'),
    'Type_Management': ('Teadmustpide haldamine','Heading'),
    'cancel': ('Katkesta','Button label'),
    'submit': ('Sisesta','Button label'),
    'remove': ('Kustuta','Button label'),
    'next': ('Jrgmine ->','Label for button'),
    'previous': ('<- Eelmine','Label for button'),
    'quick_submit': ('Kiirsisestus',''),
    'ok': ('Ok','Button label'),
    'webtop': ('Veebilaud',''),
    'bookshelf': ('Raamaturiiul',''),
    'description': ('Kirjeldus','Label'),
    'short_date_format_display': ('PP.KK.AAAA', 'String displayed as clue when entering a date'),
    'short_date_format': ('%d.%m.%Y', 'Format string for short dates.'),
    'timestamp_format': ('%H:%M %d.%m.%Y', 'Format string for long timestamps.'),
    'invite': ('Kutsu',''),
    'add': ('Lisa',''),
    'today': ('Tna',''),
    'yesterday': ('Eile',''),
    'groupfolder': ('kursuse kaust','Heading'),
# v1.9:
    'dtml_reloaded': ('DTML uuendatud','Title for message dialog'),
    'dtml_files_reloaded': ('Selle objekti juurde kuuluvad DTML failid uuendatud','Message dialog text'),
    'dtmls_reloaded': ('DTML-id uuendatud','Title for message dialog'),
    'dtmls_files_reloaded': ('Kik DTML failid uuendatud','Message dialog text'),
    'css_reloaded': ('Laadilehed uuendatud','Title for message dialog'),
    'css_files_reloaded': ('Selle objekti juurde kuuluvad laadilehed uuendatud','Message text'),
    'error': ('Viga',''),
    'warning': ('Hoiatus',''),
# v1.26:
    'invalid_url': ('Vale URL (veebiaadress)', 'Message title'),
    'give_valid_url': ('Sisesta ige URL(veebiaadress)', 'Message text'),
    'invalid_name': ('Nimi puudub/valesti kirjutatud nimi','Message title'),
    'give_valid_name': ('Sisesta ige nimi','Message text'),
    'name_taken': ('Nimi "%s" on juba kasutusel. Anna uus nimi.','Message text, name inserted inside'),
# v1.31:
    'edit': ('Muuda','Button label'),
    'you_are_in': ('Sinu asukoht:', 'Heading, without trailing colon - keep in translation if needed'),
    'required_field_missing': ("Sa ei titnud kiki vajalikke andmevlju.", 'Erro message text'),
    'confirmation': ('Kinnitus', 'Title for confirmation dialogs'),
    'invalid_input': ('Vale sisestus', 'Message title'),
    'invalid_fields': ('Jrgmised andmevljad on sisestatud valesti', 'Message text followed by a list of field names'),
    'select_item_first_common': ('Vali kigepealt mni objekt vlja', 'Message text'),
    'link_to_webtop': ('henda veebilauaga','Link'),
    'proxy_to_webtop': ('henda kursuse kaust veebilauaga','Link'),
    'export': ('Eksport','Button label'),
    'import': ('Import','Button label'),
    'importing': ('Impordib','Heading start'),
    'megabyte': ('MB', 'Abbreviation for megabyte'),
    'kilobyte': ('kB', 'Abbreviation for kilobyte'),

    'logout': ('Vlju', 'Link for logging out, also heading in logout dialogs'),
    'logout_pre': ("Vljalogimiseks sulge brauser vi klpsa allolevat <b>Vlju</b>-nuppu. Kui brauser ksib uuesti salasna, siis vajuta <b>Thista</b>. See eemaldab sinu kasutaja-andmed brauseri vahemlust.",'Instructions on logging out'),
    'logout_post': ("Oled vlja loginud.",'Logout notification'),
    'login': ('Sisene','Link to log in')
    }

kb = {
    'course_info': ('Kursuse info', 'Label for link to course details'),
    'create_context': ('Loo uus kontekst', 'Link to create new course context'),
    'hide_context': ('Peida kontekst', 'Link to hide a context from view'),
    'show_context': ('Nita konteksti', 'Link to show a hidden context'),
    'new_notes': ('uut snumit', 'Label for showing the number of new notes, eg. "5 new notes"'),
    'notes_total': ('snumit', 'Label for showing the number of notes'),
    'full_description': ('tispikk kirjeldus...', ''),
    'course': ('kursus',"String 'course' in context display"),
    'context': ('kontekst',"String 'context' in context display"),
    'thread': ('lim',"String 'thread' in context display"),
    'note': ('snum',"String 'note' in context display"),
    'start_new_thread': ('Alusta uut jutulime','Link'),
    'short_description': ('Lhikirjeldus','Label'),
    'long_description': ('Pikem kirjeldus','Label'),
    'full_description': ('Tispikk kirjeldus','Label'),
    'select': ('Vali','Start of sentence, followed by a drop-down list of available knowledge types'),
    'knowledge_type': ('teadmustp','Label'),
    'reply': ('Vasta','Button label'),
    'show_notes': ('Nita mrkmeid sorteerituna','Heading start'),
    'show_thread': ('limedena','heading finish'),
    'show_type': ('teadmustpide','heading finish'),
    'show_author': ('inimeste','heading finish'),
    'show_date': ('kuupevade jrgi','heading finish'),
    'change_course_to': ('Vaheta kursust','Label, followed by a drop-down list of available courses'),
    'creating_context': ('Loo uus kontekst','Title, followed by the course name'),
    'editing_context': ('Muuda konteksti','Title, followed by the course name'),
    'title_of_context': ('Konteksti pealkiri','Label'),
    'type_set': ('Teadmustbistik','Label'),
    'creating_note_in': ('Lisa snum arutelule','Title, followed by course context name'),
    'course_context': ('kursuse kontekst','Label for course context'),
    'you_are_replying_to': ('Vastad','Label'),
    'title_of_note': ('Pealkiri','Label'),
    'message_body': ('Snumi tekst','Label'),
    'current_image': ('Praegune pilt','Label'),
    'replace_with': ('Asenda jrgmisega','Label for image replacement in note edit'),
    'add_image': ('Lisa pilt','Label'),
    'title_of_image': ('Pildi pealkiri','Label'),
    'add_link': ('Lisa veebiviide (URL)','Label'),
    'title_of_link': ('Veebiviite pealkiri','Label'),
    'preview': ('Eelvaade','Button label'),
    'previewing_note': ('Snumi eelvaade kontekstis','Title/heading, followed by course context name'),
    'publish': ('Avalda','Button label'),
# v1.19:
    'you_didnt_select_type': ("Sa ei valinud teadmustpi.",'Title'),
    'go_back': ('Mine tagasi','Start of message, rendered into a link'),
    'and_select_type': ('ja vali oma snumile vastav teadmustp.','Rest of message'),
    'inline_notes': ('Nita kigi snumite tekste','Link'),
    'outline_notes': ('Peida kigi snumite tekstid','Link'),
    'view_info': ('info','Part of location bar'),
    'edit_context': ('Muuda konteksti','Link'),
# v1.27:
    'to_note': ('snumile','Part of a message'),
# v1.31:
    'full_thread_no': ('Nita ksnes esimesi snumeid', 'Link'),
    'full_thread_yes': ('Nita kogu jutulime', 'Link'),
    'censor': ('Tsenseeri','Button label for censoring notes'),
    'uncensor': ('Thista tsenseering','Button label for uncensoring notes'),
    'censored_msg': ('Snum on tsenseeritud','Message shown when teacher censores a note.'),
    'censor_verify': ('Oled kindel, et soovid seda snumit tsenseerida? Sinu nimi kuvatakse koos tsenseeringuga kigile kursusel osalejatele.','Verification message shown when censoring is attempted'),
    'censored_subject': ('Tsenseeritud','Title/subject for censored notes'),
    'censored_body': ('See snum on tsenseeritud %s poolt %s.',"Body for censored messages. First placeholder is replaced by censorer's name and the second by the date"),
    'notes_from_day': ('Snumid alates','Start of heading, followed by a date'),
    'previous': ('Eelmine', 'Link label'),
    'next': ('Jrgmine', 'Link label'),
    'who_has_read': ('Kes on seda lugenud?', 'Link label'),
    'last_read': ('Viimati loetud', 'Label'),
    'times_read': ('Loetud kordi', 'Label'),
    'back': ('< tagasi', 'Link label'),
    'unread_to_read_msg': ('Kik snumid selles limes on mrgitud loetuks.', 'title and message in a message dialog'),
    'mark_notes_read': ('Mrgi kik loetuks', 'text in a button'),
    'creating_groupfolder': ('Loon uue kursuse kausta','Heading start'),
    'title_groupfolder': ('Kausta nimi','Label'),
# v1.87:
    'flea_asks': ('Soovitus','Heading displayed in the scaffolding check list.'),
    'change_type': ('Kas muuta teadmustpi?', 'Question at the end of the scaffolding check list.'),
    'no_change_possible': ('See on ainus lubatud teadmustp.','Text displayed when there is only one possible follow-up type and the type cannot be changed.'),
    'change': ('Muuda', 'Button label'),
    'down_to_note': ('Alla', 'Link label'),
    }

webtop = {
    'users_courses': ("Kursused","Heading for user's course list"),
    'new_notes': ('uut snumit','Label for displaying the number of new notes in a course'),
    'total_notes': ('kokku','Label for displaying the total number of notes in a course'),
    'add_folder': ("Lisa kaust",""),
    'add_document': ("Lisa fail",""),
    'add_link': ("Lisa veebiviide",""),
    'create_document': ("Lisa memo",""),
    'sort': (' ','Common heading for sort links by_name and by_date'),
    'by_name': ('nimi','Link for sorting by name'),
    'by_date': ('aeg','Link for sorting by date'),
    'by_size': ('suurus', 'Link for sorting by size'),
    'remove': ('Kustuta','Button label'),
    'restore': ('Taasta','Button label'),
    'rename': ('Nimeta mber', 'Button label'),
    'copy': ('Kopeeri','Button label'),
    'cut': ('Lika','Button label'),
    'paste': ('Kleebi','Button label'),
    'delete': ('Kustuta','Button label'),
    'trash': ('Prgikast','Label for trashcan'),
    'adding_folder': ('Lisan kausta','Heading'),
    'title_of_folder': ('Kausta nimi','Label'),
    'viewing_memo': ('Memo kuvamine', 'Title'),
    'adding_memo': ('Lisa memo','Title'),
    'editing_memo': ('Muuda memo','Title'),
    'name_of_memo': ('Memo pealkiri','Label'),
    'content': ('Sisu','Label'),
    'show_memo_contents': ('Nita ksnes memo sisu','Link'),
    'adding_link': ('Veebiviite lisamine','Title'),
    'title_of_link': ('Viite pealkiri','Label'),
    'url': ('URL',''),
    'document_uploaded': ('Dokument lisatud.','Status message'),
    'adding_document': ('Dokumendi lisamine', 'Title'),
    'upload_document': ('Dokumendi leslaadimine','Label'),
    'title_of_document': ('Dokumendi pealkiri','Label'),
# v1.9:
    'webtop_link_added': ('Viide lisatud veebilauale','Message title'),
    'added_webtop_link': ('Viide %s "%s" lisati sinu veebilauale. Klpsa OK.','Message text; "to type" and "name" inserted into placeholders (2)'),
    'proxy_added': ('Kursuse kaust valmis', 'Message title'),
    'added_proxy': ('Kursuse %s kaust on nd sinu veebilaualt kttesaadav. Klpsa OK.', 'Message text, course name inserted into placeholder'),
    'no_item_selected': ('htegi objekti polnud valitud!','Message dialog title'),
    'select_item_first': ('Vali vhemalt ks objekt.','Message dialog message'),
    'no_file_supplied': ('htegi faili ei pakutud.','Message text'),
    'renaming': ('mbernimetamine', 'Title'),
    'invalid_names': ('Jrgmised nimed on vigased/sobimatud:', 'Message dialog messsage'),
    'same_names': ('Andsid sama nime mitmele objektile.', 'Message dialog message'),
    'names_in_use': ('Jrgmised nimed on juba kasutusel:', 'Message dialog message'),
# v1.19:
    'information': ('Kasutaja info','Link'),
    'preferences': ('Seaded','Link'),
    'editing_preferences': ('Seadete muutmine','Title'),
    'shared': ('hine', 'Printed after the name of the group folder'),
    }

coursemgmnt = {
    'course': ('kursus', 'part of browser title'),
    'courses': ('Kursused','Title'),
    'add_course': ('Lisa kursus','Link'),
    'edit_course': ('Muuda kursus','Button label'),
    'edit_participants': ('Osalejad','Button label'),
    'creating_course': ('Uue kursuse lisamine','Title'),
    'editing_course': ('Kursuse muutmine','Title'),
    'course_name': ('Kursuse nimi','Label'),
    'organization': ('Organisatioon','Label'),
    'methods': ('Meetodid','Label'),
    'starting_date': ('Kursuse algus','Label'),
    'ending_date': ('Kursuse lpp','Label'),
    'create_groupfolder': ('Loo kursuse kaust','Link'),
    'adding_users_to_course': ('Osalejate lisamine kursusele','Title, name of course is displayed after this'),
    'if_participants_not_users': ('Kui kursusel osalejad pole registreerunud serveri kasutajaks','Message'),
    'new_participants_to_system': ('uued kasutajad serveris', 'Part of a phrase'),
    'by_email': ('e-posti aadressi jrgi','Part of a phrase'),
    'manually': ('ksitsi','Part of a phrase'),
    'fle_users': ('Kasutajad','Heading'),
    'down': ('Alla','Button label'),
    'up': ('les','Button label'),
    'teachers': ('petajad','Heading'),
    'tutors': ('Tuutorid','Heading'),
    'students': ('ppijad','Heading'),
    'add_button': ('Lisa ->','Button label'),
    'remove_button': ('<- Eemalda','Button label'),
# v1.9:
    'no_course_selected': ('htegi kursust polnud valitud!','Message dialog title'),
    'select_course_first': ('Vali nimekirjast ks kursus.','Message dialog message'),
    'set_published': ('Teadmustp lisatud','Message dialog title/text'),
    'users_updated': ('Kasutajate nimekiri uuendatud','Message dialog title/message'),
    'select_some_users': ('Vali mned kasutajad','Message dialog title/message'),
# v1.19:
    'edit_course_info': ('Muuda kursuse infot','Link'),
    'edit_course_participants': ('Muuda osalejate nimekirja','Link'),
    'date': ('Kuupev','Label, followed by the starting and ending date of the course.'),
    'course_participants': ('Kursusel osalejad','Label'),
    'type_sets': ('Teadmustbistikud','Label, plural'),
    'delete': ('Kustuta','Button label'),
# v1.31:
    'new_typeset': ('Lisa teadmustbistik','Link'),
    'tt_yellow': ('Kollane','Knowledge type colour name'),
    'tt_yellowlt': ('Helekollane','Knowledge type colour name'),
    'tt_orange': ('Oranzh','Knowledge type colour name'),
    'tt_orangelt': ('Heleoranzh','Knowledge type colour name'),
    'tt_red': ('Punane','Knowledge type colour name'),
    'tt_pink': ('Roosa','Knowledge type colour name'),
    'tt_purple': ('Lilla','Knowledge type colour name'),
    'tt_blue': ('Sinine','Knowledge type colour name'),
    'tt_bluelt': ('Helesinine','Knowledge type colour name'),
    'tt_aqua': ('Aqua','Knowledge type colour name'),
    'tt_green': ('Roheline','Knowledge type colour name'),
    'tt_greenlt': ('Heleroheline','Knowledge type colour name'),
    'tt_gray': ('Hall','Knowledge type colour name'),
    'tt_white': ('Valge','Knowledge type colour name'),
    'edit_typeset': ('Teadmustbi muutmine','Heading'),
    'create_typeset': ('Uue teadmustbi lisamine','Heading'),
    'form': ('Vorm','Start of heading'),
    'name': ('Nimi','Start of label'),
    'of_typeset': ('teadmustbistikule.','Ending of label'),
    'abbreviations_and_icons': ('lhendid ja ikoonid','Ending for heading'),
    'type': ('Teadmustp','Label'),
    'types': ('Teadmustbid','Title'),
    'abbreviation': ('Lhend','Label'),
    'color': ('Vrv','Label'),
    'icon': ('Ikoon','Label'),
    'starting_phrase': ('Algusfraas','Label'),
    'checklist': ('Ankeet','Label'),
    'no_types_entered': ("Sa ei lisanud htegi teadmustpi, pead lisama vhemalt he.",'Error message for when a new set is created with no types'),
    'restrictions_of_use': ('Kasutamise piirangud','Heading sentence.'),
    'that_can_start_thread': ('kes vib algatada diskussiooni','End of label'),
    'viewing_type': ('teadmustbi kuvamine','Part of location bar'),
    'new_typeset_from': ('Tee olemasolevast teadmustbistikust koopia ja muuda seda','Link, followed by knowledge type set name'),
    'unfinished': ('Lpetamata','Label'),
    'manage_types': ('Teadmustpide haldamine','Link'),
    'finalize_typeset': ('Muuda staatus - Lpetatuks','Button label'),
    'are_you_sure': ('Kas oled kindel, et soovid kustutada jrgmised kursused:' , 'Message dialog message'),
    'are_you_sure_ctx': ('Kas oled kindel, et soovid kustutada jrgmised kontekstid:' , 'Message dialog message'),
    'are_you_sure_tts': ('Kas oled kindel, et soovid kustutada jrgmised teadmustbid:' , 'Message dialog message'),
    'typeset_importing': ('Vali pakitud (zip) teadmustbistikku sisaldav fail, mida soovid importida.','Instructions for typeset importing'),
    'typesets_imported': ('Uued teadmustbid imporditi.','Message'),
    'import_typeset': ('Impordi teadmustbistik','link'),
    'course_importing': ('Vali pakitud eksportfail kursuse sisuga, mida soovid importida.','Instructions for course importing'),
    'courses_imported': ('Uued kursused imporditi.','Message'),
    'import_course': ('Impordi kursus','link'),
    
    'quota_reached_title': ('Kvoot letatud', 'Title'),
    'quota_reached':  ('Ei saanud lpetada toimingut, kuna sinu VeebiLaua kvoot on letatud. Palun kustuta mned objektid oma veebilaualt ja rita uuesti.',  'Message dialog message'),

 # Sorting the users under user management #06.08 by Mart
  'sort_by': ('Jrjesta','Text before pull-down menu'),
  'limiters': ('Piirangud','Text before pull-down menu'),
  'modified': ('Ajaliselt','menu option'),
  'username': ('Thestikuliselt','menu option'),
  'sort': ('Jrjesta','button label'),
  'not_specified': ('Mramata','default menu option'),
  'email': ('e-post','menu option'),
  'fname': ('eesnimi','menu option'),  
  'since': ('alates','default value of textbox'),
  'until': ('kuni','default value of textbox'),  
    }

usermgmnt = {

    'user': ('kasutaja', 'part of browser title'),
    'adding_users': ('Kasutajate lisamine', 'Title'),
    'required_field': ('Kohustuslik tita',''),
    'nickname': ('Hdnimi','Label'),
    'user_account': ('Kasutajakonto','Label'),
    'Confirm': ('Kinnita',''),
    'you_are_removing': ('Eemalda',''),
    'invite_user': ('Saada kutse',''),
    'invite_new_users': ('Kutsu uusi kasutajaid','Heading for invitation form'),
    'email_addresses': ('E-posti aadressid',''),
    'separate_with_comma': ('( eralda komaga: , )',''),
    'Invitation_message': ('Kutse tekst',''),
    'Invitation_language': ('Mis keeles kutse on', ''),
    'Courses_to_invite_to': ('Mis kursusele kutsutakse', ''),
    'Freeze': ('Klmuta',''),
    'Remove': ('Eemalda',''),

    'role': ('Roll', 'label'),
    'role_staff': ('Personal', 'Global role staff'),
    'role_user': ('Kasutaja', 'Global role user'),
    'role_fleadmin': ('IVA Admin', 'Global role ivaadmin'),

    'invite_again': ('Kutsu uuesti','Button label'),
    'warning': ('Hoiatus','Heading'),
    'want_remove_users': ('Kas soovid eemaldada jrgmised kasutajad?','Complete question'),
    'invited_user_manage': ('Kutsutud kasutajate haldamine','Title'),

    'info_user': ('Kasutajainfo ','Title for user info page, prefix before usre name'),
    'edit_user': ('Muuda kasutajainfot','Link'),
    'name': ('Kasutajatunnus',''),
    'editing': ('Muuda','Heading for user edit, inserted before user name'),
    'image_of_user': ('Kasutaja pilt','Label'),
    'upload_image_of_user': ('Laadi pilt serverile','Label'),
    'or_link_to_image': ('vi sisesta pildi veebiaadress (URL)','Label, continuing from the upload label'),
    'add_new_user': ('Uue kasutaja lisamine','Title'),
    'webtop_bg': ('Vali veebilaua taustapilt', 'Label'),
    'upload_webtop_bg': ('vi laadi serverile oma taustapilt', 'Label, continuing from the webtop_bg'),
    'show_pending_users': ('Ootel kasutajakandidaadid',''),
    'add_user': ('Lisa kasutaja',''),
    'Unfreeze': ('Sulata les',''),
    'Users': ('Kasutajad',''),
    'gsm': ('Mobiil',''),
    'last_name': ('Perekonnanimi',''),
    'first_name': ('Eesnimi',''),
    'city': ('Linn',''),
    'organization': ('Organisatsioon',''),
    'professional_interests': ('Ametialased huvid',''),
    'email': ('E-post',''),
    'phone': ('Tel.',''),
    'language': ('Keel',''),
    'url_to_photo': ('Foto URL',''),
    'country_menu_default': ('Vali riik',''),
    'group_menu_default': ('Vali rhm','Default value for drop-down menu'),
    'address': ('Aadress',''),
    'address1': ('Aadressirida 1',''),
    'address2': ('Aadressirida 2',''),
    'personal_interests': ('Huvialad',''),
    'quote': ('Moto',''),
    'homepage': ('Koduleheklg',''),
    'upload': ('Laadi les',''),
    'group': ('Rhm',''),
    'password': ('Salasna',''),
    'background': ('Taust',''),
    'country': ('Riik',''),
# v1.9:
    'reserved_nickname': ('Vabandame, kuid see nimi/kasutajatunnus on juba kasutusel.', 'Message'),
    'password_mismatch': ("Salasna kordus erines esialgsest.",'Message'),
    'could_not_send_invitation': ('Ei suutnud kutset saata. Kontrolli, kas vljamineva e-posti server (MailHost) on korrektselt mratletud.','Error message'),
    'invitations_sent': ('Kutsed saadetud','Message title'),
    'invitations_sent_to': ('Kutsed saadeti %s. ','Message, email list is inserted into the placeholder.'),
    'users_removed': ('Kasutajad eemaldatud','Message title'),
    'removed_users': ('Eemaldati kasutajad: %s','Message, list inserted inside'),
    'not_removed_users': ('Ei suutnud eemaldada jrgmisi kasutajaid: %s','Message, list inserted inside'),
    're_invitations_sent': ('Korduskutsed saadetud','Message title'),
    're_invitations_sent_to': ('Kordusutsed saadetud to %s kasutajale. ','Message, email count is inserted into the placeholder.'),
    'pending_users_removed': ('Ootel kasutajakandidaadid eemaldatud','Message title'),
    'pending_removed_users': ('Eemaldati ootel kasutajakandidaadid: %s','Message, list inserted inside'),
    'pending_not_removed_users': ('Ei suudetud eemaldada jrgmisi kasutajakandidaate: %s','Message, list inserted inside'),
    'invitation_subject': ('Kutse IVA pikeskkonda','Subject for invitation messages'),
    'invitation_header': ('Kutse','Header for invitation messages'),
    'invitation_footer': ('Palun suuna oma Interneti-brauser aadressile: ','Footer for invitation messages; followed by the URL'),
# v1.15:
    'welcome_message': ('Tere tulemast IVA pikeskkonda. Palun tida kasutaja-ankeet.','Welcome message used in invitation registration form'),
    'uname': ('Kasutaja nimi','Label used in invitation registration form'),
    'registration_failed': ('Registreerumine ebannestus',"Title used when invited user can't register."),
    'invitation_key_used': ("See kutse on aegunud vi juba ra kasutatud. Kui registreerumine ebannestus, vta uue kutse saamiseks hendust oma koolitajaga.",'Message telling that the registration url has been used.'),
    'authorization_failed': ('Autentimine ebannestus - vale vti',"Message telling that the authentication key isn't valid."),
# v1.19:
    'after_submit_give_name_and_passwd': ('Prast <b>Saada</b>-nupul klpsamist sisesta oma kasutajatunnus ja salasna.','Message'),
# v1.21:
    'frozen': ('Klmutatud','User status code'),
# v1.22:
    'no_email': ('E-posti aadress puudub', 'Message title'),
    'no_email_explanation': ("Sa ei saa saata e-posti, kuna sa pole sisestanud oma e-posti aadressi kasutajainfo lehele.", 'Message text'),
    'passwd_changed': ('Salasna muudetud', 'Message title'),
    'passwd_changed_explanation': ('Muutsid oma salasna: su brauser ksib uuesti kasutajatunnust ja salasna.', 'Message text'),
    }

jam = {
    'add_new_jam_session': ('Lisa meediaprojekt', 'link'),
    'jam_sessions': ('Meediaprojektid:', 'a list of jam session will listed after/under this label'),
    'jam_session': ('ttuba', ''),
    'annotations': ('kommentaarid', ''),
    'continue_with_version': ('Lisa oma versioon', 'button label'),
    'artefact': ('fail', ''),
    'viewing_annotations': ('kommentaaride kuvamine', ''),
    'Annotations': ('Kommentaarid:', 'Label, followed by a list of annotations under it'),
    'add_annotation': ('Lisa kommentaar', 'link'),
    'adding_new_jam_session': ('Lisa uus meediaprojekt', ''),
    'title_of_jam_session': ('Meediaprojekti nimi', 'label'),
    'type_of_jam_session': ('Projekti tp', 'label'),
    'mutate_on_previous': ('Eelnevast tuletatud', 'type of jam session'),
    'explore_possibilities': ('Vabas vormis', 'type of jam session'),
    'diverge_and_converge': ('Erista ja henda', 'type of jam session'),
    'description_of_jam_session': ('Meediaprojekti kirjeldus', 'label'),
    'upload_the_starting_artefact': ('Laadi les esimene objekt', 'label'),
    'name_of_the_starting_artefact': ('Esimese objekti nimi', 'label'),
    'annotation_of_the_starting_artefact': ('Kommentaar esimese objekti juurde', 'label'),
    'adding_new_artefact': ('Lisa uus objekt', ''),
    'name_of_the_artefact': ('Objekti nimi', 'label'),
    'upload_file': ('Laadi fail les', 'label'),
    'you_adding_annotation': ('Kommentaari lisamine objektile', 'message in adding annotations form'),
    'adding_annotation': ('kommentaari lisamine', ''),
    'to_jam_session': ('meediaprojektis', 'Part of a message'),
    'to_jam_artefact': ('meediaprojekti objektile', 'Part of a message'),
    'unread_artefacts': ('uut objekti', 'There is a number before this message'),
    'total_artefacts': ('objekti', 'There is a number before this message'),
    'are_you_sure_jam_sessions': ('Kas oled kindel, et soovid kustutada jrgmised projektid:' , 'Message dialog message'),
    'censor_artefact': ('Tsenseeri objekt', 'Button label for censoring jam artefact'),
    'uncensor_artefact': ('Thista tsenseering', 'Button label for uncensoring jam artefact'),
    'censor_annotation': ('Tsenseeri valitud kommentaarid', 'Button label for censoring jam annotations'),
    'uncensor_annotation': ('Thista tsenseeringud', 'Button label for uncensoring jam annotations'),
    'censored_name': ('Tsenseeritud', 'Title/name for censored jam artefact'),
    'censored_message': ('See objekt tsenseeriti %s poolt %s.', "First placeholder is replaced by censorer's name and the second by the date"),
    'censored_msg': ('Objekt on tsenseeritud', 'Message shown when teacher censores an artefact.'),
    'censored_annotation_msg': ('Kommentaar on tsenseeritud', 'Message shown when teacher censores an annotation.'),
    'censor_verify': ('Kas oled kindel, et soovid tsenseerida seda objekti? Sinu nimi kuvatakse kigile kursuslastele tsenseeritud objekti nime krval.','Verification message shown when censoring is attempted'),
    'censor_annotations_verify': ('Kas oled kindel, et soovid tsenseerida seda kommentaari? Sinu nimi kuvatakse kigile kursuslastele tsenseeritud kommnetaari pealkirja krval.','Verification message shown when censoring is attempted'),
    'censored_annotation_body': ('See kommentaar tsenseeriti %s poolt %s.',"Body for censored annotation. First placeholder is replaced by censorer's name and the second by the date"),
    }

ivacommon = {
  #editform.dtml - ZWiki
  'ic_zwiki_change':('Muuda','Button label - change Wiki page'),
  'ic_zwiki_modifiers':('Kes on muutnud','leivapuru'), #05.08
  'ic_zwiki_who_modified':('Kes on seda muutnud','Heading'), #05.08
  'ic_zwiki_nobody_modified':('Keegi pole veel muutnud','Message'), #05.08
  
  #jooksva_kursuse_nimi.dtml
  'ic_no_course_selected':('Kursus valimata',''),
  #kasutajakursused_valik.dtml
  'ic_select_course':('Vali kursus',''),
  'ic_change_course':('Vaheta',''),
  'ic_not_added_to_courses':('Kasutaja pole kursustele registreeritud',''),

  #tootoad_kursusel.dtml #16.02
  'ic_knowledge_building_link':('TeadmusPaja',''),
  'ic_jamming_link':('MeediaPaja',''),
  'ic_wiki_link':('Wiki',''),
  'ic_no_course_selected':('Kursus valimata',''),
  '':('',''),
  '':('',''),

  #Kirjakast.py #28.12
  'ic_nomail':('Kirju pole','Message'),
  'ic_to':('Kellele: ','Field name'),
  'ic_subject':('Pealkiri: ','Field name'),
  'ic_text':('Sisu: ','Field name'),
  'ic_send':('Saada','Button label'),
  'ic_newmail':('Uus kiri','Left menu item'),
  'ic_mailbox':('Kirjakast','Left menu item'),
  'ic_outbox':('Saadetud kirjad','Left menu item'),
  'ic_sender':('Saatja','Table column heading'),
  'ic_title':('Pealkiri','Table column heading'),
  'ic_sentdate':('Saatmisaeg','Table column heading'),
  'ic_select_whom':('Vali adressaadid:','Text before pull-down menu'), #06.01.2004
  'ic_add_name':('Lisa',''), #06.01.2004

  #ui/Note/content.dtml #06.01.2004
  'ic_delete_note':('Kustuta snum','Link label'),
  '':('',''),

  #Course.py #28.12
  'ic_removed':('Kustutatud','Message'),
  'ic_registered':('Registreeritud','Message'),
  'ic_added_to_course':('Oled registreeritud kursusele','Body of mail message'),
  '':('',''),

  #Webtop/index_html.dtml #16.02 - by Mart
  'ic_make_public':('Avalikusta','Button label - Publish object from Drawer to Portfolio'),
  'ic_tocalendar':('Kalendrisse','Button label'), #08.10 Taavi
  'ic_eventmgt':('Sndmuste haldus','Left menu item'), #08.10 Taavi

  'ic_pack':('Paki','Button label'), #28.12
  'ic_loadzip':('Paki lahti','Button label'), #28.12
  'ic_adding_zip':('Zip-faili leslaadimine ja lahtipakkimine','Page heading'),  #28.12
  'ic_unzipped':('Zip-fail on IVA-sse tstetud ja lahti pakitud.','Message'), #28.12
  'ic_upload_zip':('Vali zip-fail','Message before Browse-box'), #28.12
  'ic_advanced':('Laiendatud','Link label'), #28.12
  'ic_search':('Otsi','Link label'), #28.12


  #ui/Webtop/wt_search.dtml #28.12 - by Taavi
  'ic_searching':('Otsing','Title'), #28.12
  'ic_search_title':('Nimi: ','Field name'), #28.12
  'ic_search_owner':('Omanik: ','Field name'), #28.12
  'ic_search_keyword':('Vtmesna: ','Field name'), #28.12
  'ic_cancel':('Katkesta','Button label'), #28.12

  #ui/Webtop/wt_search_results.dtml #28.12 - by Taavi
  'ic_newsearch':('Uus otsing','Link label'), #28.12
  'ic_search_results':('Otsingu tulemuste kuvamine','Title'), #28.12
  'ic_result_type':('Tp:','Column heading'), #28.12
  'ic_result_title':('Nimi:','Column heading'), #28.12
  '':('',''), #28.12
  '':('',''), #28.12
  '':('',''), #28.12    

  #kaustadkursusel.dtml #16.02 - by Mart
  'ic_no_folders':('Kursusel pole htegi kausta','Message - No folders in this course'),
  'ic_course_info':('Kursuse info','Left menu item - Course info'),
      
  
  #tootubade_leht.dtml #16.02 - 14  
  'ic_workshops_1':('pajaleht','Breadcrumbs'),
  '':('',''),
  
  #test_opilane.dtml #16.02
  'ic_test_list':('Testid','Menu header'),

  
  #haldusleht.dtml #16.02
  'ic_management_page':('haldusleht','Breadcrumbs'),
  
  
  #opetaja_menyy.dtml
  'ic_user_management':('Osalejad','Left menu item - User management'),
  'ic_inner_group_management':('Sisegruppide haldus','Left menu item -'),
  'ic_test_management':('Testide haldus','Left menu item -'),
  'ic_course_management':('Kursuste haldus','Left menu item -'),
  'ic_eventmgt':('Sndmuste haldus','Left menu item'), #08.10 Taavi
  'ic_addpending':('Lisa ootajad','Left menu item'), #08.10 Taavi

  'ic_taskmgt':('Kodutde haldus','Left menu item'), #28.12



  #sisegrupi_lisamise_leht.dtml
  'ic_problem_in_adding_inner_group':('Probleem lisamisel','Message'),

  #sisegrupiloetelu.dtml #16.02
  'ic_inner_groups_list':('Sisegrupid',''),


  #sisegrupihaldus.dtml
  'ic_inner_group_management_2':('sisegruppide haldus','Breadcrumbs'), #16.02
  'ic_adding_inner_group':('Loo uus sisegrupp',''),
  'ic_deleting_inner_group':('Kustuta sisegrupp',''),
  'ic_managing_inner_group_users':('Osalejate haldamine',''),
  'ic_list_subgroups':('Kuva sisegrupid','Link label'), #28.12
 
  #sisegrupi_lisamise_vorm.dtml  #16.02
  'ic_name_of_new_group':('Loodava sisegrupi nimi',''),
  'ic_create_new_group':('Loo','Button label'),
  'ic_inner_group_management_3':('sisegruppide haldus','Breadcrumbs'),
  'ic_adding_inner_group_2':('sisegrupi lisamine','Breadcrumbs'),
  
  #sisegrupikustutusvorm.dtml #16.02
  'ic_inner_group_management_4':('sisegruppide haldus','Breadcrumbs'),
  'ic_inner_group_deleting':('kustutamine','Breadcrumbs'),
  'ic_remove_inner_group':('Kustuta','Button label'),
  
  #sisegrupi_osaliste_vorm #16.02
  'ic_inner_group_management_5':('sisegruppide haldus','Breadcrumbs'),
  'ic_inner_group_participants':('osalejad',''),
  'ic_inner_group_other_course_participants':('Muud kursusel osalejad',''),
  'ic_inner_group_participants_in_group':('Liikmed',''),
  'ic_inner_group_change_participants':('Muuda','Button label'),
  '':('',''),
  '':('',''),
  
  #UserManager.py #05.10 Taavi
  'ic_firstname':('Eesnimi','Field name'),
  'ic_lastname':('Perekonnanimi','Field heading'),
  'ic_username':('Kasutajanimi','Field heading'),
  'ic_try':('Proovi','Link label'),
  'ic_register':('Registreeri','Link label'),
  'ic_forward':('Edasi','Link label'),
  'ic_missingdata':('Liiga vhe andmeid','Error message'), 
  'ic_upload':('Lae tekstifailist','Submission button label'),
  'ic_adding_affil':('Kuuluvustunnuse lisamine','Page title'), #07.12.2004
  'ic_import_affil':('Impordi kuuluvustunnused tekstifailist','Subheading'), #07.12.2004
  'ic_course_changed':('Kursusel %s on muutunud','Part of e-mail message'), #07.12.2004
  'ic_e_subject':('Muutused IVA kursustel','Subject row for e-mail notification'), #07.12.2004
  'ic_email_1':('Peale su viimast IVA-kylastust on ajavahemikul','First part of e-mail message'), #07.12.2004
  'ic_email_2':('on IVA kursustel toimunud uuendusi vi muudatusi, nimelt ','Second part of e-mail message'), #07.12.2004

  #tootoad_kursusel.dtml #05.10 Taavi
  'ic_grportfolio':('Rhmade portfooliod','Left menu item'),

  #kasutajaotsing.dtml #05.10 Taavi
  'ic_finduser':('Otsi','Button label'),
  'ic_delete':('Kustuta','Button label'),
  'ic_perm':('Piira','Button label'),
  'ic_perm_on':('Piiratud','UserInfo'),
  'ic_perm_off':('Vaba','UserInfo'),
  'ic_perm_unset':('Puudub','UserInfo'),
  'ic_usermgt':('kasutajate haldamine','Breadcrumbs'),
  'ic_addusers':('Lisa kasutajad','Link label'),
  'ic_addaffiliation':('Lisa eriala','Link label'),
  'ic_savecsv':('Salvesta CSV-na','Link label'),
  'ic_affiliation':('Eriala','Link label'),
  'ic_select_all':('Vali kik','Link label'), #07.01.2004
  
  #veebilauaviited.dtml #05.10 Taavi
  'ic_portfolio':('Portfoolio','Left menu item'),
  'ic_drawer':('Sahtel','Left menu item'),
  'ic_wiki':('Wiki','Menu item'),
  'ic_logpage':('Pevik','Menu item'),

  #paevikuleht.dmtl #05.10 Taavi
  'ic_apply':('Avatud kursused','Menu item'),
  
  #oigustePiiramine.dmtl #22.10 Taavi
  'ic_restrictac':('Keela kuuluvuse vahetamine','Checkbox label'),
  'ic_restrictpc':('Keela parooli muutmine','Checkbox label'),
  'ic_enforcepc':('Sunni paroolivahetus','Checkbox label'),
  'ic_change':('Muuda','Link label'),

  #edit_user_form.dtml #22.10 Taavi
  'ic_browserprefs':('Kasuta brauseri keele-eelistust: ','Link label'),
  'ic_sendtomail':('Saada E-mailile: ','Field name'), #28.12
  'ic_messages':('kirjad','Checkbox label'), #28.12
  'ic_grades':('hinded','Checkbox label'), #28.12
  'ic_changesbookshelf':('muutused Raamaturiiulil','Checkbox label'), #28.12
  'ic_changeskb':('muutused TeadmusPajas','Checkbox label'), #28.12
  'ic_changesjamming':('muutused MeediaPajas','Checkbox label'), #28.12

  #CourseManager.py #05.10 Taavi
  'ic_error':('Probleem','Error message'),
  'ic_nocourse':('Pole kuhugi registreeruda','Message'),
  'ic_added':('Lisatud: ','Listing header'),
  'ic_quote':('Mttetera','Field heading'),
  'ic_logo':('Logo','Field heading'),
  'ic_status':('Staatus','Field heading'),
  'ic_preparation':('Ettevalmistus','Pull-down menu item'),
  'ic_open':('Registreerumiseks avatud','Pull-down menu item'),
  'ic_closed':('Registreerumine mdas','Pull-down menu item'),
  'ic_finished':('Lpetatud','Pull-down menu item'),

  #FLEu.py
  'ic_help':('Abi','Main screen'), #16.02
  #hdr.dtml
  'ic_hdr_drawer':('sahtel','leivapuru osa'),  #16.02 see ja jrgmised 4
  'ic_hdr_portfolio':('portfoolio',''),
  'ic_hdr_context':('raamaturiiul',''),
  'ic_hdr_workshop':('ttoad',''),
  'ic_hdr_management':('haldus',''),
  'ic_hdr_inner_group_name':('sisegrupp',''),

  #kasutajateemataust.dtml #07.04 Jaagup
  'ic_t_webtop':('Veebilaud: individuaalse t vahendid','Picture alt text'),
  'ic_t_context':('Raamaturiiul: petajapoolsed materjalid','Picture alt text'),
  'ic_t_workshop':('Ttoad: Rhmatvahendid','Picture alt text'),
  'ic_t_management':('Haldus: kursuste, kasutajate, testide ja sisegruppide haldamise vahendid','Picture alt text'),
  'ic_t_':('','Picture alt text'),
  'ic_t_':('','Picture alt text'),
  
  #ui/CourseManager/index_html.dtml #05.08
  'ic_add_users':('Kasutajate haldus','Link'),

  #ui/CourseManager/course_info_content.dtml #28.12
  'ic_imail':('Sisekiri kigile osalejatele','Link label'),#28.12
  'ic_archive':('Arhiveeri kursus','Link label'),#28.12  

  #ui/Course/index_html.dtml #16.02
  'ic_kb_1':('TeadmusPaja','leivapuru'),
  'ic_export':('Ekspordi kursus','Link label'), #28.12
  'ic_changestatus':('Muuda staatust','Button label'), #28.12
  
  #ui/Jamming/index_html.dtml #16.02
  'ic_jam_1':('MeediaPaja','leivapuru'),
  
  #standard_wiki_footer.dtml #16.02, muudetud 19.02 Mart
  'ic_change_wiki_page':('Muuda lehte','link'), 
  'ic_add_wiki_comment':('Lisa kommentaar','Button'),
  'ic_wiki_export':('Ekspordi','Link label'),#28.12
  '':('',''),

  #pildid  #kasutajateemataust.dtml hdr.dtml #29.03
  'ic_picture_webtop_1':('webtop1_et','graphical menu button'),
  'ic_picture_webtop_2':('webtop2_et','graphical menu button'),
  'ic_picture_bookshelf_1':('bookshelf1_et','graphical menu button'),
  'ic_picture_bookshelf_2':('bookshelf2_et','graphical menu button'),
  'ic_picture_management_1':('management1_et','graphical menu button'),
  'ic_picture_management_2':('management2_et','graphical menu button'),
  'ic_picture_workshops_1':('workshops1_et','graphical menu button'),
  'ic_picture_workshops_2':('workshops2_et','graphical menu button'),
  '':('',''),
  '':('',''),

  #Cruft.py
  'ic_user_not_found':('Kasutaja puudub','message'), #29.03
  'ic_no_user_data_in_this_course':('kasutaja andmed sellel kursusel puuduvad','message'),
  'ic_no_events_for_user':('Kasutajal pole sndmusi','message to the viewer of event'),

  'ic_info_user_name':('Kasutajanimi','Table column heading'), #01.04
  'ic_info_number_open_pages':('Lehti avatud','Table column heading'),
  'ic_info_added_kb_notes':('Snumeid lisatud','Table column heading'),
  'ic_info_read_kb_notes':('Snumeid loetud','Table column heading'),
  'ic_info_added_jamming_artefacts':('Meediafaile lisatud','Table column heading'),
  'ic_info_test_results':('Testide tulemused','Table column heading'),
  'ic_info_last_access':('Viimane klastus','Table column heading'),
  'ic_info_total_mark':('Koondhinne','Table column heading'),
  'ic_info_comment':('Kommentaar','Table column heading'),
  'ic_info_save':('Salvesta','Button label'),
  'ic_user_adding':('kasutajate lisamine','Leivapuru'), #05.08
  'ic_user_names':('Kasutajate soovitavad nimed','Pealkiri'), #05.08
  'ic_user_create':('Loo','Button label'),#05.08
  
  '':('',''),

  #kylastajateLoetelu (WebtopFolder.py)  #05.04 Mart
  'ic_name':('Nimi','Table column heading'),
  'ic_date':('Kuupev','Table column heading'),  
  'ic_nobody_read':('Keegi pole seda veel vaadanud','Message text'),
  'ic_viewed_by':('Kes on seda vaadanud?','Page heading'),
  'ic_viewers':('vaatajad','Breadcrumbs'),
  
  'ic_mail_to_all':('Saada grupile e-mail', 'Link label'), #07.04 Jaagup
  'ic_course_statistics':('Koondstatistika', 'Link label'),

  'ic_copy1':('koopia', 'part of label'), #28.12 
  'ic_copy2':('koopia', 'part of label'), #28.12



  #UserInfo.py
  'ic_month_jan':('jaanuar', 'Calendar month'),  #15.09.03 Jaagup
  'ic_month_feb':('veebruar', 'Calendar month'),
  'ic_month_mar':('mrts', 'Calendar month'),
  'ic_month_apr':('aprill', 'Calendar month'),
  'ic_month_may':('mai', 'Calendar month'),
  'ic_month_jun':('juuni', 'Calendar month'),
  'ic_month_jul':('juuli', 'Calendar month'),
  'ic_month_aug':('august', 'Calendar month'),
  'ic_month_sep':('september', 'Calendar month'),
  'ic_month_oct':('oktoober', 'Calendar month'),
  'ic_month_nov':('november', 'Calendar month'),
  'ic_month_dec':('detsember', 'Calendar month'),
  'ic_author':('Autor', ''),
  'ic_time':('Aeg', ''),
  'ic_enter_correct':('Sisesta korrektne ', ''),
  'ic_hide':('Peida', 'Button label'), #28.12
  'ic_hiddenevents':('Peidetud sndmused', 'Button label'), #28.12
}

ivatests = {
  #Prefix it - Iva Test
  #YlTest.py
  'it_qt_public':('Avatud','Test status'),
  'it_qt_closed':('Suletud','Test status'),
  'it_qt_between':('Limiidid','Test status'),
  'it_qt_status':('Staatus','Test status button'),
  'it_save_title':('Salvesta testi seaded','Save quiz title'),
  'it_description_of_permissions':('Lubade loetelu','Description of permissions'),
  'it_all_permission':('Kigi juurdeps','All course participants can solve the test'),
  'it_inner_groups_permission':('Gruppide juurdeps','Inner groups which participants can solve test'),
  'it_user_permission':('Isikute juurdeps','Users who have permission to solve test'),
  'it_add_user_permission':('Lisa','Button to add user permission'),
  'it_add_group_permission':('Lisa','Button to add group permission'),
  'it_question':('Ksimus','Question in page creating test'),
  'it_answer':('Vastus',''),
  'it_type':('Tp',''),
  'it_deletion':('Kustuta',''),
  'it_points':('Punktid',''),
  'it_change':('Muutus','Change exercise in test'),
  'it_change_exercise':('muuda','Change exercise in test, label after each exercise'), #16.02
  'it_delete_exercise':('Kustuta',''),
  'it_make_public':('Avalikusta','Make quiz public to solve'),
  'it_hide':('Peida',''),
  'it_add_exercise':('Lisa lesanne',''),
  'it_results_from_users':('Kasutajate lahendused','Show, who and how solved test'),
  'it_import_from_hotpotatoes':('Laadimine HotPotatosest','Import as text file'),
  'it_export_to_web_ct':('Eksport WebCTsse','Export to WebCT as text'),
  'it_solving_test':('Testi %s lahendamine',''),
  'it_save_solved_test':('Salvesta',''),
  'it_answers_saved':('Andmed salvestatud','Test answers saved'),
  'it_answer_instance':('variant',''),
  'it_quiz_responses':('Lahendused','List of users answers'),
  'it_hdr_tests':('testid','Leivapuru osa'),  #16.02
  'it_problem_in_finding_users':('probleem kasutajate leidmisel',''),
  'it_delete_permission':('Kustuta',''),
  'it_an_question':('Ksimus','Question in user answer list page'),
  'it_an_user_answer':('Pakuti',''),
  'it_an_answer_commenting_table':('Kommenteeritav tabel',''),  #16.02
  'it_an_teacher_answer':('petaja lahendus','Teachers right answer'),
  'it_an_result':('Tabamus','Is answer right'),
  'it_an_points':('Punkte',''),
  'it_an_comment':('Kommentaar',''),
  'it_anc_question':('Ksimus','Question in commenting answers page'),
  'it_anc_user_answer':('Pakuti',''),
  'it_anc_teacher_answer':('petaja lahendus','Teacher suggested result'),
  'it_anc_result':('Tabamus','Is answer right'),
  'it_anc_automatic_points':('Automaatpunkte',''),
  'it_anc_teacher_points':('petaja punkte',''),
  'it_anc_nominal_points':('norm', ''),
  'it_anc_teachers_comment':('petaja kommentaar',''),
  'it_anc_point_reading':('Punktiarvutus','Do teacher use this exercise points in test result summary'),
  'it_anc_comment_to_whole_answer':('Kommentaar kogu lahendusele','Teacher comment to all test answer'),
  'it_anc_save':('Salvesta','Save points and comments'),
  'it_no_percent_calculating':('protsendiarvutus puudub','No percent calculating, because no nominal points in this test.'),
  'it_test_answers':('Testi %s vastused',''),
  'it_tests':('testid',''),
  'it_answers':('vastused',''),

  'it_open_test':('Ava','Viide avamaks testi kigile titmiseks'), #29.03
  'it_opened_for_all':('Kigile avatud','message in the list of quizzes'), #29.03
  'it_add_group_permission':('lisa','link label - give quiz solving permission to a group'), #29.03
  'it_add_personal_permission':('lisa','link label - give quiz solving permission to a person'), #29.03
  'it_delete_permission':('kustuta','Button label'),
  'it_no_users_without_permission':('Loata isikud puuduvad','message'), #29.03
  'it_no_groups_without_permission':('Loata grupid puuduvad','message'), #29.03

  'it_click_to_save':('Vastuste salvestamiseks vajuta nuppu <Salvesta vastused>. Mine tagasi eelmisele lehele, kasutades brauseri Back-nuppu','Message text'), #28.12
  'it_type_quiz':('Test','Type of the test, pull-down menu item'), #28.12
  'it_type_selftest':('Harjutus','Type of the test, pull-down menu item'), #28.12
  'it_type_survey':('Ankeet','Type of the test, pull-down menu item'), #28.12
  'it_quiz_title':('Pealkiri','Field name'), #28.12
  'it_quiz_descr':('Kirjeldus','Field name'), #28.12
  'it_quiz_type':('Tp','Field name'), #28.12

  'it_warning_quiz':('Thelepanu! Jtka ainult juhul kui soovid kohe testi hindele sooritada. <br>Testi esimese lahendamise aeg salvestatakse. ','Warning message - you are about to begin the quiz'),  #28.12 
  'it_quiz_started':('Testi esimene lahendamine algas: ','First part of a message'),  #28.12
  'it_begin_quiz':('Alusta lahendamist','Button label'),  #28.12
  'it_quiz_stats':('Lahenduste statistika','Link label'),  #28.12
  'it_selftest_submit':('Salvesta vastus','Button label'),  #28.12
  'it_selftest_end':('Harjutuste lpp','Message'),  #28.12
  'it_selftest_next':('Jtka','Button label'), #28.12
  'it_stat_choice':('Valik','Field label'), #28.12
  'it_stat_count':('Pakutud kordi','Field label'), #28.12
  'it_stat_hits':('Pihtas: ','Field label'), #28.12
  'it_stat_err':('Vigased andmed','Field label'), #28.12
  'it_editing_quiz':('Testi toimetamine','Page heading'), #28.12
  'it_totalpoints':('Punkte kokku: ','Part of message'), #28.12
  'it_grading':('Hinne','Link label'), #28.12
  'it_ca_onclosing':('Prast sulgemist','Pull-down menu item'), #28.12
  'it_ca_always':('Alati','Pull-down menu item'), #28.12
  'it_ca_never':('Mitte kunagi','Pull-down menu item'), #28.12
  'it_ca_visible':('Vastuste nhtavus','Pull-down menu item'), #28.12
  'it_editing_settings':('Testi seadete muutmine','Page heading'), #28.12
  'it_submissions':('Lahendusi: ','Field label'), #28.12
  'it_no_stats':('Statistika puudub','Message'), #28.12
  'it_stat_scored':('Punkte saanud ','Part of a message'), #28.12
  'it_stat_total':(' lahendajat, summaarne punktisumma: ','Part of a message'), #28.12
  'it_stat_notempty':('Sisuga vastuseid: ','Part of a message'), #28.12

  'it_restrictions':('Piirangud','Link label'), #07.01.2004
  'it_notpublic':('Avalikustamata','Button label'),#07.01.2004
  'it_for_all':('Avatud kigile','Button label'),#07.01.2004
  'it_for_subgroups':('Avatud sisegrupiti','Button label'),#07.01.2004
  'it_for_persons':('Avatud ksikisikutele','Button label'),#07.01.2004
  'it_you_answered':('Sina vastasid: ','Message'),#07.01.2004
  'it_feedback':('Tagasiside ','Page heading'),#07.01.2004
  'it_right_answer':('ige vastus oli: ','Message'),#07.01.2004
  'it_excercise':('Harjutus','Page heading'),#07.01.2004

 #kasutajateTulemused - testitulemuste kuvamise leht
  'it_show_comments':('Nita kommentaare','Link label'), #05.04 Mart
  'it_hide_comments':('Peida kommentaarid','Link label'), #05.04 Mart

 #lubadeViited 
  'it_timelimit':('ajapiirang','Link label'), #05.04 Mart 

 #koigiLuba - testi piirangute seadmise vorm
  'it_start_time':('Algusaeg','Table column heading'), #05.04 Mart
  'it_end_time':('Lpuaeg','Table column heading'), #05.04 Mart
  'it_repeat':('Kordused','Table column heading'), #05.04 Mart
  'it_unlimited':('Piiramata','Table column heading'), #05.04 Mart
  'it_save':('Salvesta','Button label'),  #05.04 Mart

  
  '':('',''),
  '':('',''),

  #testihaldus.dtml #19.02 - by Mart
  'it_add_test':('Lisa test','Menu item - Add quiz'),
  'it_tests_bread':('testid','Breadcrumb'),
  'it_test_select':('Vali','Table column heading'), #29.03
  'it_test_id':('ID','Table column heading'), #29.03
  'it_test_name':('Nimi','Table column heading'), #29.03
  'it_test_ready_to_solve':('Avalik','Table column heading'), #29.03
  'it_test_rename':('Seaded','Button label'),
  'it_test_delete':('Kustuta','Button label'),
  'it_test_export':('Eksport','Button label'),
  'it_test_import':('Import','Button label'),

  'it_test_randomized':('Juhujrjestus','Table column heading'), #05.04
  'it_test_submissions':('Lahendused','Table column heading'), #05.04
  'it_test_randomize':('Juhujrjestus','Button label'), #05.04

  'it_test_type':('Tp','Table heading'), #28.12
    
  
  #YlAlus.py
  'it_incorrect_point_count':('Vigane punktide arv','Error message'), 
  'it_ex_question':('Ksimus','Link label'), 
  'it_ex_save':('Salvesta','Button label'),
  '':('',''),
  #'it_no_point_calculating':('Punkte ei arvestata','message'), 
  'it_link_url':('Viite URL','Form item label'), 
  'it_link_text':('Viite tekst','Form item label'), 
  'it_delete_picture':('Kustuta','Form checkbox label'), 
  'it_no_automatic_point_calculating':('Automaatpunkte ei arvestata','message'), 
  'it_nominal_points':('Parimale normtulemusele vastavate punktide arv','message'), 
  'it_no_link_address':('Aadress puudub','Error message'), 
  'it_incorrect_URL':('Vigane URL','Error message'), 

  'it_describing_text':('Kirjeldav tekst', 'Form item label'), #29.03

  'it_picture':('Pilt','Form item label'), #05.04 Mart
  
  #YlTyybid.py 
 # 'it_incorrect_answer':('Sobimatu vastus','message'),
  'it_no_saved_answer':('Vastus salvestamata','message'),
  'it_no_answer_text':('Vastus puudub','message'),
  'it_no_choices':('Valikud puuduvad','message'),
  'it_no_answer':('Lahendus puudub','message'),
  'it_no_choices_in_viewing':('Valikud puuduvad','message'),
  'it_problem_with_data':('Probleem andmetega','message'),
  'it_correct_answers':('iged vastused','message'),
  
  
  #The types of quiz items in the pull-down menu #29.03
  'it_check_exercise':('Ei/jaa lesanne','The type of quiz item in pull-down menu'), 
  'it_text_answer_exercise':('Esseevastusega lesanne','The type of quiz item in pull-down menu'),  
  'it_one_answer':('Lhivastusega lesanne','The type of quiz item in pull-down menu'), #29.03  
  'it_multiple_choice_exercise':('igete vastusevariantide mrkimise lesanne','The type of quiz item in pull-down menu'),
  'it_one_answer_exercise':('Mitmikvalikuga lesanne','The type of quiz item in pull-down menu'), 
  'it_number_space_exercise':('Arvuvahemikvastusega lesanne','The type of quiz item in pull-down menu'), 
  'it_percent_excercise':('Protsentlesanne','The type of quiz item in pull-down menu'), 
  'it_matching_exercise':('Vastavuslesanne','The type of quiz item in pull-down menu'), 
  '':('',''),
  
  #iged variandid #05.08
  'it_ov_variant':('Variant','Table heading'),
  'it_ov_explanation':('Selgitus','Table heading'),
  'it_ov_correct':('ige','Table heading'),
  

  
  #Yksikvalik #05.08
  'it_yv_variants':('Variandid','Table heading'),
  'it_yv_correct':('ige','Table heading'),
  'it_yv_explanation':('Selgitus','Table heading'),
  '':('',''),


  #Numerical item settings, #29.03
  'it_av_min_correct':('Alampiir','Table heading'),  
  'it_av_centre_correct':('ige vastus','Table heading'), 
  'it_av_max_correct':('lempiir','Table heading'), 
  'it_av_checking_type':('Arvutustp','Question before menu options'), 
  'it_av_space':('Vahemik','Menu option. Maximum score if answer falls anywhere within the range'),
  'it_av_linear':('Lineaar','Menu option. Score given depends on distance from exact answer.'),

  #Percent calculation item settings, #29.03
  'it_pr_solvents':('vesi; destilleeritud vesi','List of default solvents, separated with semicolon'), 
  'it_pr_soluble':('sool; suhkur','List of default solubles, separated with semicolon'),
  'it_pr_term_solution_percent':('Lahuse protsent','Text, used in several contexts: Percentage of solution'),
  'it_pr_term_solvent_amount':('Lahusti kogus','Text, used in several contexts: amount of solvent'),
  'it_pr_term_soluble_amount':('Aine kogus','Text, used in several contexts: amount of soluble'),
  'it_pr_term_soluble_to_solvent':('Aine/lahusti','Text, used in several contexts'),
  'it_pr_term_asking_answer':('Ksitav suurus','Comment to solver'),
  'it_pr_soluble_amount_space':('Aine koguse vahemik','Label on the page of entering the question: range'),
  'it_pr_solvent_amount_space':('Lahusti koguse vahemik, hik','Label on the page of entering the question: range'),
  'it_pr_soluble_names':('Ainete nimetused, hik','Label on the page of entering the question: names and units'),
  'it_pr_solvent_names':('Lahusti nimetused, hik','Label on the page of entering the question: names and units'),
  'it_pr_answer_exactitude_percent':('Vastuse tpsuse protsent','Label on the page of entering the question'),
  'it_pr_answer_type':('Vastuse tp','Label on the page of entering the question: searchable'),
  'it_pr_checking_type':('Arvutustp','Question before menu options'),
  'it_pr_space':('Vahemik','Menu option: Maximum score if answer falls anywhere within the range'),
  'it_pr_linear':('Lineaar','Menu option: Score given depends on distance from exact answer'),

  #Vastavuspaarid #05.08
  'it_mt_left':('Vasak','Table heading'),
  'it_mt_right':('Parem','Table heading'),

  #YlVahendus.py 
  'it_send_text':('Saada','Button label'),
  'it_send_file':('Saada','Button label'),
  'it_choosing_exercise_type':('lesannete tbi valimine','Page title'),

  'it_check_exercise_default_question':('Ksimuse tekst','Default question heading'),     #16.02 jj
  'it_text_answer_exercise_default_question':('Ksimuse tekst','Default question heading'),
  'it_one_answer_default_question':('Ksimuse tekst','Default question heading'),
  'it_multiple_choice_exercise_default_question':('Ksimuse tekst','Default question heading'),
  'it_one_answer_exercise_default_question':('Ksimuse tekst','Default question heading'),

  'it_percent_exercise_default_question':('Leia puuduv','Default question heading'), #29.03
  'it_matching_exercise_default_question':('Sobita paarid','Default question heading'),
  'it_number_space_exercise_default_question':('Ksimuse tekst','Default question heading'),
  '':('',''),
  '':('',''),
}

#New module added #07.09 by Taavi

ivaevents = {
  'ie_incomplete':('Lpetamata','Pull-down menu item, incomplete event'),
  'ie_delete':('Kustuta','Submit button label, delete selected events'),
  'ie_complete':('Lpetatud','Pull-down menu item, complete event'),
  'ie_own':('Isiklik','Property of an event, inside of table listing'),
  'ie_name':('Nimi','Field name - Name of event'),
  'ie_teaser':('Lhikirjeldus','Field name - Short description of event'),
  'ie_body':('Pikk kirjeldus','Field name - Full description of event'),
  'ie_starttime':('Algusaeg','Field name - Starting time of event'),
  'ie_endtime':('Lpp','Field name - Ending time of event'),
  'ie_link':('Viide','Field name - Link label'),
  'ie_attached':('Manus','Field name - Attachment'),
  'ie_status':('Staatus','Field name - Status'),
  'ie_change':('Muuda','Link label - Change event'),
  'ie_save':('Salvesta','Button label - Save event description'),
  'ie_addevent':('Lisa sndmus','Link label'),
  '':('',''),
  '':('',''),
}

#New module added #28.12 by Mart

ivatasks = {

#Kodutoo.py 
  'ia_addtask':('Lisa kodut','Link label'),
  'ia_grading':('Hinda kodutid','Link label'),
  'ia_title':('Pealkiri','Table column heading'),
  'ia_type':('Tp','Table column heading, also field label'),
  'ia_points':('Punkte','Table column heading'),
  'ia_total':('Punkte kokku:','Field label'),
  'ia_delete':('Kustuta','Button label'),
  'ia_grade_labels':('Hinne','Table column heading'),
  'ia_grade_percent':('Alampiir %','Table column heading'),
  'ia_submit':('Salvesta','Button label'),
  'ia_add':('Lisa','Button label'),
  'ia_quiz':('Test','Pull-down menu item'),
  'ia_product':('Materjal','Pull-down menu item'),
  'ia_grpwork':('Rhmat','Pull-down menu item'),
  'ia_presentn':('Esitlus','Pull-down menu item'),
  'ia_select_quiz':('Vali test','Default option in pull-down menu'),
  'ia_descr':('Kirjeldus','Field label'),
  'ia_deadline':('Thtaeg','Field label'),
  'ia_edit':('Muuda','Button label'),
  'ia_editing_task':('Kodut seadete muutmine','Page heading'),
  'ia_adding_task':('Kodut lisamine','Page heading'),
  'ia_groups':('Rhmad','Field label'),
  'ia_result':('Tulemus','Table column header'),


  'ia_noscale':('Skaala puudub','Error message - grading scale is missing'),
  'ia_nogrades':('Hinded puuduvad','Error message - grades are missing'),
  'ia_failed':('Puudulik','Error message - grade below satisfactory'),

  'ia_task':('Kodut','Title'),#07.01.2004
  'ia_deadline_updated':('Thtaeg uudeti: ','Message'), #07.01.2004
  'ia_no_deadline':('Puudub','Message'),#07.01.2004
  'ia_task_added':('Lisatud uus kodut','Message'), #07.01.2004


#Course.py
  'ia_total_grade':('Hinne','Table column heading'),
  'ia_no_folder':('Pole kausta','Error message within the table'),
  'ia_gradetable':('Hinnete koondtabel','Page heading'),
  'ia_comment':('Kommentaar','Table column heading'),
  'ia_scale':('Skaala','Table column heading'),
  'ia_view':('Vaata','Link label'),
  'ia_maxpoints':('Norm: ','Field label'),
  'ia_none':('puudub','Message'), #07.01.2004
  'ia_savecsv':('Salvesta CSV-na','Link label'), #07.01.2004
  'ia_email_grades':('Saada hinded e-postiga','Checkbox label'), #07.01.2004
  'ia_grademail_subject':('Hinne IVA-kursusel on vlja pandud','Subject of e-mail message with grade'), #07.01.2004
  'ia_grademail_body1':('Oled saanud kursusel ','Part of e-mail message with grade'), #07.01.2004
  'ia_grademail_body2':('hindeks: ','Part of e-mail message with grade'), #07.01.2004

#WebtopFolder.py #07.01.2004
  'ia_edit_deadline':('Selle kausta sisu saab muuta kuni: ','Part of a message - Allowed to edit until:'),

#UserInfo.py #07.01.2004
  'ia_tasks':('Kodutd','Folder name'),
}

# All vocabularies combined
vocabulary = {'common': common,
              'kb': kb,
              'webtop': webtop,
              'usermgmnt': usermgmnt,
              'coursemgmnt': coursemgmnt,
              'jam': jam,
              'ivacommon': ivacommon,
              'ivatests': ivatests,
              'ivaevents': ivaevents, #07.09
		  'ivatasks': ivatasks, #28.12
              }
              
#print vocabulary['ivacommon']['ic_change_wiki_page']

#EOF
